#ifndef __D_INPUT_H__
#define __D_INPUT_H__

#define DIRECTINPUT_VERSION	0x0800
#define BUFFER_SIZE			16
#define AXIS_RANGE			10

#include <dinput.h>

#pragma comment(lib,"dinput8.lib")

typedef struct{
	bool	left;	// ifalse:ĂȂAtrue:Ăj
	bool	right;	// E
	bool	up;		// 
	bool	down;	// 
	bool	space;	// SPACE L[
	bool	enter;	// Enter L[
	bool	esc;	// ESC L[
	bool	c;		// C L[
	bool	h;		// H L[
	bool	x;		// X L[
	bool	z;		// Z L[
}KEYSTATE,*LPKEYSTATE;

KEYSTATE	g_key[3];		// L[̏ԁi0:݂̏ԁA1:ꂽuԂ̂݁A2:Aj

LPDIRECTINPUT8			g_pDI;
LPDIRECTINPUTDEVICE8	g_pDIDevice;

BOOL 			DI_Init(HWND hWnd);
BOOL CALLBACK	EnumJoysticksCallback(const DIDEVICEINSTANCE* pdidInst, VOID* pContext);
int CALLBACK	EnumAxesCallback(const DIDEVICEOBJECTINSTANCE* pdidoi, VOID* pContext);
HRESULT			Get_Joy();
void			DI_Term();

BOOL DI_Init(HWND hWnd)
{
	HRESULT hr;
	
	hr = DirectInput8Create(GetModuleHandle(NULL), DIRECTINPUT_VERSION,
							IID_IDirectInput8, (void**) &g_pDI, NULL);
	if FAILED(hr) return FALSE;
	
	hr = g_pDI->EnumDevices(DI8DEVCLASS_GAMECTRL, EnumJoysticksCallback, NULL,
							DIEDFL_ATTACHEDONLY);
	if FAILED(hr) return FALSE;
	
	if(g_pDIDevice == NULL) return FALSE;
	
	hr = g_pDIDevice->SetDataFormat(&c_dfDIJoystick2);
	if FAILED(hr) return FALSE;
	
	hr = g_pDIDevice->SetCooperativeLevel(hWnd, DISCL_EXCLUSIVE | DISCL_FOREGROUND);
	if FAILED(hr) return FALSE;
	
	hr = g_pDIDevice->EnumObjects(EnumAxesCallback, (VOID*)hWnd, DIDFT_AXIS);
	if FAILED(hr) return FALSE;
	
	DIPROPDWORD dipdw;
	dipdw.diph.dwSize		= sizeof(DIPROPDWORD);
	dipdw.diph.dwHeaderSize	= sizeof(DIPROPHEADER);
	dipdw.diph.dwObj		= 0;
	dipdw.diph.dwHow		= DIPH_DEVICE;
	dipdw.dwData			= BUFFER_SIZE;
	hr = g_pDIDevice->SetProperty(DIPROP_BUFFERSIZE, &dipdw.diph);
	if FAILED(hr) return FALSE;
	
	return TRUE;
}// DI_Init

BOOL CALLBACK EnumJoysticksCallback(const DIDEVICEINSTANCE* pdidInst, VOID* pContext)
{
	if(!g_pDI || !pdidInst){
		return DIENUM_STOP;
	}
	
	HRESULT hr;
	
	// 񋓂ꂽWCXeBbNւ̃C^[tFCX擾B
	hr = g_pDI->CreateDevice(pdidInst->guidInstance, &g_pDIDevice, NULL);
	if(FAILED(hr)) return DIENUM_CONTINUE;
	
	return DIENUM_STOP;
}// EnumJoysticksCallback

int CALLBACK EnumAxesCallback(const DIDEVICEOBJECTINSTANCE* pdidoi, VOID* pContext)
{
	if(!g_pDIDevice || !pdidoi){
		return DIENUM_STOP;
	}
	
	DIPROPRANGE diprg;
	diprg.diph.dwSize		= sizeof(DIPROPRANGE);
	diprg.diph.dwHeaderSize	= sizeof(DIPROPHEADER);
	diprg.diph.dwHow		= DIPH_BYID;
	diprg.diph.dwObj		= pdidoi->dwType; // Specify the enumerated axis
	diprg.lMin				= -AXIS_RANGE;
	diprg.lMax				= +AXIS_RANGE;
	g_pDIDevice->SetProperty(DIPROP_RANGE, &diprg.diph);
	
	return DIENUM_CONTINUE;
}// EnumAxesCallback

HRESULT Set_JoyState()
{
	if(!g_pDIDevice){
		return DIERR_GENERIC;
	}
	
	HRESULT		hr;
	DIJOYSTATE2	dijs;
	
	// WCXeBbNԎ擾
	
	hr = g_pDIDevice->Poll(); 
	if (FAILED(hr)){
		hr = g_pDIDevice->Acquire();
		while(hr == DIERR_INPUTLOST)
			g_pDIDevice->Acquire();
	}
	
	// ڃf[^擾
	
	hr = g_pDIDevice->GetDeviceState(sizeof(DIJOYSTATE2), &dijs);
	if (hr == DI_OK){
		if (dijs.rgbButtons[0] & 0x80){	// [1] {^ꂽ
		}
		else{
		}
		if (dijs.rgbButtons[1] & 0x80){	// [2] {^ꂽ
		}
		else{
		}
		if (dijs.rgbButtons[2] & 0x80){	// [3] {^ꂽ
			g_key[0].esc = true;
		}
		else{
			g_key[0].esc = false;
		}
		if (dijs.rgbButtons[3] & 0x80){	// [4] {^ꂽ
			g_key[0].space = true;
		}
		else{
			g_key[0].space = false;
		}
		if (dijs.rgbButtons[4] & 0x80){	// [5] {^ꂽ
		}
		else{
		}
		if (dijs.rgbButtons[5] & 0x80){	// [6] {^ꂽ
		}
		else{
		}
		if (dijs.rgbButtons[6] & 0x80){	// [7] {^ꂽ
		}
		else{
		}
		if (dijs.rgbButtons[7] & 0x80){	// [8] {^ꂽ
		}
		else{
		}
		if (dijs.lX == -AXIS_RANGE){	// [] ꂽ
			g_key[0].left = true;
		}
		else{
			g_key[0].left = false;
		}
		if (dijs.lX == AXIS_RANGE){	// [] ꂽ
			g_key[0].right = true;
		}
		else{
			g_key[0].right = false;
		}
		if (dijs.lY == -AXIS_RANGE){	// [] ꂽ
			g_key[0].up = true;
		}
		else{
			g_key[0].up = false;
		}
		if (dijs.lY == AXIS_RANGE){	// [] ꂽ
			g_key[0].down = true;
		}
		else{
			g_key[0].down = false;
		}
	} 
	else if (hr == DIERR_INPUTLOST) {
		g_pDIDevice->Acquire();
	}
	
	// obt@Of[^擾
	
	DIDEVICEOBJECTDATA	rgdod[BUFFER_SIZE];
    DWORD				dwItems = BUFFER_SIZE;
	
	hr = g_pDIDevice->GetDeviceData(sizeof(DIDEVICEOBJECTDATA), rgdod, &dwItems, 0);
	if (hr == DI_OK || hr == DI_BUFFEROVERFLOW){
		for(DWORD i=0; i<dwItems; i++){
			switch (rgdod[i].dwOfs)
			{
			case DIJOFS_BUTTON0:	// [1] {^
				if(rgdod[i].dwData & 0x80){
				}
				else{
				}
				break;
			case DIJOFS_BUTTON1:	// [2] {^
				if(rgdod[i].dwData & 0x80){
				}
				else{
				}
				break;
			case DIJOFS_BUTTON2:	// [3] {^
				if(rgdod[i].dwData & 0x80){
					g_key[1].esc = true;
				}
				else{
					g_key[1].esc = false;
				}
				break;
			case DIJOFS_BUTTON3:	// [4] {^
				if(rgdod[i].dwData & 0x80){
					g_key[1].space = true;
				}
				else{
					g_key[1].space = false;
				}
				break;
			case DIJOFS_BUTTON4:	// [5] {^
				if(rgdod[i].dwData & 0x80){
				}
				else{
				}
				break;
			case DIJOFS_BUTTON5:	// [6] {^
				if(rgdod[i].dwData & 0x80){
				}
				else{
				}
				break;
			case DIJOFS_BUTTON6:	// [7] {^
				if(rgdod[i].dwData & 0x80){
				}
				else{
				}
				break;
			case DIJOFS_BUTTON7:	// [8] {^
				if(rgdod[i].dwData & 0x80){
				}
				else{
				}
				break;
			case DIJOFS_X:
				if(rgdod[i].dwData == (DWORD) -AXIS_RANGE){	// [] ꂽ
					g_key[1].left = true;
				}
				else{
					g_key[1].left = false;
				}
				if(rgdod[i].dwData == (DWORD) AXIS_RANGE){	// [] ꂽ
					g_key[1].right = true;
				}
				else{
					g_key[1].right = false;
				}
				break;
			case DIJOFS_Y:
				if(rgdod[i].dwData == (DWORD) -AXIS_RANGE){	// [] ꂽ
					g_key[1].up = true;
				}
				else{
					g_key[1].up = false;
				}
				if(rgdod[i].dwData == (DWORD) AXIS_RANGE){	// [] ꂽ
					g_key[1].down = true;
				}
				else{
					g_key[1].down = false;
				}
				break;
			}
		}
	}
	
	return hr;
}// Set_JoyState

void DI_Term()
{
	if (g_pDIDevice){
		// Release() ĂяoO͏ɃfoCXB
		g_pDIDevice->Unacquire();
	}
	RELEASE(g_pDIDevice);
	RELEASE(g_pDI);
}// DI_Term

#endif
