#ifndef __DIBALP2_H__
#define __DIBALP2_H__

#include "dib_buf2.h"
#include "dib_alpha.h"
#include "rpgLoadBmpCode.h"

void DIB2_DrawAlpha(CDib* dst, int dst_x, int dst_y, CDib2* src, int src_x, int src_y,
					int width, int height, int alpha);
void DIB2_Draw(CDib* dst, int dst_x, int dst_y, CDib2* src, int src_x, int src_y,
				int width, int height);
void DIB2_Draw(CDib* dst, int dst_x, int dst_y, CDib2* src, int src_x, int src_y,
				int width, int height, BYTE red, BYTE green, BYTE blue);
void DIB2_DrawAddAlpha(CDib2* dst, int dst_x, int dst_y, CDib2* src, int src_x, int src_y,
						int width, int height, int alpha);
bool DIB2_ReLoadFile(CDib2* dib, int dst_x, int dst_y, char *file_name,
					int src_x, int src_y, int width, int height);
void DIB2_AlterMonotone(CDib2* dib, int x, int y, int width, int height);
void DIB2_AlterHue(CDib2* dib, int x, int y, int width, int height, int hue);
RECT DIB2_Clip(int *dst_x, int *dst_y, int src_x, int src_y, int width, int height,
				int wdhSrc, int hgtSrc, int wdhDst, int hgtDst);
RECT DIB2_Clip(CDib2* dst, int *dst_x, int *dst_y, CDib2* src, int src_x, int src_y,
				int width, int height);
RECT DIB2_Clip(int x, int y, int width, int height, int wdhDib, int hgtDib);
void DIB2_DrawFont(CDib2* dst, char *str, int size, int x, int y, COLORREF rgb);

// 32 bit x DIB ̓xw`
// dst			: [IN][OUT]	Rs[DIB
// dst_x, dst_y	: [IN]		Rs[W
// src			: [IN]		Rs[DIB
// src_x, src_y	: [IN]		Rs[W
// width, height: [IN]		Rs[`̕ƍ
// alpha		: [IN]		Ŝ̓xi0 - 255j
void DIB2_DrawAlpha(CDib* dst, int dst_x, int dst_y, CDib2* src, int src_x, int src_y,
					int width, int height, int alpha)
{
	if (!dst || !dst->GetHDC() || !src || !src->GetHBmp()) return;
	
	if(alpha < 0)	alpha = 0;
	if(alpha > 255)	alpha = 255;
	
	if(alpha == 0){
		return;
	}
	
	HDC		hDC = dst->GetHDC();
	HDC 	hdcCp;
	HBITMAP	hbmpPre;
	BLENDFUNCTION bf;
	bf.BlendOp = AC_SRC_OVER;
	bf.BlendFlags = 0;
	bf.SourceConstantAlpha = alpha;
	bf.AlphaFormat = 0x01;
	hdcCp = CreateCompatibleDC(hDC);
	if(hdcCp){
		hbmpPre = (HBITMAP) SelectObject(hdcCp, src->GetHBmp());
		AlphaBlend(hDC, dst_x, dst_y, width, height, hdcCp, src_x, src_y, width, height, bf);
		SelectObject(hdcCp, hbmpPre);
		DeleteDC(hdcCp);
	}
}// DIB2_DrawAlpha

// 32 bit DIB ̕`
// dst			: [IN][OUT]	Rs[DIB
// dst_x, dst_y	: [IN]		Rs[W
// src			: [IN]		Rs[DIB
// src_x, src_y	: [IN]		Rs[W
// width, height: [IN]		Rs[`̕ƍ
void DIB2_Draw(CDib* dst, int dst_x, int dst_y, CDib2* src, int src_x, int src_y,
				int width, int height)
{
	if (!dst || !dst->GetHDC() || !src || !src->GetHBmp()) return;
	
	HDC		hDC = dst->GetHDC();
	HDC 	hdcCp;
	HBITMAP	hbmpPre;
	hdcCp = CreateCompatibleDC(hDC);
	if(hdcCp){
		hbmpPre = (HBITMAP) SelectObject(hdcCp, src->GetHBmp());
		BitBlt(hDC, dst_x, dst_y, width, height, hdcCp, src_x, src_y, SRCCOPY);
		SelectObject(hdcCp, hbmpPre);
		DeleteDC(hdcCp);
	}
}// DIB2_Draw

// 32 bit DIB ̔F`
// dst				: [IN][OUT]	Rs[DIB
// dst_x, dst_y		: [IN]		Rs[W
// src				: [IN]		Rs[DIB
// src_x, src_y		: [IN]		Rs[W
// width, height	: [IN]		Rs[`̕ƍ
// red,green,blue	: [IN]		J[L[ieX 0 - 255j
void DIB2_Draw(CDib* dst, int dst_x, int dst_y, CDib2* src, int src_x, int src_y,
				int width, int height, BYTE red, BYTE green, BYTE blue)
{
	if (!dst || !dst->GetHDC() || !src || !src->GetHBmp()) return;
	
	HDC		hDC = dst->GetHDC();
	HDC 	hdcCp;
	HBITMAP	hbmpPre;
	hdcCp = CreateCompatibleDC(hDC);
	if(hdcCp){
		hbmpPre = (HBITMAP) SelectObject(hdcCp, src->GetHBmp());
		TransparentBlt(hDC, dst_x, dst_y, width, height,
						hdcCp, src_x, src_y, width, height, RGB(red, green, blue));
		SelectObject(hdcCp, hbmpPre);
		DeleteDC(hdcCp);
	}
}// DIB2_Draw

// 32 bit DIB ̉Z`
// dst			: [IN][OUT]	Rs[DIB
// dst_x, dst_y	: [IN]		Rs[W
// src			: [IN]		Rs[DIB
// src_x, src_y	: [IN]		Rs[W
// width, height: [IN]		Rs[`̕ƍ
// alpha		: [IN]		Ŝ̓xi0 - 255j
void DIB2_DrawAddAlpha(CDib2* dst, int dst_x, int dst_y, CDib2* src, int src_x, int src_y,
						int width, int height, int alpha)
{
	if (!dst || !dst->GetHBmp() || !src || !src->GetHBmp()) return;
	
	if(alpha < 0)	alpha = 0;
	if(alpha > 255)	alpha = 255;
	
	if(alpha == 0){
		return;
	}
	
	int	wdhSrc = src->GetWidth();
	int	hgtSrc = src->GetHeight();
	int	wdhDst = dst->GetWidth();
	int	hgtDst = dst->GetHeight();
	
	RECT rc = DIB2_Clip(&dst_x, &dst_y, src_x, src_y, width, height,
						wdhSrc, hgtSrc, wdhDst, hgtDst);
	
	int		sum_r, sum_g, sum_b;
	float	alpha2 = (float) alpha / 255;
	DWORD	ba;
	BYTE	br, bg, bb, sr, sg, sb;
	PDWORD	ps = src->GetPBits();
	PDWORD	pb = dst->GetPBits();
	
	for (int i = rc.top; i < rc.bottom; i++) {
		PDWORD	ps = src->GetPBits() + i * wdhSrc + rc.left;
		PDWORD	pb = dst->GetPBits() + (i + dst_y) * wdhDst + rc.left + dst_x;
		for (int j = rc.left; j < rc.right; j++) {
			ba = *pb & 0xff000000;
			br = (BYTE)(*pb >> 16);
			bg = (BYTE)(*pb >> 8);
			bb = (BYTE) *pb;
			sr = (BYTE)(*ps >> 16);
			sg = (BYTE)(*ps >> 8);
			sb = (BYTE) *ps;
			sum_r = br + (int)(sr * alpha2);
			sum_g = bg + (int)(sg * alpha2);
			sum_b = bb + (int)(sb * alpha2);
			if(sum_r > 255)	sum_r = 255;
			if(sum_g > 255)	sum_g = 255;
			if(sum_b > 255)	sum_b = 255;
			*pb = ba | (sum_r << 16) | (sum_g << 8) | sum_b;
			ps ++;
			pb ++;
		}
	}
}// DIB2_DrawAddAlpha

// rbg}bvēǂݍ݊֐
// dib				: [IN][OUT]	ΏDIB
// dst_x, dst_y		: [IN]		Rs[W
// file_name		: [IN]		t@C
// src_x, src_y		: [IN]		Rs[W
// width, height	: [IN]		Rs[`̕ƍ
bool DIB2_ReLoadFile(CDib2* dib, int dst_x, int dst_y, char *file_name,
					int src_x, int src_y, int width, int height)
{
	if ( !dib || dib->GetHBmp() == NULL ) return false;
	
	HBITMAP hBmp;
	BITMAP  bmp;
	
	hBmp = Load_BMP(file_name);
    if (hBmp == NULL) return false;
	
    GetObject(hBmp, sizeof(bmp), &bmp);
	
	HDC     hdcCp1,hdcCp2;
	HBITMAP hbmOld1,hbmOld2;
	
	hdcCp1 = CreateCompatibleDC(NULL);
	hdcCp2 = CreateCompatibleDC(NULL);
	hbmOld1 = (HBITMAP)SelectObject(hdcCp1, dib->GetHBmp());
    hbmOld2 = (HBITMAP)SelectObject(hdcCp2, hBmp);
	
	BitBlt(hdcCp1, dst_x, dst_y, width, height, hdcCp2, src_x, src_y, SRCCOPY);
	
	SelectObject(hdcCp1, hbmOld1);
	SelectObject(hdcCp2, hbmOld2);
	DeleteDC(hdcCp1);
	DeleteDC(hdcCp2);
	DeleteObject(hBmp);
	
	return true;
}// DIB2_ReLoadFile

// OCXP[ϊ
// dib			: [IN][OUT]	ϊΏۂDIB
// x, y			: [IN]		`̍W
// width, height: [IN]		`̕ƍ
void DIB2_AlterMonotone(CDib2* dib, int x, int y, int width, int height)
{
	if (!dib || !dib->GetHBmp()) return;
	
	int width2  = dib->GetWidth();
	int height2 = dib->GetHeight();
	
	RECT rc = DIB2_Clip(x, y, width, height, width2, height2);
	
	DWORD	a;
	BYTE	r, g, b;
	
	for (int i = rc.top; i < rc.bottom; i++) {
		PDWORD	pb = dib->GetPBits() + i * width2 + rc.left;
		for (int j = rc.left; j < rc.right; j++) {
			a = *pb & 0xff000000;
			r = (BYTE)(*pb >> 16);
			g = (BYTE)(*pb >> 8);
			b = (BYTE) *pb;
			double	luminance =	(r * 0.299) +
								(g * 0.587) +
								(b * 0.114) + 0.5;
			
			r = g = b = (BYTE) luminance;
			
			*pb = a | (r << 16) | (g << 8) | b;
			pb ++;
		}
	}
}// DIB2_AlterMonotone

// Fϊ
// dib			: [IN][OUT]	ϊΏۂDIB
// x, y			: [IN]		`̍W
// width, height: [IN]		`̕ƍ
// hue			: [IN]		F[g 0 - 192i32F, 96F, 144Fj
void DIB2_AlterHue(CDib2* dib, int x, int y, int width, int height, int hue)
{
	if ( !dib ) return;
	
	if (hue > 192) hue = 192;
	else if (hue <  0) hue = 0;
	int hue2 = 64 - hue;
	int hue3 = hue - 64;
	int hue4 = 128 - hue;
	int hue5 = hue - 128;
	int hue6 = 192 - hue;
	
	int width2  = dib->GetWidth();
	int height2 = dib->GetHeight();
	
	RECT rc = DIB2_Clip(x, y, width, height, width2, height2);
	
	DWORD	a;
	BYTE	r, g, b;
	WORD	fr1,fr2,fg1,fg2,fb1,fb2;
	
	for (int i = rc.top; i < rc.bottom; i++) {
		PDWORD	pb = dib->GetPBits() + i * width2 + rc.left;
		for (int j = rc.left; j < rc.right; j++) {
			a = *pb & 0xff000000;
			r = (BYTE)(*pb >> 16);
			g = (BYTE)(*pb >> 8);
			b = (BYTE) *pb;
			if(hue >= 0 && hue <= 64){
				fr1 = (WORD)(r * hue) >> 6;	// >> 6  / 64 ̂
				fr2 = (WORD)(r * hue2) >> 6;
				fg1 = (WORD)(g * hue) >> 6;
				fg2 = (WORD)(g * hue2) >> 6;
				fb1 = (WORD)(b * hue) >> 6;
				fb2 = (WORD)(b * hue2) >> 6;
			}
			else if(hue > 64 && hue <= 128){
				fr1 = (WORD)(b * hue3) >> 6;
				fr2 = (WORD)(b * hue4) >> 6;
				fg1 = (WORD)(r * hue3) >> 6;
				fg2 = (WORD)(r * hue4) >> 6;
				fb1 = (WORD)(g * hue3) >> 6;
				fb2 = (WORD)(g * hue4) >> 6;
			}
			else if(hue > 128 && hue <= 192){
				fr1 = (WORD)(g * hue5) >> 6;
				fr2 = (WORD)(g * hue6) >> 6;
				fg1 = (WORD)(b * hue5) >> 6;
				fg2 = (WORD)(b * hue6) >> 6;
				fb1 = (WORD)(r * hue5) >> 6;
				fb2 = (WORD)(r * hue6) >> 6;
			}
			r = (BYTE)(fr2 + fb1);
			g = (BYTE)(fg2 + fr1);
			b = (BYTE)(fb2 + fg1);
			
			*pb = a | (r << 16) | (g << 8) | b;
			
			pb ++;
		}
	}
}// DIB2_AlterHue

// `̗L͈͂擾
// dst_x, dst_y		: [IN]	Rs[W
// src_x, src_y		: [IN]	Rs[W
// width, height	: [IN]	Rs[`̕ƍ
// wdhSrc, hgtSrc	: [IN]	Rs[DIB̕ƍ
// wdhDst, hgtDst	: [IN]	Rs[DIB̕ƍ
// ߂l			:		`̗L͈
RECT DIB2_Clip(int *dst_x, int *dst_y, int src_x, int src_y, int width, int height,
				int wdhSrc, int hgtSrc, int wdhDst, int hgtDst)
{
	RECT	rc = {src_x, src_y, src_x + width, src_y + height};
	if(rc.left < 0)			rc.left   = 0;
	if(rc.top < 0)			rc.top    = 0;
	if(rc.right > wdhSrc)	rc.right  = wdhSrc;
	if(rc.bottom > hgtSrc)	rc.bottom = hgtSrc;
	if(rc.right <= rc.left)	rc.right  = wdhSrc;
	if(rc.bottom <= rc.top)	rc.bottom = hgtSrc;
	if(*dst_x < 0)			*dst_x = 0;
	if(*dst_y < 0)			*dst_y = 0;
	if(*dst_x > wdhDst - (rc.right - rc.left))
		*dst_x = wdhDst - (rc.right - rc.left);
	if(*dst_y > hgtDst - (rc.bottom - rc.top))
		*dst_y = hgtDst - (rc.bottom - rc.top);
	if(*dst_x < 0){
		*dst_x = 0;
		rc.right = wdhDst + rc.left;
	}
	if(*dst_y < 0){
		*dst_y = 0;
		rc.bottom = hgtDst + rc.top;
	}
	
	return rc;
}// DIB2_Clip

// `̗L͈͂擾
// dst_x, dst_y		: [IN]	Rs[W
// src_x, src_y		: [IN]	Rs[W
// width, height	: [IN]	Rs[`̕ƍ
// wdhDib, hgtDib	: [IN]	DIB̕ƍ
// ߂l			:		`̗L͈
RECT DIB2_Clip(int x, int y, int width, int height, int wdhDib, int hgtDib)
{
	RECT	rc = {x, y, x + width, y + height};
	
	if(rc.left < 0)			rc.left		= 0;
	if(rc.top < 0)			rc.top		= 0;
	if(rc.right > width)	rc.right	= wdhDib;
	if(rc.bottom > height)	rc.bottom	= hgtDib;
	if(rc.right <= rc.left)	rc.right	= wdhDib;
	if(rc.bottom <= rc.top)	rc.bottom	= hgtDib;
	
	return rc;
}// DIB2_Clip

// ̕`
void DIB2_DrawFont(CDib2* dst, char *str, int size, int x, int y, COLORREF rgb)
{
	if (!dst || !dst->GetHBmp()) return;
	
	HDC     hdcCp;
	HBITMAP hbmOld;
	HFONT	NewFont,OldFont;
	
	glFont.lfHeight	= size;
	
	hdcCp = CreateCompatibleDC(NULL);
	hbmOld = (HBITMAP)SelectObject(hdcCp, dst->GetHBmp());
	NewFont = CreateFontIndirect(&glFont);
	OldFont = (HFONT)SelectObject(hdcCp, NewFont);
	
	SetBkMode(hdcCp, TRANSPARENT);
	SetTextColor(hdcCp, rgb);
	TextOut(hdcCp, x, y, str, strlen(str));
	
	SelectObject(hdcCp, hbmOld);
	DeleteDC(hdcCp);
	SelectObject(hdcCp, OldFont);
	DeleteObject(NewFont);
	DeleteDC(hdcCp);
}// DIB_DrawFont2

#endif
