#include "win_main.h"
#include "d_music.h"
#include "d_input.h"
#include "rpgKey.h"
#include "dib_alpha2.h"
#include "rpgUtil.h"
#include "cmpcode.h"
#include "rpgLoadMusicCode.h"
#include "rpgFileTxt.h"
#include "rpgFileBin.h"
#include "rpgFile.h"
#include "rpgBin.h"
#include "rpgDrawEvent.h"
#include "rpgDrawChara.h"
#include "win_pop.h"
#include "game.h"

#pragma comment(lib, "cmpcode.lib")

#define LAST_FLAG		14		// Ō̃tOԍ

CDib	*BackBuffer = NULL;		// obNobt@
int		*g_monster_probability = NULL;	// Gjbg̏o
int		g_nTiming[SLOWEST_SPEED + 1];

void	Param_Init();
void	Pc_Init();
void	Set_EventStopFlag(bool *flag_stop);
bool	Can_Event(int idxFlag, bool *flag_stop);
int		Get_Enemies_Index(int idxEnemy);

// Q[
void GameInit(void)
{
	HWND hWnd = GetSysHwnd();
	// CEBhEʒSֈړ
	int		widthDT		= GetSystemMetrics(SM_CXSCREEN);
	int		heightDT	= GetSystemMetrics(SM_CYSCREEN);
	RECT	rc;
	GetWindowRect(hWnd, &rc);
	int		width = rc.right - rc.left;
	int		height = rc.bottom - rc.top;
	int		x = (widthDT - width) / 2;
	int		y = (heightDT - height) / 2;
	MoveWindow(hWnd, x, y, width, height, FALSE);
	// ϐ̏
	GameRelease();
	// JgfBNg̐ݒ
	char path[MAX_PATH];
	GetModuleFileName(NULL, path, sizeof(path));
	char *p = strrchr(path, '\\');
	if(p){
		strcpy(p,"");
	}
	SetCurrentDirectory(path);
	// f[^ǂݍݏݒ̓ǂݍ
	if(!Load_Prepare()){
		SendMessage(hWnd, WM_CLOSE, 0, 0);
		return;
	}
	// |bvAbvEBhE̍쐬
	CreatePopUpWindow();
	// obNobt@̍쐬
	BackBuffer = new CDib(SCREEN_WIDTH, SCREEN_HEIGHT);
	// Direct Music 
	Music_Init();
	// f[^t@C̓ǂݍ
	Load_Setting();	// Load_FolderName() ̎s
	// ^Cg̐ݒ
	SendMessage(hWnd, WM_SETTEXT, 0, (LPARAM) g_set.title);
	// BGM ƌʉ̉ʐݒ
	Set_Volume(g_set.vol_all);
	// f[^t@C̓ǂݍ
	Load_PlayDataName("play_data_name_list.dat");	// Load_Setting() ̎s
	Load_LevelList();
	Load_LevelAbility();
	Load_Monster();
	Load_Enemy();
	Load_Magic();
	Load_Item();
	Load_Talk();
	Load_Sound();
	Load_BGM();
	Load_BackImage();
	Load_SelImage();
	Load_FaceImage();
	Load_Effect();
	Load_Title();
	Load_Narration();
	Load_Shop();
	// p[^̏
	Param_Init();
	// Direct Input ̏
	DI_Init(hWnd);
	// |bvAbvEBhE
	if(g_hPop){
		SendMessage(g_hPop, WM_CLOSE, 0, 0);
	}
	// ^C~O
	ZeroMemory(g_bTiming, sizeof(g_bTiming));
	ZeroMemory(g_nTiming, sizeof(g_nTiming));
}// GameInit

// Q[[v֐
void GameMain(void)
{
	// {Aj[Vx
	static long	TickCountFade = GetTickCount();
	if(!GetTiming(g_set.game_speed, &TickCountFade)){
		return;
	}
	
	static bool	flag_stop[] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
	static bool	flag_stop_PC1 = 0;
	static bool	flag_stop_PC2 = 0;
	static bool	flag_draw_map = false;	// }bv`悷邩Ȃ
	static bool	flag_move_PC = false;	// PCړǂiL[ĂȂƂfalseȀ݂ꍇfalsej
	
	Set_KeyState();		// L[̉ԂOϐɐݒ
	
	if(!g_key[0].left && !g_key[0].right && !g_key[0].up && !g_key[0].down){
		Set_JoyState();	// Rg[[̏ԂOϐɐݒ
	}
	
	Set_KeyState2();	// AL[ԂOϐɐݒ
	
	Set_ShowFlag();		// \tO̐ݒ
	
	// p[^Q[X^[g̏Ԃɏ
	if(gbInitParam){
		Param_Init();
		gbInitParam = false;
	}
	
	// ʕύX̊JntOݒ
	static int	indexScene;	// ʕύX̔ԍ
	if(!flag_stop[LAST_FLAG] && g_sn.scene_change){
		int i;
		static POINT	pre_pos = {-1, -1};
		indexScene = -1;
		if(g_pc.interval_ct == g_set.move_interval_pc && 
			(pre_pos.x != g_pc.pos_hit.x || pre_pos.y != g_pc.pos_hit.y))
		{
			pre_pos = g_pc.pos_hit;
			for(i=0;i<g_sn.scene_change_num;i++){
				if(g_pc.pos_hit.x == g_sn.scene_change[i].tipPtNow.x &&
					g_pc.pos_hit.y == g_sn.scene_change[i].tipPtNow.y)
				{
					if(g_pc.idxDir == g_sn.scene_change[i].idxDir ||
						g_sn.scene_change[i].idxDir == 4)
					{
						indexScene = i;
						Parse_EventFlag(&g_pc, g_sn.scene_change[i].idxFlag);
						break;
					}
					else{
						pre_pos.x = pre_pos.y = -1;
					}
				}
			}
		}
	}
	Set_EventStopFlag(flag_stop);
	// tB[h퓬̊JntOݒ
	static char	nameBmpBg[MAX_PATH];	// PCn_̔wi摜̃t@C
	static int	indexEnemy = 0;			// Gjbg̔ԍ
	static int	indexEnemies = 0;		// G̔ԍ
	if(Can_Event(4, flag_stop) && flag_move_PC){
		int idxMapChip = gMapData[g_pc.pos_hit.y * gMapSizeX + g_pc.pos_hit.x] & BYTE_MASK_BG;
		int idxBattle = g_sn.battle_map.idxBattles[idxMapChip/CHIP_IMG_ROW][idxMapChip%CHIP_IMG_ROW] - 1;
		if(g_sn.battle && idxBattle >= 0 && idxBattle < g_sn.battle_num && !(rand() % (int)(100.0f / g_sn.battle[idxBattle].rateAppear))){	// 퓬
			flag_stop[4] = true;
			strncpy(nameBmpBg, g_sn.battle[idxBattle].filenameBgBattle, sizeof(nameBmpBg));
			indexEnemy = g_sn.battle[idxBattle].idxEnemy;
			indexEnemies = Get_Enemies_Index(indexEnemy);
		}
	}
	Set_EventStopFlag(flag_stop);
	// ʒuCxgiXEhEĎDE퓬j̊JntOݒ
	static bool	flag_show_money = false;// bŏ\邩H
	static bool	flag_escape = false;	// mn͉\H
	static int	idxEp = 0;				// ʒuCxgʔԍ
	static int	indexEnemy2 = 0;		// Gjbg̔ԍiʒu퓬j
	static int	indexEnemies2 = 0;		// G̔ԍiʒu퓬j
	static char	*strTalk1 = NULL;		// ʒu퓬Ob
	static char	*strTalk2 = NULL;		// ʒu퓬b
	if((g_key[1].space || g_key[1].enter) && g_sn.event_pos && Can_Event(5, flag_stop)){
		int	i,idxEp2 = -1;
		for(i=0;i<g_sn.event_pos_num;i++){
			if((g_pc.idxDir == g_sn.event_pos[i].idxDir || g_sn.event_pos[i].idxDir == 4) && 
				g_pc.pos_hit.x == g_sn.event_pos[i].pos.x && 
				g_pc.pos_hit.y == g_sn.event_pos[i].pos.y &&
				!((g_pc.view.x + g_pc.pos.x) % HIT_SIZE) &&
				!((g_pc.view.y + g_pc.pos.y - (g_pc.img_size[1] - HIT_SIZE)) % HIT_SIZE))
			{
				idxEp2 = i;
				break;
			}
		}
		if(idxEp2 != -1){
			idxEp = idxEp2;
			flag_stop[5] = true;
			flag_show_money = false;
			switch (g_sn.event_pos[idxEp].kind)
			{
			case 1:	// h̏ꍇ
				flag_show_money = true;
				break;
			case 3:	// 퓬̏ꍇ
				{
					Parse_EventFlag(&g_pc, g_sn.event_pos[idxEp2].idxFlag);
					int		idxTalk1,idxTalk2;
					idxTalk1 = gEf.eb.idxTalk1;
					idxTalk2 = gEf.eb.idxTalk2;
					
					if(idxTalk1 >= 0 && idxTalk1 < g_talk.num){
						strTalk1 = g_talk.str[idxTalk1];
					}
					if(idxTalk2 >= 0 && idxTalk2 < g_talk.num){
						strTalk2 = g_talk.str[idxTalk2];
					}
					indexEnemy2 = gEf.eb.idxEnemy;
					indexEnemies2 = Get_Enemies_Index(indexEnemy2);
					flag_escape = gEf.eb.flag_escape ? true : false;
				}
				break;
			}
		}
	}
	Set_EventStopFlag(flag_stop);
	// 󔠃Cxg
	if(!flag_stop[LAST_FLAG]){
		Open_Treasure(&g_pc);
	}
	// }bv`̃Cxg
	if(flag_draw_map){
		// PC tF[hC
		flag_stop_PC1 = FadeIn_PC(&g_pc);
		// PC tF[hAEg
		flag_stop_PC2 = FadeOut_PC(&g_pc);
		// PC̈ړ
		flag_move_PC = Move_PC(&g_pc, flag_stop[LAST_FLAG] | flag_stop_PC1 | flag_stop_PC2);
		// NPC̈ړ
		Move_NPC();
		// 󔠂̃AjJEgXV
		Move_Treasure();
		// }bv̕`idˍ킹j
		Draw_Map_Bin(BackBuffer, g_pc.view.x, g_pc.view.y, false);
		// GtFNg\
		if(Can_Event(0, flag_stop) && g_ine.inf && gEf.idxEffect >= 0 && !g_ine.inf[gEf.idxEffect].inf3.flag_over){
			flag_stop[0] = Effect(BackBuffer, &g_pc);
		}
		Set_EventStopFlag(flag_stop);
		// PCNPC̕`
		Draw_Chara(BackBuffer, &g_pc);
		// GtFNg\
		if(Can_Event(1, flag_stop) && g_ine.inf && gEf.idxEffect >= 0 && g_ine.inf[gEf.idxEffect].inf3.flag_over){
			flag_stop[1] = Effect(BackBuffer, &g_pc);
		}
		Set_EventStopFlag(flag_stop);
		// }bv̕`idˍ킹j
		Draw_Map_Bin(BackBuffer, g_pc.view.x, g_pc.view.y, true);
		// ʕύX
		if(Can_Event(2, flag_stop)){
			flag_stop[2] = Change_Scene(BackBuffer, &g_pc);
		}
		Set_EventStopFlag(flag_stop);
		// NPCƉb
		if(Can_Event(3, flag_stop)){
			flag_stop[3] = Talk_Npc(BackBuffer, &g_pc);
		}
		Set_EventStopFlag(flag_stop);
	}
	// tB[h퓬
	if(flag_stop[4]){
		flag_stop[4] = Battle(BackBuffer, &g_pc, &flag_draw_map, &g_enemy.inf[indexEnemy].inf[indexEnemies], nameBmpBg, true, 0, NULL, NULL, -1);
	}
	Set_EventStopFlag(flag_stop);
	// XEhEĎDEʒu퓬
	if(flag_stop[5]){
		switch (g_sn.event_pos[idxEp].kind )
		{
		case 0:	// X̏ꍇ
			flag_stop[5] = Shop(BackBuffer, &g_pc, &flag_draw_map, idxEp);
			break;
		case 1:	// h̏ꍇ
		case 2:	// ĎD̏ꍇ
			flag_stop[5] = Inn_Notice(BackBuffer, &g_pc, g_sn.event_pos[idxEp].idxFlag, flag_show_money);
			break;
		case 3:	// 퓬̏ꍇ
			if(gEf.eb.speedTalk > 0 && strcmp(gEf.eb.nameImg, "") &&
				indexEnemy2 >= 0 && indexEnemy2 < g_enemy.num && 
				indexEnemies2 >= 0 && indexEnemies2 < g_enemy.inf[indexEnemy2].num)
			{
				flag_stop[5] = Battle(BackBuffer, &g_pc, &flag_draw_map, &g_enemy.inf[indexEnemy2].inf[indexEnemies2],
									gEf.eb.nameImg, flag_escape, strTalk1, strTalk2,
									gEf.eb.speedTalk, gEf.eb.idxFlag);
			}
			else{
				flag_stop[5] = false;
			}
			break;
		}
		// PCÎ~
		static bool pre_flag_stop5 = false;
		if(!pre_flag_stop5 && flag_stop[5]){
			g_pc.interval_ct = g_set.move_interval_pc;
			g_pc.posBm.x = 1;
		}
		pre_flag_stop5 = flag_stop[5];
	}
	Set_EventStopFlag(flag_stop);
	// Q[I[o[
	if(Can_Event(6, flag_stop) && g_pc.hitPoint <= 0){
		flag_stop[6] = GameOver(BackBuffer, &flag_draw_map);
		if(!flag_stop[6]){
			Param_Init();
		}
	}
	Set_EventStopFlag(flag_stop);
	// xAbvɔ\͒lAbv^̑I
	if(Can_Event(7, flag_stop)){
		flag_stop[7] = Level_Ability_Up(BackBuffer, &g_pc, &flag_draw_map);
	}
	Set_EventStopFlag(flag_stop);
	// ^Cg\
	if(Can_Event(8, flag_stop)){
		flag_stop[8] = Title(BackBuffer, &g_pc, &flag_draw_map);
	}
	Set_EventStopFlag(flag_stop);
	// [hʕ\
	if(Can_Event(9, flag_stop)){
		flag_stop[9] = Disp_Load(BackBuffer, &flag_draw_map);
	}
	Set_EventStopFlag(flag_stop);
	// i[V\
	if(Can_Event(10, flag_stop)){
		flag_stop[10] = Narration(BackBuffer, &g_pc, &flag_draw_map);
	}
	Set_EventStopFlag(flag_stop);
	// j[\
	if(Can_Event(11, flag_stop)){
		flag_stop[11] = Menu(BackBuffer, &g_pc, &flag_draw_map);
	}
	Set_EventStopFlag(flag_stop);
	// tF[h
	if(Can_Event(12, flag_stop)){
		flag_stop[12] = Fade(BackBuffer);
	}
	Set_EventStopFlag(flag_stop);
	// bZ[W\
	if(Can_Event(13, flag_stop)){
		flag_stop[13] = Message(BackBuffer, &g_pc);
	}
	Set_EventStopFlag(flag_stop);
	// xAbv\
	if(!flag_stop[LAST_FLAG] && gbShowLevelUp){
		gbShowLevelUp = Show_Level_Up(&g_pc, gEf.strMsg);
		if(gbShowLevelUp){
			gbMessage = true;
			gEf.idxShow = 5;
			gEf.idxFlag = -1;
		}
	}
	// b҂
	TalkWait();
	
	// \
	if(flag_draw_map && g_flagShowCood){
		char str[256];
		int idxBk = gMapData[g_pc.pos_hit.y * gMapSizeX + g_pc.pos_hit.x] & BYTE_MASK_BG;
		DIB_DrawRectFade(BackBuffer, 0, 0, SCREEN_WIDTH, 65, 8, DIB_RGB_MAKE(0, 0, 55));
		sprintf(str, "r[ʒuFX = %3d, Y = %3d", g_pc.view.x / CHIP_SIZE, g_pc.view.y / CHIP_SIZE);
		DIB_DrawFont(BackBuffer, str, 12, 5, 5, 255, 255, 255);
		sprintf(str, "obW@FX = %3d, Y = %3d", g_pc.pos.x, g_pc.pos.y);
		DIB_DrawFont(BackBuffer, str, 12, 5, 20, 255, 255, 255);
		sprintf(str, "obʒu@FX = %3d, Y = %3d", g_pc.pos_hit.x, g_pc.pos_hit.y);
		DIB_DrawFont(BackBuffer, str, 12, 5, 35, 255, 255, 255);
		sprintf(str, "摜ʒu@FX = %3d, Y = %3d", idxBk % CHIP_IMG_ROW, idxBk / CHIP_IMG_ROW);
		DIB_DrawFont(BackBuffer, str, 12, 5, 50, 255, 255, 255);
	}
	
	static quake_ct = 0;
	// obNobt@]
	HDC hDC = GetDC(GetSysHwnd());
	BitBlt(hDC, gEf.ptQuake[quake_ct].x, gEf.ptQuake[quake_ct].y, SCREEN_WIDTH, SCREEN_HEIGHT, BackBuffer->GetHDC(), 0, 0, SRCCOPY);
	ReleaseDC(GetSysHwnd(), hDC);
	// nk
	Quake(&g_pc, &quake_ct);
	
	// ^C~O̐ݒ
	for(int i=1; i<=SLOWEST_SPEED; i++){
		g_bTiming[i] = false;
		g_nTiming[i] ++;
		if(g_nTiming[i] >= i){
			g_bTiming[i] = true;
			g_nTiming[i] = 0;
		}
	}
}// GameMain

// p[^̏
void Param_Init()
{
	HWND hWnd = GetSysHwnd();
	char scene_file[MAX_PATH];
	
	// Q[ݒ̓ǂݍ
	Load_StartGame();
	
	_snprintf(scene_file, sizeof(scene_file), "scene%d.txt", gIdxScene);
	if(!Load_Scene(scene_file)){
		SysErrMsgDisp("scene.txt ǂݍ߂܂");
		PostMessage(hWnd, WM_CLOSE, 0, 0);
	}
	if(Load_MapData(g_sn.filenameMapData)){
		Load_BgMapChip(g_sn.filenameBgMapChip);
		Load_LyerMapChip(g_sn.imginfLyerMapChip.name,
						DIB_RGB_MAKE(g_sn.imginfLyerMapChip.colorkey_red,
									g_sn.imginfLyerMapChip.colorkey_green,
									g_sn.imginfLyerMapChip.colorkey_blue));
		
		// NPC̏
		Load_NPC();
		
		// 󔠏̏
		Load_Treasure();	// Load_Effect() Ɏs
		
		// NPCE󔠏̍XV
		Init_NpcTre();
		
		// PC̏
		Pc_Init();
		g_pc.kindScene = g_sn.kindScene;
		
		// CxgtȌ
		Init_EventFlag();
		
		// ̏
		srand((unsigned)time(NULL));
	}
	else{
		SysErrMsgDisp("BIN t@Cǂݍ߂܂");
		PostMessage(hWnd, WM_CLOSE, 0, 0);
	}
}// Param_Init

// vC[LN^[̏
void Pc_Init()
{
	Load_PC();
	Set_ViewCenter(&g_pc);
	g_pc.pos_hit.x		= (g_pc.view.x + g_pc.pos.x) / HIT_SIZE;
	g_pc.pos_hit.y		= (g_pc.view.y + g_pc.pos.y - (g_pc.img_size[1] - HIT_SIZE)) / HIT_SIZE + (g_pc.img_size[1] - 1) / HIT_SIZE;
	g_pc.hitPoint		= g_pc.ability.hitPointMax;
	g_pc.mentalPoint	= g_pc.ability.mentalPointMax;
	for(int i=0;i<2;i++){
		Set_Bm(&g_pc.img[i].bm, &g_pc.img[i].bm2, g_pc.img[i].flag_alpha,
				g_pc.img[i].flag_colorkey, g_pc.img[i].filenameBm,
				g_pc.img[i].xBm, g_pc.img[i].yBm,
				g_pc.img[i].widthBm, g_pc.img[i].heightBm,
				DIB_RGB_MAKE(g_pc.img[i].colorkey_red,
				g_pc.img[i].colorkey_green, g_pc.img[i].colorkey_blue));
	}
	Change_ConditionBmp(&g_pc);
	if(g_magic.inf){
		free(g_pc.idxMagic);
		int size = g_magic.num * sizeof(int);
		g_pc.idxMagic = (int *) malloc(size);
		ZeroMemory(g_pc.idxMagic, size);
		Learn_Magic(&g_pc);
	}
}// Pc_Init

// flag_stop Ŝ̃tOݒ
void Set_EventStopFlag(bool *flag_stop)
{
	flag_stop[LAST_FLAG] = 0;
	for(int i=0;i<LAST_FLAG;i++){
		flag_stop[LAST_FLAG] |= flag_stop[i];
	}
}// Set_EventStopFlag

// wԍ̃Cxgs\H
bool Can_Event(int idxFlag, bool *flag_stop)
{
	bool flag = false;
	for(int i=0;i<LAST_FLAG;i++){
		if(i == idxFlag)	continue;
		flag |= flag_stop[i];
	}
	return !flag;
}// Can_Event

// ǂ̓Gꂽ
// idxEnemy	: [IN]	Gjbg̔ԍ
// ߂l	: G̔ԍiGȂꍇ -1j
int Get_Enemies_Index(int idxEnemy)
{
	if(idxEnemy < 0 || idxEnemy >= g_enemy.num){
		return -1;
	}
	
	int i,enemy_num;
	int enemy_max = g_enemy.inf[idxEnemy].num;
	int size = enemy_max * sizeof(int);
	
	g_monster_probability = (int*) malloc(size);
	ZeroMemory(g_monster_probability, size);
	enemy_num = 0;
	for(i=0;i<enemy_max;i++){
		g_monster_probability[enemy_num] = 0;
		if(enemy_num == 0){
			g_monster_probability[enemy_num] = (int)(g_enemy.inf[idxEnemy].inf[i].rateAppear * 100);
		}
		else{
			g_monster_probability[enemy_num] = g_monster_probability[enemy_num - 1] + (int)(g_enemy.inf[idxEnemy].inf[i].rateAppear * 100);
		}
		enemy_num ++;
	}
	int remainder = rand() % 100;
	int indexEnemies = 0;
	for(i=0;i<enemy_max;i++){
		if(remainder < g_monster_probability[i]){
			indexEnemies = i;
			break;
		}
	}
	SAFE_FREE(g_monster_probability);
	return indexEnemies;
}// Get_Enemies_Index

// 	Q[I
void GameRelease(void)
{
	SAFE_FREE(g_monster_probability);
	Term_RpgFile();
	Term_RpgBin();
	Term_RpgEvent();
	Term_RpgChara();
	Term_WinPop();
	// DIB̉
	SAFE_DELETE(BackBuffer);
	// Direct Music I
	Music_Term();
	Free_Music();
	// Direct Input I
	DI_Term();
}// GameRelease
