#ifndef __RPGBIN_H__
#define __RPGBIN_H__

#define MAP_VIEW_SIZE_X		10	// }bv̕\TCY (GAME_WIDTH / CHIP_SIZE)
#define MAP_VIEW_SIZE_Y		8	// }bv̕\TCY (GAME_HEIGHT / CHIP_SIZE)
#define HIT_SIZE			32	// 蔻TCY i32 Œj

#define BYTE_MASK_BG		0x000000FF
#define BYTE_MASK_FLG		0x0000FF00
#define BYTE_MASK_LYER		0x00FF0000
#define BYTE_MASK_UNDEF		0xFF000000

#define BIT_MASK_HIT16_0	0x00000100
#define BIT_MASK_HIT16_1	0x00000200
#define BIT_MASK_HIT16_2	0x00000400
#define BIT_MASK_HIT16_3	0x00000800
#define BIT_MASK_PRI16_0	0x00001000
#define BIT_MASK_PRI16_1	0x00002000
#define BIT_MASK_PRI16_2	0x00004000
#define BIT_MASK_PRI16_3	0x00008000

#define BYTE_SHIFT_BG		0
#define BYTE_SHIFT_FLG		8
#define BYTE_SHIFT_LYER		16
#define BYTE_SHIFT_UNDEF	24

POINT	gViewCenterPos = {0, 0};	// r[̒SWihbgj
bool	g_flagShowCood = false;		// W\tO
bool	g_flagShowHit = false;		// 蔻\tO
bool	g_bTiming[SLOWEST_SPEED + 1];	// Jn̍}ig_bTiming[0] ͎gpȂj

CDib	*MapChipBg		= NULL;		// wipobt@
CDib	*MapChipLyer	= NULL;		// C[pobt@i16 bit DIBj
CDib2	*MapChipLyer2	= NULL;		// C[pobt@i32 bit DIBj

void	Set_KeyState();
void	Set_KeyState2();
void	Set_ShowFlag();
POINT	Get_MapSize();
void	Load_BgMapChip(char *filename);
void	Load_LyerMapChip(char *filename, WORD color = COLOKEY_NONE);
void	Draw_Map_Bin(CDib *buf, long scr_x, long scr_y, bool flag_priority);
void	Draw_AnimeChip(CDib *buf, int idxMapAnim, int x, int y, int pos_ct);
void	Get_LastKeyState(int *key_idx, bool *flag_keydown);
void	Get_ScrAndPos_Bin(long key_idx, int move_step, int *pos_hitmap, int *pos_center, int *scr_limit,
					int *pos_limit, long *scr_x, long *scr_y, long *pos_x, long *pos_y);
void	Set_ViewCenter(PC *pc);
void	Term_RpgBin();

// ݂̃L[ԂOϐɐݒ
void Set_KeyState()
{
	// L[`FbN
	static int left = FREE_KEY;
	SysKeyGet(VK_LEFT, &left);
	static int right = FREE_KEY;
	SysKeyGet(VK_RIGHT, &right);
	static int up = FREE_KEY;
	SysKeyGet(VK_UP, &up);
	static int down = FREE_KEY;
	SysKeyGet(VK_DOWN, &down);
	static int space = FREE_KEY;
	SysKeyGet(VK_SPACE, &space);
	static int enter = FREE_KEY;
	SysKeyGet(VK_RETURN, &enter);
	static int esc = FREE_KEY;
	SysKeyGet(VK_ESCAPE, &esc);
	static int c = FREE_KEY;
	SysKeyGet('C', &c);
	static int h = FREE_KEY;
	SysKeyGet('H', &h);
	static int x = FREE_KEY;
	SysKeyGet('X', &x);
	static int z = FREE_KEY;
	SysKeyGet('Z', &z);
	// ݂̏
	g_key[0].left	= (left  == HOLD_KEY) ? true : false;
	g_key[0].right	= (right == HOLD_KEY) ? true : false;
	g_key[0].up		= (up    == HOLD_KEY) ? true : false;
	g_key[0].down	= (down  == HOLD_KEY) ? true : false;
	g_key[0].space	= (space == HOLD_KEY) ? true : false;
	g_key[0].enter	= (enter == HOLD_KEY) ? true : false;
	g_key[0].esc	= (esc   == HOLD_KEY) ? true : false;
	g_key[0].c		= (c     == HOLD_KEY) ? true : false;
	g_key[0].h		= (h     == HOLD_KEY) ? true : false;
	g_key[0].x		= (x     == HOLD_KEY) ? true : false;
	g_key[0].z		= (z     == HOLD_KEY) ? true : false;
	// ŏɉƂ
	g_key[1].left	= (left  == PUSH_KEY) ? true : false;
	g_key[1].right	= (right == PUSH_KEY) ? true : false;
	g_key[1].up		= (up    == PUSH_KEY) ? true : false;
	g_key[1].down	= (down  == PUSH_KEY) ? true : false;
	g_key[1].space	= (space == PUSH_KEY) ? true : false;
	g_key[1].enter	= (enter == PUSH_KEY) ? true : false;
	g_key[1].esc	= (esc   == PUSH_KEY) ? true : false;
	g_key[1].c		= (c     == PUSH_KEY) ? true : false;
	g_key[1].h		= (h     == PUSH_KEY) ? true : false;
	g_key[1].x		= (x     == PUSH_KEY) ? true : false;
	g_key[1].z		= (z     == PUSH_KEY) ? true : false;
	
	static long	TickCountKey = GetTickCount();
	
	g_key[2].left	= false;
	g_key[2].right	= false;
	g_key[2].up		= false;
	g_key[2].down	= false;
	if(g_key[1].left || g_key[1].right ||
		g_key[1].up || g_key[1].down)
	{
		g_key[2] = g_key[1];
		TickCountKey = GetTickCount();
	}
	else{
		bool		flag_key = GetTiming(g_set.key_interval*g_set.game_speed, &TickCountKey);
		if(flag_key){
			if(g_key[0].left){
				if(!g_key[2].left)
					g_key[2].left = true;
				else
					g_key[2].left = false;
			}
			else{
				g_key[2].left = false;
			}
			if(g_key[0].right){
				if(!g_key[2].right)
					g_key[2].right = true;
				else
					g_key[2].right = false;
			}
			else{
				g_key[2].right = false;
			}
			if(g_key[0].up){
				if(!g_key[2].up)
					g_key[2].up = true;
				else
					g_key[2].up = false;
			}
			else{
				g_key[2].up = false;
			}
			if(g_key[0].down){
				if(!g_key[2].down)
					g_key[2].down = true;
				else
					g_key[2].down = false;
			}
			else{
				g_key[2].down = false;
			}
		}
	}
}// Set_KeyState

// AL[ԂOϐɐݒ
void Set_KeyState2()
{
	static long	TickCountKey = GetTickCount();
	
	g_key[2].left	= false;
	g_key[2].right	= false;
	g_key[2].up		= false;
	g_key[2].down	= false;
	if(g_key[1].left || g_key[1].right ||
		g_key[1].up || g_key[1].down)
	{
		g_key[2] = g_key[1];
		TickCountKey = GetTickCount();
	}
	else{
		bool		flag_key = GetTiming(g_set.key_interval*g_set.game_speed, &TickCountKey);
		if(flag_key){
			if(g_key[0].left){
				if(!g_key[2].left)
					g_key[2].left = true;
				else
					g_key[2].left = false;
			}
			else{
				g_key[2].left = false;
			}
			if(g_key[0].right){
				if(!g_key[2].right)
					g_key[2].right = true;
				else
					g_key[2].right = false;
			}
			else{
				g_key[2].right = false;
			}
			if(g_key[0].up){
				if(!g_key[2].up)
					g_key[2].up = true;
				else
					g_key[2].up = false;
			}
			else{
				g_key[2].up = false;
			}
			if(g_key[0].down){
				if(!g_key[2].down)
					g_key[2].down = true;
				else
					g_key[2].down = false;
			}
			else{
				g_key[2].down = false;
			}
		}
	}
}// Set_KeyState2

// \tO̐ݒ
void Set_ShowFlag()
{
	if(g_key[1].c){
		if(g_flagShowCood)
			g_flagShowCood = false;
		else
			g_flagShowCood = true;
	}
	if(g_key[1].h){
		if(g_flagShowHit)
			g_flagShowHit = false;
		else
			g_flagShowHit = true;
	}
}// Set_ShowFlag

//	}bvTCY擾
POINT Get_MapSize()
{
	POINT map_size;
	map_size.x = gMapSizeX;
	map_size.y = gMapSizeY;
	return map_size;
}// Get_MapSize

//	wi}bv`bv摜ǂݍ
void Load_BgMapChip(char *filename)
{
	SAFE_DELETE(MapChipBg);
	MapChipBg = new CDib(filename);
}// Load_BgMapChip

//	C[}bv`bv摜ǂݍ
//@color	: [IN]	J[L[
void Load_LyerMapChip(char *filename, WORD color)
{
	SAFE_DELETE(MapChipLyer);
	SAFE_DELETE(MapChipLyer2);
	if(g_sn.imginfLyerMapChip.flag_alpha < 2){
		if(!g_sn.imginfLyerMapChip.flag_colorkey)
			MapChipLyer = new CDib(filename);
		else
			MapChipLyer = new CDib(filename, color);
	}
	else{
		MapChipLyer2 = new CDib2(filename);
	}
}// Load_LyerMapChip

//	}bv̕\
//@buf				: [IN][OUT]	obNobt@
//@scr_x, scr_y	: [IN]		}bṽXN[ʒu
//@flag_priority	: [IN]		false  L`Oɕ`, true  L`ɕ`
void Draw_Map_Bin(CDib *buf, long scr_x, long scr_y, bool flag_priority)
{
	if(!gMapData)	return;
	
	if(scr_x < 0)	scr_x = 0;
	if(scr_y < 0)	scr_y = 0;
	
	static int	pos_ct[CHIP_IMG_COL*CHIP_IMG_ROW] = {0};
	int i, j;
	int map_left   = scr_x / CHIP_SIZE;
	int map_right  = map_left + MAP_VIEW_SIZE_X;
	int map_top    = scr_y / CHIP_SIZE;
	int map_bottom = map_top + MAP_VIEW_SIZE_Y;
	
	if (scr_x % CHIP_SIZE)		map_right  ++;
	if (scr_y % CHIP_SIZE)		map_bottom ++;
	if (map_right  > gMapSizeX) map_right  = gMapSizeX;
	if (map_bottom > gMapSizeY) map_bottom = gMapSizeY;
	
	for (i = map_top; i < map_bottom; i++) {
		for (j = map_left; j < map_right; j++) {
			// wi\
			int idx = gMapData[i * gMapSizeX + j] & BYTE_MASK_BG;
			int x = j * CHIP_SIZE - scr_x;
			int y = i * CHIP_SIZE - scr_y;
			
			if(!flag_priority){
				int u2 = idx % CHIP_IMG_ROW;
				int v2 = idx / CHIP_IMG_ROW;
				int u = u2 * CHIP_SIZE;
				int v = v2 * CHIP_SIZE;
				int idxMapAnim = g_sn.map_anim.idxMapAnims[v2][u2] - 1;
				if(idxMapAnim < 0){
					DIB_DrawRectFast(buf, x, y, MapChipBg, u, v, u + CHIP_SIZE, v + CHIP_SIZE);
				}
				else{
					Draw_AnimeChip(buf, idxMapAnim, x, y, pos_ct[idxMapAnim]);
				}
			}
			// C[\
			idx = (gMapData[i * gMapSizeX + j] & BYTE_MASK_LYER) >> BYTE_SHIFT_LYER;
			if(HIT_SIZE == 32){
				if(!flag_priority && (gMapData[i * gMapSizeX + j] & BIT_MASK_PRI16_0)){
					continue;
				}
				else if(flag_priority && !(gMapData[i * gMapSizeX + j] & BIT_MASK_PRI16_0)){
					continue;
				}
				if(idx != 0) { // `bvhcÔ͍ߕ`悵Ȃ
					int u = (idx % CHIP_IMG_ROW) * CHIP_SIZE;
					int v = (idx / CHIP_IMG_ROW) * CHIP_SIZE;
					if(g_sn.imginfLyerMapChip.flag_alpha < 2)
						DIB_DrawRect(buf, x, y, MapChipLyer, u, v, u + CHIP_SIZE, v + CHIP_SIZE);
					else
						DIB2_DrawAlpha(buf, x, y, MapChipLyer2, u, v, CHIP_SIZE, CHIP_SIZE, 255);
				}
			}
		}
	}
	
	// Aj`bvJEg̍XV
	if(!flag_priority && g_bTiming[g_inma.speed]){
		for(i=0; i<g_inma.inf_num; i++){
			pos_ct[i] ++;
			if(pos_ct[i] >= g_inma.inf[i].pos_num){	// I
				pos_ct[i] = 0;
			}
		}
	}
	
	// 蔻̕`
	if(gMapData && g_flagShowHit){
		for (i = map_top; i < map_bottom; i++) {
			for (j = map_left; j < map_right; j++) {
				if(flag_priority && (gMapData[i * gMapSizeX + j] & BIT_MASK_HIT16_0)){
					int x = j * HIT_SIZE - scr_x;
					int y = i * HIT_SIZE - scr_y;
					DIB_DrawHalfAlpha(buf, x, y, MapChipBg, 0, 0, HIT_SIZE, HIT_SIZE);
				}
			}
		}
	}
}// Draw_Map_Bin

// Aj[V }bv`bv̕`
void Draw_AnimeChip(CDib *buf, int idxMapAnim, int x, int y, int pos_ct)
{
	if(!g_inma.inf || !g_inma.bm || idxMapAnim < 0 || idxMapAnim >= g_inma.inf_num || pos_ct < 0 || pos_ct >= g_inma.inf[idxMapAnim].pos_num){
		return;
	}
	
	RECT	rc_src;
	
	rc_src.left		= g_inma.inf[idxMapAnim].pos[pos_ct].x * g_inma.width;
	rc_src.top		= g_inma.inf[idxMapAnim].pos[pos_ct].y * g_inma.height;
	rc_src.right	= rc_src.left + g_inma.width;
	rc_src.bottom	= rc_src.top + g_inma.height;
	
	DIB_DrawRectFast(buf, x, y, g_inma.bm, rc_src.left, rc_src.top, rc_src.right, rc_src.bottom);
}// Draw_AnimeChip

//	ŌɉꂽA邢͈ĂL[̔ԍ擾
//@key_idx		: [OUT]	0  up, 1  right, 2  down, 3  left
//@flag_keydown: [OUT]	true  Ă, false  ĂȂ
void Get_LastKeyState(int *key_idx, bool *flag_keydown)
{
	static bool	pre_state0 = 0,pre_state1 = 0,pre_state2 = 0,pre_state3 = 0;
	
	if(!g_key[0].down){
		pre_state0 = false;
	}
	if(!g_key[0].left){
		pre_state1 = false;
	}
	if(!g_key[0].right){
		pre_state2 = false;
	}
	if(!g_key[0].up){
		pre_state3 = false;
	}
	
	*flag_keydown = false;
	
	if(g_key[0].down){
		if(!pre_state0 || (!g_key[0].left && !g_key[0].right && !g_key[0].up)){
			*key_idx = 0;
			pre_state0 = true;
		}
		*flag_keydown = true;
	}
	if(g_key[0].left) {
		if(!pre_state1 || (!g_key[0].right && !g_key[0].up && !g_key[0].down)){
			*key_idx = 1;
			pre_state1 = true;
		}
		*flag_keydown = true;
	}
	if(g_key[0].right){
		if(!pre_state2 || (!g_key[0].left && !g_key[0].up && !g_key[0].down)){
			*key_idx = 2;
			pre_state2 = true;
		}
		*flag_keydown = true;
	}
	if(g_key[0].up){
		if(!pre_state3 || (!g_key[0].left && !g_key[0].right && !g_key[0].down)){
			*key_idx = 3;
			pre_state3 = true;
		}
		*flag_keydown = true;
	}
}// Get_LastKeyState

//	XN[ʒuƃL̈ʒu擾
//@key_idx				: [IN]		݂̃L[ԍ (0  down, 1  left, 2  right, 3  up)
//@move_step			: [IN]		L̕
//@pos_hitmap[key_idx]	: [IN]		蔻z̗vfԍ
//@pos_center[key_idx]	: [IN]		L̈ړ\͈
//@scr_limit[key_idx]	: [IN]		XN[̌Eʒu
//@pos_limit[key_idx]	: [IN]		L̈ړEʒu
//@scr_x, scr_y		: [IN][OUT] XN[ʒu
//@pos_x, pos_y		: [IN][OUT] L̈ʒu
void Get_ScrAndPos_Bin(long key_idx, int move_step, int *pos_hitmap, int *pos_center, int *scr_limit,
					int *pos_limit, long *scr_x, long *scr_y, long *pos_x, long *pos_y)
{
	if(!gMapData)	return;
	
	switch (key_idx)
	{
	case 0:	// down
		if(!(gMapData[pos_hitmap[4]] & BIT_MASK_HIT16_2) && !(gMapData[pos_hitmap[0]] & BIT_MASK_HIT16_0)){
			if(*pos_y >= pos_center[0]){
				*scr_y += move_step;
			}
			else{
				*pos_y += move_step;
			}
			if(*scr_y > scr_limit[0]){
				*scr_y -= move_step;
				*pos_y += move_step;
				if(*pos_y > pos_limit[0])
					*pos_y -= move_step;
			}
		}
		break;
	case 1:	// left
		if(!(gMapData[pos_hitmap[1]] & BIT_MASK_HIT16_1) && !(gMapData[pos_hitmap[1]] & BIT_MASK_HIT16_0)){
			if(*pos_x <= pos_center[1]){
				*scr_x -= move_step;
			}
			else{
				*pos_x -= move_step;
			}
			if(*scr_x < scr_limit[1]){
				*scr_x += move_step;
				*pos_x -= move_step;
				if(*pos_x < pos_limit[1])
					*pos_x += move_step;
			}
		}
		break;
	case 2:	// right
		if(!(gMapData[pos_hitmap[4]] & BIT_MASK_HIT16_1) && !(gMapData[pos_hitmap[2]] & BIT_MASK_HIT16_0)){
			if(*pos_x >= pos_center[2]){
				*scr_x += move_step;
			}
			else{
				*pos_x += move_step;
			}
			if(*scr_x > scr_limit[2]){
				*scr_x -= move_step;
				*pos_x += move_step;
				if(*pos_x > pos_limit[2])
					*pos_x -= move_step;
			}
		}
		break;
	case 3:	// up
		if(!(gMapData[pos_hitmap[3]] & BIT_MASK_HIT16_2) && !(gMapData[pos_hitmap[3]] & BIT_MASK_HIT16_0)){
			if(*pos_y <= pos_center[3]){
				*scr_y -= move_step;
			}
			else{
				*pos_y -= move_step;
			}
			if(*scr_y < scr_limit[3]){
				*scr_y += move_step;
				*pos_y -= move_step;
				if(*pos_y < pos_limit[3])
					*pos_y += move_step;
			}
		}
		break;
	}
}// Get_ScrAndPos_Bin

// r[̒SWݒ
void Set_ViewCenter(PC *pc)
{
	if(pc){
		gViewCenterPos.x = (MAP_VIEW_SIZE_X * CHIP_SIZE) / 2;
		gViewCenterPos.y = (MAP_VIEW_SIZE_Y * CHIP_SIZE) / 2 - (pc->img_size[1] - HIT_SIZE);
	}
}// Set_ViewCenter

//	I
void Term_RpgBin()
{
	SAFE_DELETE(MapChipBg);
	SAFE_DELETE(MapChipLyer);
	SAFE_DELETE(MapChipLyer2);
	
	SAFE_FREE(gMapData);
	
	gMapSizeX = 0;
	gMapSizeY = 0;
	gViewCenterPos.x = 0;
	gViewCenterPos.y = 0;
	g_flagShowCood = false;
	g_flagShowHit = false;
}// Term_RpgBin

#endif
