#ifndef __RPGDRAWCHARA_H__
#define __RPGDRAWCHARA_H__

#include <time.h>

typedef struct{
	int		idxChara;		// Lԍig_npc.inf[] ̗vfԍ, -1  PCj
	POINT	tipPos;			// ݈ʒu
}CHARASCENE,*LPCHARASCENE;

CHARASCENE	*g_chara_scene = NULL;	// ʂƂNPCPC̔ԍƈʒu

int		Cmp_CHARASCENE(const CHARASCENE *a, const CHARASCENE *b);
void	Draw_Chara(CDib *buf, PC *pc);
void	Draw_Treasure(CDib *buf, int idxTre, int view_x, int view_y);
void	Draw_NPC(CDib *buf, int idx_npc, int view_x, int view_y);
void	Draw_PC(CDib *buf, PC *pc);
void	Move_Treasure();
void	Move_NPC();
bool	Move_PC(PC *pc, bool flag_stop_anim);
void	Calculate_HitVal(PC *pc, int *pos_hitmap, int *pos_center, int *scr_limit, int *pos_limit);
int		Get_Bm_X(int *idx_anim, int *anim_ct);
bool	Talk_Npc(CDib *buf, PC *pc);
bool	Open_Treasure(PC *pc);
bool	Change_Scene(CDib *buf, PC *pc);
void	Init_NpcTre();
void	Term_RpgChara();

// NCbN\[g̔r֐ij
int Cmp_CHARASCENE(const CHARASCENE *a, const CHARASCENE *b)
{
	return (a->tipPos.y - b->tipPos.y);
}// Cmp_CHARASCENE

// PCNPCƕ󔠂̕`
void Draw_Chara(CDib *buf, PC *pc)
{
	int	chara_scene_num;	// g_chara_scene ̗vf
	int i;
	int	chara_scene_max = g_sn.npc_index_num + g_sn.tre_index_num + 1;
	int size = chara_scene_max * sizeof(CHARASCENE);
	g_chara_scene = (LPCHARASCENE) malloc(size);
	ZeroMemory(g_chara_scene, size);
	
	// PCNPCƕ󔠂̕`揇pݒ
	chara_scene_num = 0;
	if(g_sn.npc_index && g_npc.inf){
		for(i=0;i<g_sn.npc_index_num;i++){
			int idxNpc = g_sn.npc_index[i];
			if(idxNpc >= 0 && idxNpc < g_npc.num){
				g_chara_scene[chara_scene_num].idxChara = i;
				g_chara_scene[chara_scene_num].tipPos = g_npc.inf[idxNpc].posNow;
				chara_scene_num ++;
				if(chara_scene_num >= chara_scene_max - 1){
					break;
				}
			}
		}
	}
	if(g_sn.tre_index && g_tre.inf){
		for(i=0;i<g_sn.tre_index_num;i++){
			int idxTre = g_sn.tre_index[i];
			if(idxTre >= 0 && idxTre < g_tre.num){
				g_chara_scene[chara_scene_num].idxChara = i + g_sn.npc_index_num;
				g_chara_scene[chara_scene_num].tipPos = g_tre.inf[idxTre].pt;
				chara_scene_num ++;
				if(chara_scene_num >= chara_scene_max - 1){
					break;
				}
			}
		}
	}
	g_chara_scene[chara_scene_num].idxChara = -1;
	g_chara_scene[chara_scene_num].tipPos = pc->pos_hit;
	chara_scene_num ++;
	
	// PCNPCƕ󔠂̕`揇
	qsort(g_chara_scene, chara_scene_num, sizeof(*g_chara_scene),
				(int (*)(const void*, const void*))Cmp_CHARASCENE);
	// PCNPCƕ󔠂̕`
	for(i=0;i<chara_scene_num;i++){
		int	idx = g_chara_scene[i].idxChara;
		if(idx >= 0 && idx < g_sn.npc_index_num){
			// NPC̕`
			int idxNpc = g_sn.npc_index[idx];
			if(idxNpc >= 0 && idxNpc < g_npc.num){
				Draw_NPC(buf, idxNpc, pc->view.x, pc->view.y);
			}
		}
		else if(idx >= g_sn.npc_index_num && idx < g_sn.npc_index_num + g_sn.tre_index_num){
			// 󔠂̕`
			int idx2 = idx - g_sn.npc_index_num;
			int idxTre = g_sn.tre_index[idx2];
			if(idxTre >= 0 && idxTre < g_tre.num){
				Draw_Treasure(buf, idxTre, pc->view.x, pc->view.y);
			}
		}
		else{
			// PC̕`
			Draw_PC(buf, pc);
		}
	}
	
	SAFE_FREE(g_chara_scene);
}// Draw_Chara

// 󔠂̕`
// buf		: [IN][OUT]	obNobt@
// idxTre	: [IN]		g_sn.tre.inf[] ̗vfԍ
void Draw_Treasure(CDib *buf, int idxTre, int view_x, int view_y)
{
	if(g_tre.inf && idxTre >= 0 && idxTre < g_tre.num && g_tre.inf[idxTre].flag_show){
		int		idxEffect = g_tre.inf[idxTre].idxEffect;
		int		idxAnim = g_tre.inf[idxTre].anim_ct;
		if(g_ine.inf && idxEffect >= 0 && idxEffect < g_ine.num){
			POINT	pt;
			pt.x = - view_x + g_tre.inf[idxTre].pt2.x;
			pt.y = - view_y + g_tre.inf[idxTre].pt2.y;
			if(pt.x >= -g_ine.inf[idxEffect].inf3.width && pt.x < SCREEN_WIDTH && pt.y >= -g_ine.inf[idxEffect].inf3.height && pt.y < SCREEN_HEIGHT){
				// 󔠂̕`
				Draw_Effect(buf, g_tre.inf[idxTre].bm, g_tre.inf[idxTre].bm2,
							pt, idxEffect, idxAnim);
			}
		}
	}
}// Draw_Treasure

// NPC̕`
// buf		: [IN][OUT]	obNobt@
// idx_npc	: [IN]		g_sn.npc.inf[] ̗vfԍ
void Draw_NPC(CDib *buf, int idx_npc, int view_x, int view_y)
{
	if(g_npc.inf && idx_npc >= 0 && idx_npc < g_npc.num && g_npc.inf[idx_npc].flag_show){
		POINT	pt;
		pt.x = - view_x + g_npc.inf[idx_npc].posNow2.x;
		pt.y = - view_y + g_npc.inf[idx_npc].posNow2.y;
		if(pt.x >= -g_npc.inf[idx_npc].img_size[0] && pt.x < SCREEN_WIDTH && pt.y >= -g_npc.inf[idx_npc].img_size[1] && pt.y < SCREEN_HEIGHT){
			// NPC̕`
			Draw_Dib(buf, g_npc.inf[idx_npc].img.bm,
					g_npc.inf[idx_npc].img.bm2,
					g_npc.inf[idx_npc].img.flag_alpha,
					pt.x, pt.y,
					g_npc.inf[idx_npc].posBm.x *
					g_npc.inf[idx_npc].img_size[0],
					g_npc.inf[idx_npc].posBm.y *
					g_npc.inf[idx_npc].img_size[1],
					g_npc.inf[idx_npc].img_size[0],
					g_npc.inf[idx_npc].img_size[1], 32);
		}
	}
}// Draw_NPC

// PC̕`
// buf		: [IN][OUT]	obNobt@
// pc		: [IN]		PC
void Draw_PC(CDib *buf, PC *pc)
{
	int pc_bm_y2 = pc->img_pos_idx[1][pc->idxDir];
	// PC̕`
	Draw_Dib(buf, pc->img[0].bm, pc->img[0].bm2,
				pc->img[0].flag_alpha,
				pc->pos.x, pc->pos.y,
				pc->posBm.x * pc->img_size[0],
				pc_bm_y2 * pc->img_size[1],
				pc->img_size[0], pc->img_size[1], pc->alpha_ct);
}// Draw_PC

// 
void Move_Treasure()
{
	if(!g_ine.inf || !g_sn.tre_index || !g_tre.inf){
		return;
	}
	
	for(int i=0;i<g_sn.tre_index_num;i++){
		int idxTre = g_sn.tre_index[i];
		if(idxTre >= 0 && idxTre < g_tre.num){
			if(g_tre.inf[idxTre].flag_anim_kind < 2 && g_tre.inf[idxTre].flag_opened &&
				g_tre.inf[idxTre].flag_show)
			{
				int idxEffect = g_tre.inf[idxTre].idxEffect;
				if(idxEffect >= 0 && idxEffect < g_ine.num){
					bool		flag_tre = GetTiming(g_ine.inf[idxEffect].inf3.speed*g_set.game_speed, &g_tre.inf[idxTre].TickCount);
					if(flag_tre){
						if(g_tre.inf[idxTre].anim_ct == 0){	// 
							Play_Wave(g_tre.inf[idxTre].idxWave);	// ʉ̍Đ
						}
						g_tre.inf[idxTre].anim_ct ++;
						if(g_tre.inf[idxTre].anim_ct >= g_ine.inf[idxEffect].inf4.pos_num){	// I
							switch(g_tre.inf[idxTre].flag_anim_kind)
							{
							case 1:	// 
								g_tre.inf[idxTre].anim_ct = g_ine.inf[idxEffect].inf4.pos_num - 1;
								break;
							case 2:	// ɃAj
								g_tre.inf[idxTre].anim_ct = 0;
								break;
							}
							return;
						}
					}
				}
			}
		}
	}
}// Move_Treasure

// NPC̈ړ
void Move_NPC()
{
	if(!g_sn.npc_index || !g_npc.inf){
		return;
	}
	
	for(int i=0;i<g_sn.npc_index_num;i++){
		int idxNpc = g_sn.npc_index[i];
		if(idxNpc >= 0 && idxNpc < g_npc.num){
			if(g_npc.inf[idxNpc].typeMove > 0 && !g_npc.inf[idxNpc].flag_talking && g_npc.inf[idxNpc].flag_show){
				bool	flag_NPC = GetTiming(g_npc.inf[idxNpc].move_speed*g_set.game_speed, &g_npc.inf[idxNpc].TickCount);
				if(flag_NPC){
					const int	cmb[][4] = {{0,1,2,3},{0,1,3,2},{0,2,1,3},{0,2,3,1},
											{0,3,1,2},{0,3,2,1},{1,0,2,3},{1,0,3,2},
											{1,2,0,3},{1,2,3,0},{1,3,0,2},{1,3,2,0},
											{2,0,1,3},{2,0,3,1},{2,1,0,3},{2,1,3,0},
											{2,3,0,1},{2,3,1,0},{3,0,1,2},{3,0,2,1},
											{3,1,0,2},{3,1,2,0},{3,2,0,1},{3,2,1,0}};
					const int	mv_x[4] = { 0,-1, 1, 0};
					const int	mv_y[4] = { 1 ,0, 0,-1};
					int			mv_idx;
					int			cmb_idx;
					if(g_npc.inf[idxNpc].straight_ct >= g_set.straight_max){
						g_npc.inf[idxNpc].straight_ct = 0;
						cmb_idx = rand() % 24;
						g_npc.inf[idxNpc].cmb_idx_pre = cmb_idx;
					}
					else{
						g_npc.inf[idxNpc].straight_ct ++;
						cmb_idx = g_npc.inf[idxNpc].cmb_idx_pre;
					}
					for(int j=0;j<4;j++){
						mv_idx = cmb[cmb_idx][j];
						int pos_hitmap1,pos_hitmap2;
						int next_x = g_npc.inf[idxNpc].posNow.x + mv_x[mv_idx];
						int next_y = g_npc.inf[idxNpc].posNow.y + mv_y[mv_idx];
						pos_hitmap1 = next_y * gMapSizeX + next_x;
						pos_hitmap2 = g_npc.inf[idxNpc].posNow.y * gMapSizeX + g_npc.inf[idxNpc].posNow.x;
						if(next_x > 0 && next_y > 0 && next_x < gMapSizeX
							&& next_y < gMapSizeY
							&& !(gMapData[pos_hitmap1] & BIT_MASK_HIT16_0)
							&& ((mv_x[mv_idx] == -1) && !(gMapData[pos_hitmap1] & BIT_MASK_HIT16_1)
							||  (mv_x[mv_idx] ==  1) && !(gMapData[pos_hitmap2] & BIT_MASK_HIT16_1)
							||  (mv_y[mv_idx] == -1) && !(gMapData[pos_hitmap1] & BIT_MASK_HIT16_2)
							||  (mv_y[mv_idx] ==  1) && !(gMapData[pos_hitmap2] & BIT_MASK_HIT16_2))
							&& next_x > g_npc.inf[idxNpc].posCenter.x - g_npc.inf[idxNpc].areaMove.x
							&& next_x < g_npc.inf[idxNpc].posCenter.x + g_npc.inf[idxNpc].areaMove.x
							&& next_y > g_npc.inf[idxNpc].posCenter.y - g_npc.inf[idxNpc].areaMove.y
							&& next_y < g_npc.inf[idxNpc].posCenter.y + g_npc.inf[idxNpc].areaMove.y)
						{
							if(g_npc.inf[idxNpc].interval_ct == 0){
								gMapData[g_npc.inf[idxNpc].posNow.y * gMapSizeX + g_npc.inf[idxNpc].posNow.x] &= ~BIT_MASK_HIT16_0;
								g_npc.inf[idxNpc].posNow.x += mv_x[mv_idx];
								g_npc.inf[idxNpc].posNow.y += mv_y[mv_idx];
								gMapData[g_npc.inf[idxNpc].posNow.y * gMapSizeX + g_npc.inf[idxNpc].posNow.x] |= BIT_MASK_HIT16_0;
								g_npc.inf[idxNpc].ptDst.x = mv_x[mv_idx] * HIT_SIZE / g_set.move_interval_npc;
								g_npc.inf[idxNpc].ptDst.y = mv_y[mv_idx] * HIT_SIZE / g_set.move_interval_npc;
								g_npc.inf[idxNpc].posBm.y = g_npc.inf[idxNpc].img_pos_idx[1][mv_idx];
							}
							g_npc.inf[idxNpc].posNow2.x += g_npc.inf[idxNpc].ptDst.x;
							g_npc.inf[idxNpc].posNow2.y += g_npc.inf[idxNpc].ptDst.y;
							// NPC̈ړAj̃R}ς
							g_npc.inf[idxNpc].posBm.x = Get_Bm_X(&g_npc.inf[idxNpc].idx_anim, g_npc.inf[idxNpc].img_pos_idx[0]);
							// interval_ct̉Z
							g_npc.inf[idxNpc].interval_ct ++;
							if(g_npc.inf[idxNpc].interval_ct >= g_set.move_interval_npc){
								g_npc.inf[idxNpc].interval_ct = 0;
							}
							break;
						}
						else{
							g_npc.inf[idxNpc].straight_ct = g_set.straight_max;
						}
					}
				}
			}
		}
	}
}// Move_NPC

// PC̈ړ
// pc				: [IN][OUT]	PC
// flag_stop_move	: [IN]		true  ړs, false  ړ\
// ߂l			:			true  ړ, false ړȂ
bool Move_PC(PC *pc, bool flag_stop_move)
{
	bool flag_move = false;
	
	// Ajx̐ݒ
	if(g_bTiming[pc->move_speed] && !flag_stop_move){
		static bool		flag_arrowkeydown = false;	// L[Ă邩
		
		if(pc->interval_ct == g_set.move_interval_pc){
			// ŌɉꂽA邢͈ĂL[̔ԍ擾
			Get_LastKeyState(&(pc->idxDir), &flag_arrowkeydown);
			if(flag_arrowkeydown){
				pc->interval_ct = 0;
			}
		}
		
		static long		next_view_x,next_view_y,next_pos_x,next_pos_y;
		static POINT	ptView,ptPos;				// C^[oړ
		static bool		flag_poison = false;
		
		if(flag_poison){	// łŃ_[W󂯂Ƃ̕`ʒuύX
			static int		pos_ct = 0;
			const POINT		pos_damage[2] = {{-2,-2},{2,2}};
			pc->pos.x += pos_damage[pos_ct].x;
			pc->pos.y += pos_damage[pos_ct].y;
			pos_ct ++;
			if(pos_ct >= 2){
				pos_ct = 0;
				flag_poison = false;
			}
		}
		else{
			if(pc->interval_ct == 0){
				int	pos_hitmap[5],pos_center[4],view_limit[4],pos_limit[4];
				pc->pos_hit.x = (pc->view.x + pc->pos.x) / HIT_SIZE;
				pc->pos_hit.y = (pc->view.y + pc->pos.y - (pc->img_size[1] - HIT_SIZE)) / HIT_SIZE + (pc->img_size[1] - 1) / HIT_SIZE;
				// ړ̓蔻ŕKvȕϐ߂
				Calculate_HitVal(pc, pos_hitmap, pos_center, view_limit, pos_limit);
				// XN[ʒuPC̈ʒu擾
				next_view_x = pc->view.x;
				next_view_y = pc->view.y;
				next_pos_x  = pc->pos.x;
				next_pos_y  = pc->pos.y;
				Get_ScrAndPos_Bin(pc->idxDir, HIT_SIZE, pos_hitmap, pos_center,
							view_limit, pos_limit, &next_view_x, &next_view_y, &next_pos_x, &next_pos_y);
				ptView.x = (next_view_x - pc->view.x) / g_set.move_interval_pc;
				ptView.y = (next_view_y - pc->view.y) / g_set.move_interval_pc;
				ptPos.x  = (next_pos_x - pc->pos.x) / g_set.move_interval_pc;
				ptPos.y  = (next_pos_y - pc->pos.y) / g_set.move_interval_pc;
				// 蔻̐ݒ
				gMapData[pc->pos_hit.y * gMapSizeX + pc->pos_hit.x] &= ~BIT_MASK_HIT16_0;
				pc->pos_hit.x += (ptView.x + ptPos.x) * g_set.move_interval_pc / HIT_SIZE;
				pc->pos_hit.y += (ptView.y + ptPos.y) * g_set.move_interval_pc / HIT_SIZE;
				gMapData[pc->pos_hit.y * gMapSizeX + pc->pos_hit.x] |= BIT_MASK_HIT16_0;
				// łɂ_[W
				if((pc->ability.condition & 0x01) && pc->kindScene != 2){
					pc->poison_move_ct ++;
					if(pc->poison_move_ct >= g_set.poison_interval){
						pc->poison_move_ct = 0;
						pc->hitPoint -= pc->damagePoison;
						if(pc->hitPoint <= 0){	// = ͕Kv
							pc->hitPoint = 0;
						}
						flag_poison = true;
					}
				}
			}
			else if(pc->interval_ct == g_set.move_interval_pc - 1
					&& (next_view_x != pc->view.x || next_view_y != pc->view.y
					|| next_pos_x != pc->pos.x || next_pos_y != pc->pos.y))
			{
				flag_move = true;
			}
			
			if(!flag_arrowkeydown){
				pc->posBm.x = 1;
			}
			
			if(pc->interval_ct < g_set.move_interval_pc){
				pc->view.x += ptView.x;
				pc->view.y += ptView.y;
				pc->pos.x  += ptPos.x;
				pc->pos.y  += ptPos.y;
				// PC̈ړAj̃R}ς
				static int	idx_anim_PC = 0;
				pc->posBm.x = Get_Bm_X(&idx_anim_PC, g_pc.img_pos_idx[0]);
				// C^[o JEg̉Z
				pc->interval_ct ++;
			}
		}
	}
	return flag_move;
}// Move_PC

// ړ̓蔻ŕKvȕϐ߂
void Calculate_HitVal(PC *pc, int *pos_hitmap, int *pos_center, int *scr_limit, int *pos_limit)
{
	// ݂̃L[ԍ (0:down, 1:left, 2:right, 3:up, 4:current)B 4  pos_hitmap ̂
	// 蔻z̗vfԍ
	pos_hitmap[0] = (pc->pos_hit.y + 1) * gMapSizeX + pc->pos_hit.x;
	pos_hitmap[1] = pc->pos_hit.y       * gMapSizeX + (pc->pos_hit.x - 1);
	pos_hitmap[2] = pc->pos_hit.y       * gMapSizeX + (pc->pos_hit.x + 1);
	pos_hitmap[3] = (pc->pos_hit.y - 1) * gMapSizeX + pc->pos_hit.x;
	pos_hitmap[4] = pc->pos_hit.y * gMapSizeX + pc->pos_hit.x;
	for(int i=0;i<4;i++){
		if(pos_hitmap[i] < 0)
			pos_hitmap[i] = 0;
	}
	// PC̈ړ\͈
	pos_center[0] = gViewCenterPos.y + g_set.no_scroll_area.y - HIT_SIZE;
	pos_center[1] = gViewCenterPos.x - g_set.no_scroll_area.x;
	pos_center[2] = gViewCenterPos.x + g_set.no_scroll_area.x - HIT_SIZE;
	pos_center[3] = gViewCenterPos.y - g_set.no_scroll_area.y;
	// XN[̌Eʒu
	scr_limit[0] = (gMapSizeY - MAP_VIEW_SIZE_Y) * CHIP_SIZE;
	scr_limit[1] = 0;
	scr_limit[2] = (gMapSizeX - MAP_VIEW_SIZE_X) * CHIP_SIZE;
	scr_limit[3] = 0;
	// PC̈ړEʒu
	pos_limit[0] = MAP_VIEW_SIZE_Y * CHIP_SIZE - pc->img_size[1];
	pos_limit[1] = 0;
	pos_limit[2] = MAP_VIEW_SIZE_X * CHIP_SIZE - pc->img_size[0];
	pos_limit[3] = - CHIP_SIZE;
}// Calculate_HitVal

// ړAj̃R}ς
int Get_Bm_X(int *idx_anim, int *anim_ct)
{
	(*idx_anim) ++;
	if(*idx_anim > 3){
		*idx_anim = 0;
	}
	return anim_ct[*idx_anim];
}// Get_Bm_X

// NPCƉb
// ߂l	:	true  b, false  bI or Ȃ
bool Talk_Npc(CDib *buf, PC *pc)
{
	if(!g_sn.npc_index || !g_npc.inf){
		return false;
	}
	
	static int	idx_talking = -1;		// bNPC̔ԍ
	static int	idx_talking_pre = -1;	// ȑObĂNPC̔ԍ
	static bool	flag_next = false;		// y[W̕\w
	static int	pre_npcCharaBm_y = 0;
	static bool	flag_interruption = false;
	static bool	flag_once = true;		// tO
	static int	idxTalkBack = 0;		// wi摜ԍ
	static int	nMarginX = 0;
	static char	*strTalk = "";
	static RECT rc_face = {0, 0, 0, 0};	// 摜̈ʒuƃTCY
	static RECT rc1;
	static RECT rc2;
	static RECT rcSrc;
	const int	half_thick = (g_set.line_thick + 1) / 2;
	
	if(g_key[1].space || g_key[1].enter){
		if(flag_once){
			if(g_sn.npc_index && g_npc.inf){
				for(int i=0;i<g_sn.npc_index_num;i++){
					int idxNpc = g_sn.npc_index[i];
					if(idxNpc >= 0 && idxNpc < g_npc.num){
						if(!g_npc.inf[idxNpc].flag_talking && g_npc.inf[idxNpc].flag_show){
							if(pc->idxDir == 0 && g_npc.inf[idxNpc].posNow.x == pc->pos_hit.x && g_npc.inf[idxNpc].posNow.y == pc->pos_hit.y + 1){
								g_npc.inf[idxNpc].flag_talking = true;
								idx_talking = idxNpc;
								pre_npcCharaBm_y = g_npc.inf[idxNpc].posBm.y;
								g_npc.inf[idxNpc].posBm.y = g_npc.inf[idxNpc].img_pos_idx[1][3];
								break;
							}
							else if(pc->idxDir == 1 && g_npc.inf[idxNpc].posNow.x == pc->pos_hit.x - 1 && g_npc.inf[idxNpc].posNow.y == pc->pos_hit.y){
								g_npc.inf[idxNpc].flag_talking = true;
								idx_talking = idxNpc;
								pre_npcCharaBm_y = g_npc.inf[idxNpc].posBm.y;
								g_npc.inf[idxNpc].posBm.y = g_npc.inf[idxNpc].img_pos_idx[1][2];
								break;
							}
							else if(pc->idxDir == 2 && g_npc.inf[idxNpc].posNow.x == pc->pos_hit.x + 1 && g_npc.inf[idxNpc].posNow.y == pc->pos_hit.y){
								g_npc.inf[idxNpc].flag_talking = true;
								idx_talking = idxNpc;
								pre_npcCharaBm_y = g_npc.inf[idxNpc].posBm.y;
								g_npc.inf[idxNpc].posBm.y = g_npc.inf[idxNpc].img_pos_idx[1][1];
								break;
							}
							else if(pc->idxDir == 3 && g_npc.inf[idxNpc].posNow.x == pc->pos_hit.x && g_npc.inf[idxNpc].posNow.y == pc->pos_hit.y - 1){
								g_npc.inf[idxNpc].flag_talking = true;
								idx_talking = idxNpc;
								pre_npcCharaBm_y = g_npc.inf[idxNpc].posBm.y;
								g_npc.inf[idxNpc].posBm.y = g_npc.inf[idxNpc].img_pos_idx[1][0];
								break;
							}
						}
					}
				}
			}
			if(idx_talking >= 0 && idx_talking < g_npc.num && g_npc.inf[idx_talking].idxFlag == -1){
				g_npc.inf[idx_talking].posBm.y = pre_npcCharaBm_y;
				g_npc.inf[idx_talking].flag_talking = false;
				idx_talking = -1;
			}
			if(idx_talking == -1){
				return false;
			}
		}
		// y[W̕\w
		if(idx_talking_pre != -1){
			flag_next = true;
		}
		idx_talking_pre = idx_talking;
	}
	else if(idx_talking == -1){
		return false;
	}
	
	if(g_key[1].esc){
		flag_interruption = true;
	}
	
	// 
	if(idx_talking != -1 && flag_once && (pc->interval_ct == g_set.move_interval_pc)){
		flag_once = false;
		
		// NPC ̈ړ
		switch (pc->idxDir)
		{
		case 0:	// 
			g_npc.inf[idx_talking].posNow2.x = pc->view.x + pc->pos.x;
			g_npc.inf[idx_talking].posNow2.y = pc->view.y + pc->pos.y + HIT_SIZE;
			break;
		case 1:	// 
			g_npc.inf[idx_talking].posNow2.x = pc->view.x + pc->pos.x - g_npc.inf[idx_talking].img_size[0];
			g_npc.inf[idx_talking].posNow2.y = pc->view.y + pc->pos.y;
			break;
		case 2:	// E
			g_npc.inf[idx_talking].posNow2.x = pc->view.x + pc->pos.x + g_npc.inf[idx_talking].img_size[0];
			g_npc.inf[idx_talking].posNow2.y = pc->view.y + pc->pos.y;
			break;
		case 3:	// 
			g_npc.inf[idx_talking].posNow2.x = pc->view.x + pc->pos.x;
			g_npc.inf[idx_talking].posNow2.y = pc->view.y + pc->pos.y - HIT_SIZE;
			break;
		}
		g_npc.inf[idx_talking].posBm.x = 1;
		g_npc.inf[idx_talking].interval_ct = 0;
		// PC ̃L`bv摜ύX
		pc->posBm.x = 1;
		Set_BmEventSel(&g_bm_select[0], 10);
		SAFE_DELETE(g_bm_face_talk);
		SAFE_DELETE(g_bm_face_talk2);
		// CxgR}h̉
		Parse_EventFlag(pc, g_npc.inf[idx_talking].idxFlag);
		// e`̐ݒ
		int money_hgt = g_set.item_height + g_set.line_thick;
		SetRect(&rc1, 0, g_set.talk_y, SCREEN_WIDTH, SCREEN_HEIGHT);
		if(gEf.bShowMoney){
			rc1.top -= money_hgt;
		}
		SetRect(&rc2, 0, rc1.top, rc1.right, rc1.bottom);
		SetRect(&rcSrc, 0, 0, rc1.right, SCREEN_HEIGHT - rc1.top);
		// Iꍇ
		if(gEf.nSelect > 0){
			if(g_set.flag_back_bmp)
				rc2.left = g_set.menu_width3;
			else
				rc2.left = gEf.wdhSelect + g_set.line_thick + 10;
		}
		// 摜\ꍇ
		if(g_bm_face_talk || g_bm_face_talk2){
			SetRect(&rc_face, 0, 0, gEf.width, gEf.height);
			if(g_set.flag_talk_face == 0 || g_set.flag_talk_face == 1){
				nMarginX = g_set.line_thick;
			}
			else if(g_set.flag_talk_face == 2 || g_set.flag_talk_face == 3){
				nMarginX = rc_face.right - rc_face.left;
				rc2.left += nMarginX;
				if(g_set.flag_talk_face == 2){
					rc2.left += g_set.line_thick;
				}
			}
		}
		int money_y = rcSrc.bottom - money_hgt - half_thick;
		SAFE_DELETE(g_bm_talk_back);
		if(g_set.flag_back_bmp){
			if(gEf.nSelect > 0){
				if(gEf.bShowMoney)
					idxTalkBack = 19;
				else
					idxTalkBack = 18;
			}
			else{
				idxTalkBack = 17;
			}
			g_bm_talk_back = new CDib(g_inb.inf[idxTalkBack].name);
		}
		else{
			g_bm_talk_back = new CDib(rcSrc.right, rcSrc.bottom);
			DIB_DrawFrameCls(g_bm_talk_back, rcSrc, g_set.line_thick, g_set.rgb_line, g_set.rgb_back_talk);
			if(!gEf.bShowMoney){
				DIB_DrawLine(g_bm_talk_back, rc2.left, rcSrc.top + half_thick, rc2.left, rcSrc.bottom - half_thick, g_set.line_thick, g_set.rgb_line);
			}
			else{
				DIB_DrawLine(g_bm_talk_back, rc2.left, rcSrc.top + half_thick, rc2.left, money_y, g_set.line_thick, g_set.rgb_line);
				DIB_DrawLine(g_bm_talk_back, rc1.left, money_y, rc1.right - g_set.line_thick, money_y, g_set.line_thick, g_set.rgb_line);
			}
		}
		if(gEf.bShowMoney){
			char strMoney[256];
			sprintf(strMoney, " %d %s", pc->ability.money, g_set.denomi_name);
			DIB_DrawFont2(g_bm_talk_back, strMoney, g_set.event_font_size, rc1.left + g_set.line_thick + 5, money_y + 5, g_set.font_color[0]);
		}
		// 摜̕`i`ʒȕꍇj
		if((g_bm_face_talk || g_bm_face_talk2) && g_bm_talk_back){
			if(g_set.flag_talk_face == 2)
				Draw_Dib(g_bm_talk_back, g_bm_face_talk, g_bm_face_talk2, gEf.idxAlpha,
						g_set.line_thick, g_set.line_thick, rc_face.right, rc_face.bottom, 32);
			else if(g_set.flag_talk_face == 3)
				Draw_Dib(g_bm_talk_back, g_bm_face_talk, g_bm_face_talk2, gEf.idxAlpha,
						0, 0, rc_face.right, rc_face.bottom, 32);
		}
		strTalk = NULL;
		if(gEf.idxTalk >= 0 && gEf.idxTalk < g_talk.num && g_talk.str && g_talk.str[gEf.idxTalk]){
			strTalk = g_talk.str[gEf.idxTalk];
		}
	}
	
	if(flag_once){
		return false;
	}
	
	static int	idx_talk_end = 0;	// ݂̉b̐is󋵁i0:o͒, 1:Sďo͊, 2:tF[hAEgIj
	static bool	flag_waiting = true;// tF[hAEgtOitrue:ҋ@, false:Jnj
	static int	idx_act = 0;		// ݃tH[JX̂ACe̔ԍi0:, 1:, 2:߂j
	static int	fade_ct = 0;
	
	RECT rc3;
	int	i;
	
	// wi̕`
	if(g_bm_talk_back){
		if(g_set.flag_back_bmp){
			DIB_DrawRateAlpha2(buf, rc1.left, rc1.top, g_bm_talk_back, rcSrc, fade_ct * 2, DIB_RGB_MAKE(g_inb.inf[idxTalkBack].colorkey_red, g_inb.inf[idxTalkBack].colorkey_green, g_inb.inf[idxTalkBack].colorkey_blue), fade_ct);
		}
		else{
			DIB_DrawRateAlpha2(buf, rc1.left, rc1.top, g_bm_talk_back, rcSrc, fade_ct * 2, g_set.rgb_back_talk, fade_ct);
		}
		if((g_bm_face_talk || g_bm_face_talk2) && g_set.flag_talk_face == 1){
			int face_y = rc1.top - (rc_face.bottom - rc_face.top);
			Draw_Dib(buf, g_bm_face_talk, g_bm_face_talk2, gEf.idxAlpha,
					0, face_y, rc_face.right, rc_face.bottom, fade_ct * 2);
		}
	}
	for(i=0;i<gEf.nSelect;i++){
		SetRect(&rc3, nMarginX, rc2.top + g_set.item_height * i, rc2.left -  g_set.line_thick / 2, rc2.top + g_set.item_height * (i + 1));
		if(g_set.flag_talk_face == 2){
			rc3.left += g_set.line_thick;
		}
		if(i == idx_act && idx_talk_end > 0){
			if(fade_ct == g_set.fade_max_talk){
				if(g_bm_select[0]){
					DIB_DrawRateAlpha(buf, rc3.left, rc3.top, g_bm_select[0], 0, 0, g_bm_select[0]->GetWidth(), g_bm_select[0]->GetHeight(), g_set.alpha_select);
				}
				DIB_DrawFont2(buf, gEf.strSelect[i], g_set.event_font_size, nMarginX + g_set.pos_menu_item.x, rc3.top + g_set.pos_menu_item.y, g_set.font_color[0]);
			}
		}
		else{
			if(fade_ct == g_set.fade_max_talk)
				DIB_DrawFont2(buf, gEf.strSelect[i], g_set.event_font_size, nMarginX + g_set.pos_menu_item.x, rc3.top + g_set.pos_menu_item.y, g_set.font_color[1]);
		}
	}
	// ̕`
	idx_talk_end = Talk(buf, rc2, (unsigned char*) strTalk, &fade_ct, &flag_next, flag_interruption, flag_waiting);
	
	// ʉ̍Đ
	if(idx_talk_end >= 1){
		Play_Wave(gEf.idxWaveAfter);
		gEf.idxWaveAfter = -1;
	}
	
	if((idx_talk_end >= 1) && flag_waiting && gEf.nSelect > 0){
		if(g_key[1].left || g_key[1].up){
			idx_act --;
			if(idx_act < 0)
				idx_act = gEf.nSelect - 1;
		}
		else if(g_key[1].right || g_key[1].down){
			idx_act ++;
			if(idx_act >= gEf.nSelect)
				idx_act = 0;
		}
		if(g_key[1].esc){
			if(fade_ct > 0){
				flag_interruption = true;
				flag_waiting = false;
			}
		}
	}
	if(g_key[1].space || g_key[1].enter){
		if(idx_talk_end == 1 && flag_waiting){
			if(idx_act >= 0 && idx_act < gEf.nSelect &&
				gEf.nEventFlag[idx_act] >= 0 && gEf.nEventFlag[idx_act] < g_sn.evt_cmd_num)
			{
				Parse_EventFlag(pc, gEf.idxSelect[idx_act]);
			}
			flag_waiting = false;
			flag_next = true;
		}
	}
	
	// b̏I
	if(idx_talk_end == 2 && idx_talking != -1){
		g_npc.inf[idx_talking].flag_talking = false;
		g_npc.inf[idx_talking].posBm.y = pre_npcCharaBm_y;
		pre_npcCharaBm_y = 0;
		idx_talking = -1;
		idx_talking_pre = -1;
		idx_talk_end = 0;
		idxTalkBack = 0;
		fade_ct = 0;
		flag_next = false;
		flag_interruption = false;
		flag_once = true;
		flag_waiting = true;
		idx_act = 0;
		nMarginX = 0;
		SetRect(&rc_face, 0, 0, 0, 0);
		SetRect(&rc1, 0, g_set.talk_y, SCREEN_WIDTH, SCREEN_HEIGHT);
		SetRect(&rc2, 0, rc1.top + g_set.line_thick, rc1.right, rc1.bottom - g_set.line_thick);
		SetRect(&rcSrc, 0, 0, rc1.right, SCREEN_HEIGHT - rc1.top);
		SAFE_DELETE(g_bm_face_talk);
		SAFE_DELETE(g_bm_face_talk2);
		SAFE_DELETE(g_bm_talk_back);
		SAFE_DELETE(g_bm_select[0]);
		gEf.idxTalk = -1;
		return false;
	}
	
	return true;
}// Talk_Npc

// 󔠂J
bool Open_Treasure(PC *pc)
{
	static int	idx_open = -1;		// J󔠔ԍ
	
	if(g_key[1].space || g_key[1].enter){
		if(g_sn.tre_index && g_tre.inf &&
				!((pc->view.x + pc->pos.x) % HIT_SIZE) &&
				!((pc->view.y + pc->pos.y - (pc->img_size[1] - HIT_SIZE)) % HIT_SIZE)){
			for(int i=0;i<g_sn.tre_index_num;i++){
				int idxTre = g_sn.tre_index[i];
				if(idxTre >= 0 && idxTre < g_tre.num){
					if(g_tre.inf[idxTre].flag_show)
					{
						if(pc->idxDir == 0 && g_tre.inf[idxTre].pt.x == pc->pos_hit.x && g_tre.inf[idxTre].pt.y == pc->pos_hit.y + 1){
							idx_open = idxTre;
							break;
						}
						else if(pc->idxDir == 1 && g_tre.inf[idxTre].pt.x == pc->pos_hit.x - 1 && g_tre.inf[idxTre].pt.y == pc->pos_hit.y){
							idx_open = idxTre;
							break;
						}
						else if(pc->idxDir == 2 && g_tre.inf[idxTre].pt.x == pc->pos_hit.x + 1 && g_tre.inf[idxTre].pt.y == pc->pos_hit.y){
							idx_open = idxTre;
							break;
						}
						else if(pc->idxDir == 3 && g_tre.inf[idxTre].pt.x == pc->pos_hit.x && g_tre.inf[idxTre].pt.y == pc->pos_hit.y - 1){
							idx_open = idxTre;
							break;
						}
					}
				}
			}
		}
		if(idx_open == -1){
			return false;
		}
		if(!g_tre.inf[idx_open].flag_once || !g_tre.inf[idx_open].flag_opened){
			g_tre.inf[idx_open].flag_opened = TRUE;
			// CxgR}h̉
			Parse_EventFlag(pc, g_tre.inf[idx_open].idxFlag);
		}
		idx_open = -1;
	}
	else if(idx_open == -1){
		return false;
	}
	
	return true;
}// Open_Treasure

// ʂς
// pc		: [IN][OUT]	pc
// ߂l	:			true  ʕύX, false  ʕύXI or Ȃ
bool Change_Scene(CDib *buf, PC *pc)
{
	if(!gbScene){
		return false;
	}
	
	static bool	flag_scene_changing = false;
	static bool	flag_fade_in_start = false;
	
	// tF[hAEg
	if(!flag_fade_in_start)
	{
		static int	fade_out_ct = 33,pre_fade_out_ct = 33;
		
		fade_out_ct = Fade_Out_Sub(buf);
		if(pre_fade_out_ct == 33){				// tF[hAEgJn
			flag_scene_changing = true;
		}
		else if(fade_out_ct > pre_fade_out_ct){	// tF[hAEgI
			fade_out_ct = 33;
			gIdxScene = gEf.idxSceneNext;
			flag_fade_in_start = true;
		}
		pre_fade_out_ct = fade_out_ct;
	}
	// tF[hC
	if(flag_fade_in_start){
		static int	fade_in_ct = -1,pre_fade_in_ct = -1;
		
		fade_in_ct = Fade_In_Sub(buf);
		if(pre_fade_in_ct == -1){				// tF[hCJn
			char scene_file[MAX_PATH];
			_snprintf(scene_file, sizeof(scene_file), "scene%d.txt", gIdxScene);
			if(!Load_Scene(scene_file)){
				SysErrMsgDisp("ʃf[^ǂݍ߂܂");
			}
			else{
				Play_Midi(g_sn.idxMidi);
				pc->kindScene = g_sn.kindScene;
				if(!Load_MapData(g_sn.filenameMapData)){
					SysErrMsgDisp("BIN t@Cǂݍ߂܂");
				}
				else{
					Load_BgMapChip(g_sn.filenameBgMapChip);
					Load_LyerMapChip(g_sn.imginfLyerMapChip.name,
									DIB_RGB_MAKE(g_sn.imginfLyerMapChip.colorkey_red,
												g_sn.imginfLyerMapChip.colorkey_green,
												g_sn.imginfLyerMapChip.colorkey_blue));
					
					POINT	next_view = {0,0};
					POINT	next_pos = {0,0};
					POINT	map_size = Get_MapSize();
					POINT	tipNext;
					tipNext.x = gEf.tipPtNext.x - gViewCenterPos.x / HIT_SIZE;
					tipNext.y = gEf.tipPtNext.y - gViewCenterPos.y / HIT_SIZE;
					if(gEf.tipPtNext.x <= MAP_VIEW_SIZE_X / 2){
						next_pos.x = tipNext.x;
					}
					else if(gEf.tipPtNext.x >= (map_size.x - MAP_VIEW_SIZE_X / 2)){
						next_view.x = (map_size.x - MAP_VIEW_SIZE_X);
						next_pos.x = tipNext.x - next_view.x;
					}
					else{
						next_view.x = tipNext.x;
					}
					if(gEf.tipPtNext.y <= MAP_VIEW_SIZE_Y / 2){
						next_pos.y = tipNext.y;
					}
					else if(gEf.tipPtNext.y >= (map_size.y - MAP_VIEW_SIZE_Y / 2)){
						next_view.y = (map_size.y - MAP_VIEW_SIZE_Y);
						next_pos.y = tipNext.y - next_view.y;
					}
					else{
						next_view.y = tipNext.y;
					}
					pc->view.x = next_view.x * HIT_SIZE;
					pc->view.y = next_view.y * HIT_SIZE;
					pc->pos.x  = gViewCenterPos.x + next_pos.x * HIT_SIZE;
					pc->pos.y  = gViewCenterPos.y + (next_pos.y - (((pc->img_size[1] - 1) / HIT_SIZE))) * HIT_SIZE;
					pc->interval_ct = g_set.move_interval_pc;
					
					// NPCE󔠏̍XV
					Init_NpcTre();
				}
			}
		}
		else if(fade_in_ct < pre_fade_in_ct){	// tF[hCI
			fade_in_ct = -1;
			flag_scene_changing = false;
			flag_fade_in_start = false;
			gbScene = false;
			// ʉ̍Đ
			Play_Wave(gEf.idxWaveAfter);
			gEf.idxWaveAfter = -1;
			// CxgR}h̉
			Parse_EventFlag(pc, gEf.idxFlag);
		}
		pre_fade_in_ct = fade_in_ct;
	}
	return flag_scene_changing;
}// Change_Scene

// NPCE󔠏̍XV
void Init_NpcTre()
{
	int i;
	// NPC̍XV
	if(g_sn.npc_index && g_npc.inf){
		for(i=0;i<g_sn.npc_index_num;i++){
			int idxNpc = g_sn.npc_index[i];
			if(idxNpc >= 0 && idxNpc < g_npc.num){
				g_npc.inf[idxNpc].posNow2.x = g_npc.inf[idxNpc].posNow.x * HIT_SIZE;
				g_npc.inf[idxNpc].posNow2.y = (g_npc.inf[idxNpc].posNow.y - (((g_npc.inf[idxNpc].img_size[1] - 1) / HIT_SIZE))) * HIT_SIZE + (g_npc.inf[idxNpc].img_size[1] - HIT_SIZE);
				if(g_npc.inf[idxNpc].flag_show && (!g_npc.inf[idxNpc].typeMove || (!g_npc.inf[idxNpc].areaMove.x && !g_npc.inf[idxNpc].areaMove.y))){
					gMapData[g_npc.inf[idxNpc].posNow.y * gMapSizeX + g_npc.inf[idxNpc].posNow.x] |= BIT_MASK_HIT16_0;
				}
				g_npc.inf[idxNpc].posBm.y += g_npc.inf[idxNpc].img_pos_idx[1][g_npc.inf[idxNpc].idxDir];
				g_npc.inf[idxNpc].TickCount = GetTickCount();
				g_npc.inf[idxNpc].interval_ct = 0;
			}
		}
	}
	
	// 󔠏̍XV
	if(g_sn.tre_index && g_tre.inf){
		for(i=0;i<g_sn.tre_index_num;i++){
			int idxTre = g_sn.tre_index[i];
			if(idxTre >= 0 && idxTre < g_tre.num){
				if(g_tre.inf[idxTre].flag_show){
					int idxEffect = g_tre.inf[idxTre].idxEffect;
					if(g_ine.inf && idxEffect >= 0 && idxEffect < g_ine.num){
						g_tre.inf[idxTre].pt2.x = g_tre.inf[idxTre].pt.x * HIT_SIZE;
						g_tre.inf[idxTre].pt2.y = (g_tre.inf[idxTre].pt.y - (((g_ine.inf[idxEffect].inf3.height - 1) / HIT_SIZE))) * HIT_SIZE + (g_ine.inf[idxEffect].inf3.height - HIT_SIZE);
					}
					gMapData[g_tre.inf[idxTre].pt.y * gMapSizeX + g_tre.inf[idxTre].pt.x] |= BIT_MASK_HIT16_0;
				}
				g_tre.inf[idxTre].TickCount = GetTickCount();
			}
		}
	}
}// Init_NpcTre

void Term_RpgChara()
{
	SAFE_DELETE(g_bm_face_talk);
	SAFE_DELETE(g_bm_face_talk2);
	SAFE_DELETE(g_bm_talk_back);
	SAFE_DELETE(g_bm_select[0]);
	SAFE_FREE(g_chara_scene);
	gIdxScene = 0;
}// Term_RpgChara

#endif
