#ifndef __RPGFILE_H__
#define __RPGFILE_H__

bool Load_MapData(char *filename);
bool Load_Prepare();
bool Load_StartGame();
bool Load_BGM();
bool Load_Sound();
bool Load_Title();
bool Load_Narration();
bool Load_Talk();
bool Load_Item();
bool Load_Shop();
bool Load_LevelList();
bool Load_LevelAbility();
bool Load_Monster();
bool Load_Enemy();
bool Load_Magic();
bool Load_BackImage();
bool Load_SelImage();
bool Load_FaceImage();
bool Load_Effect();
bool Load_MapAnim(char *filename);
bool Load_Treasure();
bool Load_PC();
bool Load_NPC();
bool Load_Scene(char *filename);
bool Load_Setting();
bool Load_Data_Coded(char *filename);
bool Load_Bin(char *filename);
bool Load_Bin_Sub(FILE *fp, char *filename);

// }bvf[^̓ǂݍ
bool Load_MapData(char *filename)
{
	char filename_code[MAX_PATH];
	strncpy(filename_code, filename, sizeof(filename_code));
	char *p2 = strrchr(filename_code, '.');
	if(p2 + 1)
		strcpy(p2 + 1, "b");
	if(!Load_Data_Coded(filename_code)){
		if(!Load_Bin(filename)){
			return false;
		}
	}
	return true;
}// Load_MapData

// prepare.dat ̓ǂݍ
bool Load_Prepare()
{
	if(!Load_Data_Coded("prepare.d")){
		if(!Load_Bin("prepare.dat")){
			if(!Load_Prepare("prepare.txt")){
				return false;
			}
		}
	}
	return true;
}// Load_Prepare

// Q[ݒ̓ǂݍ
bool Load_StartGame()
{
	if(!Load_Data_Coded("start_game.d")){
		if(!Load_Bin("start_game.dat")){
			if(!Load_StartGame("start_game.txt")){
				return false;
			}
		}
	}
	return true;
}// Load_StartGame

// midi_list.dat ̓ǂݍ
bool Load_BGM()
{
	if(!Load_Data_Coded("midi_list.d")){
		if(!Load_Bin("midi_list.dat")){
			if(!Load_MidiList("midi_list.txt")){
				return false;
			}
		}
	}
	return true;
}// Load_BGM

// wave_list.dat ̓ǂݍ
bool Load_Sound()
{
	if(!Load_Data_Coded("wave_list.d")){
		if(!Load_Bin("wave_list.dat")){
			if(!Load_WaveList("wave_list.txt")){
				return false;
			}
		}
	}
	return true;
}// Load_Sound

// ^Cgݒ̓ǂݍ
bool Load_Title()
{
	if(!Load_Data_Coded("title.d")){
		if(!Load_Bin("title.dat")){
			if(!Load_Title("title.txt")){
				return false;
			}
		}
	}
	return true;
}// Load_Title

// i[V Xg̓ǂݍ
bool Load_Narration()
{
	if(!Load_Data_Coded("narration_list.d")){
		if(!Load_Bin("narration_list.dat")){
			if(!Load_NarrationList("narration_list.txt")){
				return false;
			}
		}
	}
	return true;
}// Load_Narration

// bXg̓ǂݍ
bool Load_Talk()
{
	if(!Load_Data_Coded("talk_list.d")){
		if(!Load_Bin("talk_list.dat")){
			if(!Load_TalkList("talk_list.txt")){
				return false;
			}
		}
	}
	return true;
}// Load_Talk

// ACe Xg̓ǂݍ
bool Load_Item()
{
	if(!Load_Data_Coded("item_list.d")){
		if(!Load_Bin("item_list.dat")){
			if(!Load_ItemList("item_list.txt")){
				return false;
			}
		}
	}
	return true;
}// Load_Item

// XXg̓ǂݍ
bool Load_Shop()
{
	if(!Load_Data_Coded("shop_list.d")){
		if(!Load_Bin("shop_list.dat")){
			if(!Load_ShopList("shop_list.txt")){
				return false;
			}
		}
	}
	return true;
}// Load_Shop

// x Xg̓ǂݍ
bool Load_LevelList()
{
	if(!Load_Data_Coded("level_list.d")){
		if(!Load_Bin("level_list.dat")){
			if(!Load_LevelList("level_list.txt")){
				return false;
			}
		}
	}
	return true;
}// Load_LevelList

// x\͒lAbv Xg̓ǂݍ
bool Load_LevelAbility()
{
	if(!Load_Data_Coded("level_ability_list.d")){
		if(!Load_Bin("level_ability_list.dat")){
			if(!Load_LevelAbilityList("level_ability_list.txt")){
				return false;
			}
		}
	}
	return true;
}// Load_LevelAbility

// Xg̓ǂݍ
bool Load_Monster()
{
	if(!Load_Data_Coded("monster_list.d")){
		if(!Load_Bin("monster_list.dat")){
			if(!Load_MonsterList("monster_list.txt")){
				return false;
			}
		}
	}
	return true;
}// Load_Monster

// Gjbg Xg̓ǂݍ
bool Load_Enemy()
{
	if(!Load_Data_Coded("enemy_list.d")){
		if(!Load_Bin("enemy_list.dat")){
			if(!Load_EnemyList("enemy_list.txt")){
				return false;
			}
		}
	}
	return true;
}// Load_Enemy

// @Xg̓ǂݍ
bool Load_Magic()
{
	if(!Load_Data_Coded("magic_list.d")){
		if(!Load_Bin("magic_list.dat")){
			if(!Load_MagicList("magic_list.txt")){
				return false;
			}
		}
	}
	return true;
}// Load_Magic

// wi摜Xg̓ǂݍ
bool Load_BackImage()
{
	if(!Load_Data_Coded("image_back.d")){
		if(!Load_Bin("image_back.dat")){
			if(!Load_BackImageFileName("image_back.txt")){
				return false;
			}
		}
	}
	return true;
}// Load_BackImage

// I摜Xg̓ǂݍ
bool Load_SelImage()
{
	if(!Load_Data_Coded("image_select.d")){
		if(!Load_Bin("image_select.dat")){
			if(!Load_SelImageFileName("image_select.txt")){
				return false;
			}
		}
	}
	return true;
}// Load_SelImage

// 摜Xg̓ǂݍ
bool Load_FaceImage()
{
	if(!Load_Data_Coded("image_face.d")){
		if(!Load_Bin("image_face.dat")){
			if(!Load_FaceImageFileName("image_face.txt")){
				return false;
			}
		}
	}
	return true;
}// Load_FaceImage

// GtFNg Xg̓ǂݍ
bool Load_Effect()
{
	if(!Load_Data_Coded("image_effect.d")){
		if(!Load_Bin("image_effect.dat")){
			if(!Load_EffectFileName("image_effect.txt")){
				return false;
			}
		}
	}
	return true;
}// Load_Effect

// }bvAj̓ǂݍ
bool Load_MapAnim(char *filename)
{
	char filename_bin[MAX_PATH];
	char filename_code[MAX_PATH];
	strncpy(filename_bin, filename, sizeof(filename_bin));
	strncpy(filename_code, filename, sizeof(filename_code));
	char *p = strrchr(filename_bin, '.');
	if(p + 1)
		strcpy(p + 1, "dat");
	char *p2 = strrchr(filename_code, '.');
	if(p2 + 1)
		strcpy(p2 + 1, "d");
	if(!Load_Data_Coded(filename_code)){
		if(!Load_Bin(filename_bin)){
			if(!Load_MapAnimFileName(filename)){
				return false;
			}
		}
	}
	return true;
}// Load_MapAnim

// 󔠃Xg̓ǂݍ
bool Load_Treasure()
{
	if(!Load_Data_Coded("treasure_list.d")){
		if(!Load_Bin("treasure_list.dat")){
			if(!Load_TreasureList("treasure_list.txt")){
				return false;
			}
		}
	}
	return true;
}// Load_Treasure

// PC ̓ǂݍ
bool Load_PC()
{
	if(!Load_Data_Coded("pc.d")){
		if(!Load_Bin("pc.dat")){
			if(!Load_PC("pc.txt")){
				return false;
			}
		}
	}
	return true;
}// Load_PC

// NPC Xg̓ǂݍ
bool Load_NPC()
{
	if(!Load_Data_Coded("npc_list.d")){
		if(!Load_Bin("npc_list.dat")){
			if(!Load_NpcList("npc_list.txt")){
				return false;
			}
		}
	}
	return true;
}// Load_NPC

// ʃf[^̓ǂݍ
bool Load_Scene(char *filename)
{
	char filename_bin[MAX_PATH];
	char filename_code[MAX_PATH];
	strncpy(filename_bin, filename, sizeof(filename_bin));
	strncpy(filename_code, filename, sizeof(filename_code));
	char *p = strrchr(filename_bin, '.');
	if(p + 1)
		strcpy(p + 1, "dat");
	char *p2 = strrchr(filename_code, '.');
	if(p2 + 1)
		strcpy(p2 + 1, "d");
	if(!Load_Data_Coded(filename_code)){
		if(!Load_Bin(filename_bin)){
			if(!Load_SceneData(filename)){
				return false;
			}
		}
	}
	if(strcmp(g_sn.filenameMapAnim, "")){
		Load_MapAnim(g_sn.filenameMapAnim);
	}
	return true;
}// Load_Scene

// {ݒ̓ǂݍ
bool Load_Setting()
{
	if(!Load_Data_Coded("setting.d")){
		if(!Load_Bin("setting.dat")){
			if(!Load_Setting("setting.txt")){
				return false;
			}
		}
	}
	return true;
}// Load_Setting

// Ít@C̓ǂݍ
bool Load_Data_Coded(char *filename)
{
	bool ret = false;
	char *p = strrchr(filename, '.');
	if((p + 1) && strlen(p + 1) == 1){	// gqP̏ꍇ
		char	filename2[MAX_PATH];
		_snprintf(filename2, sizeof(filename2)-1, ".\\%s\\%s", g_dir.strData, filename);
		int type = Is_Compress(filename2) ? 2 : 0;
		int size = Get_FileSize(type, filename2);
		if(size == 0){
			return false;
		}
		BYTE *pData = (BYTE*) malloc(size);
		if(pData){
			ZeroMemory(pData, size);
			ret = Decode_File(type, CODE_KEY, (BYTE*) pData, size, filename2);
			FILE	*fpT;
			if((fpT = tmpfile()) == NULL){
				free(pData);
				pData = NULL;
				return false;
			}
			
			fwrite(pData, sizeof(BYTE), size, fpT);
			rewind(fpT);
			Load_Bin_Sub(fpT, filename);
			fclose(fpT);
			_rmtmp();
			free(pData);
			pData = NULL;
		}
	}
	return ret;
}// Load_Data_Coded

// oCi f[^ t@C̓ǂݍ
bool Load_Bin(char *filename)
{
	bool ret = false;
	char *p = strrchr(filename, '.');
	if((p + 1) && (!stricmp(p + 1, "dat") || !stricmp(p + 1, "bin"))){
		char	filename2[MAX_PATH];
		_snprintf(filename2, sizeof(filename2)-1, ".\\%s\\%s", g_dir.strData, filename);
		FILE *fp = fopen(filename2, "rb");
		if(!fp){
			return false;
		}
		Load_Bin_Sub(fp, filename);
		fclose(fp);
		ret = true;
	}
	return ret;
}// Load_Bin

bool Load_Bin_Sub(FILE *fp, char *filename)
{
	bool ret = false;
	char filename2[MAX_PATH],strExt[MAX_PATH];
	strncpy(filename2, filename, sizeof(filename2));
	char *p = strrchr(filename2, '.');
	if(p){
		strncpy(strExt, p, sizeof(strExt));
		strcpy(p, "");
	}
	if(!stricmp(strExt, ".bin") || !stricmp(strExt, ".b"))
		ret = Load_MapData_Bin(fp);
	else if(!stricmp(filename2, "prepare"))
		ret = Load_Prepare_Bin(fp);
	else if(!stricmp(filename2, "start_game"))
		ret = Load_StartGame_Bin(fp);
	else if(!stricmp(filename2, "midi_list"))
		ret = Load_BGM_Bin(fp);
	else if(!stricmp(filename2, "wave_list"))
		ret = Load_Sound_Bin(fp);
	else if(!stricmp(filename2, "title"))
		ret = Load_Title_Bin(fp);
	else if(!stricmp(filename2, "narration_list"))
		ret = Load_Narration_Bin(fp);
	else if(!stricmp(filename2, "talk_list"))
		ret = Load_Talk_Bin(fp);
	else if(!stricmp(filename2, "item_list"))
		ret = Load_Item_Bin(fp);
	else if(!stricmp(filename2, "shop_list"))
		ret = Load_Shop_Bin(fp);
	else if(!stricmp(filename2, "level_list"))
		ret = Load_LevelList_Bin(fp);
	else if(!stricmp(filename2, "level_ability_list"))
		ret = Load_LevelAbility_Bin(fp);
	else if(!stricmp(filename2, "monster_list"))
		ret = Load_Monster_Bin(fp);
	else if(!stricmp(filename2, "enemy_list"))
		ret = Load_Enemy_Bin(fp);
	else if(!stricmp(filename2, "magic_list"))
		ret = Load_Magic_Bin(fp);
	else if(!stricmp(filename2, "image_back"))
		ret = Load_BackImage_Bin(fp);
	else if(!stricmp(filename2, "image_select"))
		ret = Load_SelImage_Bin(fp);
	else if(!stricmp(filename2, "image_face"))
		ret = Load_FaceImage_Bin(fp);
	else if(!stricmp(filename2, "image_effect"))
		ret = Load_Effect_Bin(fp);
	else if(!_strnicmp(filename2, "map_anim", 7))
		ret = Load_MapAnim_Bin(fp);
	else if(!stricmp(filename2, "treasure_list"))
		ret = Load_Treasure_Bin(fp);
	else if(!stricmp(filename2, "pc"))
		ret = Load_PC_Bin(fp);
	else if(!stricmp(filename2, "npc_list"))
		ret = Load_NPC_Bin(fp);
	else if(!_strnicmp(filename2, "scene", 5))
		ret = Load_Scene_Bin(fp);
	else if(!stricmp(filename2, "setting"))
		ret = Load_Setting_Bin(fp);
	else
		ret = false;
	return ret;
}// Load_Bin

#endif