#ifndef __RPGFILEBIN_H__
#define __RPGFILEBIN_H__

#define TAG_LEN 			256		// ^O̍ő啶

typedef struct{
	int	red;		// 
	int	green;		// 
	int	blue;		// 
}COLOR,*LPCOLOR;

char g_tag_prepare[][TAG_LEN] = {	"folder_name_data","folder_name_image",
									"folder_name_audio","load_image"};
char g_tag_start_game[][TAG_LEN] = {"start_scene_index"};
char g_tag_midi[][TAG_LEN] = {"midi_number","midi_data"};
char g_tag_wave[][TAG_LEN] = {"wave_number","wave_data"};
char g_tag_title[][TAG_LEN] = {	"midi_index","menu_pos","menu_item_height",
								"font_size","font_color","menu_item_number",
								"menu_item_data"};
char g_tag_nar[][TAG_LEN] = {"narration_number","narration_data"};
char g_tag_talk[][TAG_LEN] = {"talk_number","talk_data"};
char g_tag_item[][TAG_LEN] = {"item_number","item_data"};
char g_tag_shop[][TAG_LEN] = {"shop_number","shop_data"};
char g_tag_level_list[][TAG_LEN] = {"level_number","level_data","level_add","level_max"};
char g_tag_level_ability[][TAG_LEN] = {"level_ability_number","level_ability_data","level_ability_message"};
char g_tag_monster[][TAG_LEN] = {"monster_number","monster_data"};
char g_tag_enemy[][TAG_LEN] = {"enemy_number","enemy_data"};
char g_tag_magic[][TAG_LEN] = {"magic_number","magic_data"};
char g_tag_image_back[][TAG_LEN] = {"image_back_number","image_back_data"};
char g_tag_image_sel[][TAG_LEN] = {"image_sel_number","image_sel_data"};
char g_tag_image_face[][TAG_LEN] = {"image_face_number","image_face_data"};
char g_tag_image_effect[][TAG_LEN] = {"image_effect_number","image_effect_data"};
char g_tag_map_anim[][TAG_LEN] = {"map_anim_main_data","map_anim_number","map_anim_data"};
char g_tag_treasure[][TAG_LEN] = {"treasure_number","treasure_data"};
char g_tag_pc[][TAG_LEN] = {"pc_name","pc_main_data","pc_image_data","pc_equipment_number","pc_equipment_data","pc_item_max_number","pc_item_number","pc_item_data"};
char g_tag_npc[][TAG_LEN] = {"npc_number","npc_data"};
char g_tag_scene[][TAG_LEN] = {"scene_kind","scene_name","filename_map_data","filename_bg_map_chip","lyer_map_chip","midi_index","scene_change_number","scene_change_data","npc_index_number","npc_index_data","treasure_index_number","treasure_index_data","battle_number","battle_data","battle_field_data","anim_field_filename","anim_field_data","event_pos_number","event_pos_data","flag_number","flag_cmd_number","flag_cmd_data"};
char g_tag_setting[][TAG_LEN] = {"title","img_focus","effect_arrow_talk","effect_arrow_menu1","effect_arrow_menu2","effect_bare","wave_bare","wave_battle","wave_poison","wave_equip_set","wave_equip_remove","midi_level_up","midi_gameover","denomi_name","line_thick","flag_battle_alpha","flag_back_bmp","alpha_select","rgb_line","rgb_back","rgb_battle_item","alpha_battle_item","rgb_back_talk","fade_max_talk","flag_talk_face","talk_y","poison_interval","move_interval_pc","move_interval_npc","no_scroll_area","straight_max","game_speed","fade_speed","turn_speed","enemy_attack_speed","damage_speed","enemy_damage_speed","focus_speed","letter_speed","font_name","font_weight","font_color","event_font_size","talk_font_size","ability_max","item_own_num","item_sell_rate","buy_disp_num","sell_disp_num","menu_disp_num1","menu_disp_num2","battle_disp_num","save_disp_num","battle_item_y","battle_wait1","battle_wait2","save_max","menu_width1","menu_width2","menu_width3","item_height","fade_increment_monster","fade_increment_talk","vol_all","vol_bgm","vol_sound","key_interval","talk_margin","pos_menu_item","critical_rate","ampl_damage","ampl_damage_crt","dist_enemy_attack","effect_wave_crt","vol_sound_crt"};

int gMapSizeX	= 0;		// `bv/}bvij
int gMapSizeY	= 0;		// `bv/}bvicj

unsigned long	*gMapData = NULL;		// }bvf[^

bool Load_MapData_Bin(FILE *fp);
bool Load_Prepare_Bin(FILE *fp);
bool Load_StartGame_Bin(FILE *fp);
bool Load_BGM_Bin(FILE *fp);
bool Load_Sound_Bin(FILE *fp);
bool Load_Title_Bin(FILE *fp);
bool Load_Narration_Bin(FILE *fp);
bool Load_Talk_Bin(FILE *fp);
bool Load_Item_Bin(FILE *fp);
bool Load_Shop_Bin(FILE *fp);
bool Load_LevelList_Bin(FILE *fp);
bool Load_LevelAbility_Bin(FILE *fp);
bool Load_Monster_Bin(FILE *fp);
bool Load_Enemy_Bin(FILE *fp);
bool Load_Magic_Bin(FILE *fp);
bool Load_BackImage_Bin(FILE *fp);
bool Load_SelImage_Bin(FILE *fp);
bool Load_FaceImage_Bin(FILE *fp);
bool Load_Effect_Bin(FILE *fp);
bool Load_MapAnim_Bin(FILE *fp);
bool Load_Treasure_Bin(FILE *fp);
bool Load_PC_Bin(FILE *fp);
bool Load_NPC_Bin(FILE *fp);
bool Load_Scene_Bin(FILE *fp);
bool Load_Setting_Bin(FILE *fp);

//	}bvf[^ǂݍ
bool Load_MapData_Bin(FILE *fp)
{
	if (fp != NULL) {
		// WAcW̓ǂݍ
		gMapSizeX  = fgetc(fp);
		gMapSizeX |= fgetc(fp) << 8;
		gMapSizeX |= fgetc(fp) << 16;
		gMapSizeX |= fgetc(fp) << 24;
		
		gMapSizeY  = fgetc(fp);
		gMapSizeY |= fgetc(fp) << 8;
		gMapSizeY |= fgetc(fp) << 16;
		gMapSizeY |= fgetc(fp) << 24;
		
		// }bvf[^zm
		int i;
		int size = sizeof(unsigned long) * gMapSizeX * gMapSizeY;
		SAFE_FREE(gMapData);
		gMapData = (unsigned long *)malloc(size);
		ZeroMemory(gMapData, size);
		
		// zɊi[
		unsigned char *p = (unsigned char *)gMapData;
		
		for (i = 0; i < size; i++) {
			if (feof(fp)){
				SAFE_FREE(gMapData);
				return false;
			}
			*p = fgetc(fp);
			p++;
		}
		
		return true;
	}
	return false;
}// Load_MapData_Bin

// prepare.dat ̓ǂݍ݁ioCij
bool Load_Prepare_Bin(FILE *fp)
{
	UINT	len_tag,size;
	int		k,len,tg,tag_num;
	char	tag[TAG_LEN];
	
	ZeroMemory(&g_dir, sizeof(g_dir));
	
	fread(&tag_num, sizeof(int), 1, fp);
	for(tg=0; tg<tag_num; tg++){
		int read_size = fread(&len_tag, sizeof(int), 1, fp);
		if(read_size < 1){
			break;
		}
		if(len_tag > sizeof(tag))	len_tag = sizeof(tag);
		fread(tag, sizeof(char), len_tag, fp);
		fread(&size, sizeof(int), 1, fp);
		bool flag = false;
		for(k=0; k<sizeof(g_tag_prepare) / sizeof(g_tag_prepare[0]); k++){
			if(!strcmp(tag,  g_tag_prepare[k])){
				flag = true;
switch(k)
{
case 0:
	{
		fread(&len, sizeof(int), 1, fp);
		fread(g_dir.strData, sizeof(char), len, fp);
	}
	break;
case 1:
	{
		fread(&len, sizeof(int), 1, fp);
		fread(g_dir.strImage, sizeof(char), len, fp);
	}
	break;
case 2:
	{
		fread(&len, sizeof(int), 1, fp);
		fread(g_dir.strAudio, sizeof(char), len, fp);
	}
	break;
case 3:
	{
		fread(&len, sizeof(int), 1, fp);
		fread(g_dir.strLoadImage, sizeof(char), len, fp);
	}
	break;
}
				break;
			}
		}
		if(!flag)
			fseek(fp, size, SEEK_CUR);		// ǂݔ΂
	}
	
	return true;
}// Load_Prepare_Bin

// Q[ݒ̓ǂݍ݁ioCij
bool Load_StartGame_Bin(FILE *fp)
{
	UINT	len_tag,size;
	int		k,tg,tag_num;
	char	tag[TAG_LEN];
	
	fread(&tag_num, sizeof(int), 1, fp);
	for(tg=0; tg<tag_num; tg++){
		int read_size = fread(&len_tag, sizeof(int), 1, fp);
		if(read_size < 1){
			break;
		}
		if(len_tag > sizeof(tag))	len_tag = sizeof(tag);
		fread(tag, sizeof(char), len_tag, fp);
		fread(&size, sizeof(int), 1, fp);
		bool flag = false;
		for(k=0; k<sizeof(g_tag_start_game) / sizeof(g_tag_start_game[0]); k++){
			if(!strcmp(tag,  g_tag_start_game[k])){
				flag = true;
switch(k)
{
case 0:
	fread(&gIdxScene, sizeof(int), 1, fp);
	break;
}
				break;
			}
		}
		if(!flag)
			fseek(fp, size, SEEK_CUR);		// ǂݔ΂
	}
	
	return true;
}// Load_StartGame_Bin

// midi_list.dat ̓ǂݍ݁ioCij
bool Load_BGM_Bin(FILE *fp)
{
	UINT	len_tag,size;
	int		i,k,tg,tag_num,len,bgm_num = 0;
	char	tag[TAG_LEN];
	char	filename3[MAX_PATH];
	
	fread(&tag_num, sizeof(int), 1, fp);
	for(tg=0; tg<tag_num; tg++){
		int read_size = fread(&len_tag, sizeof(int), 1, fp);
		if(read_size < 1){
			break;
		}
		if(len_tag > sizeof(tag))	len_tag = sizeof(tag);
		fread(tag, sizeof(char), len_tag, fp);
		fread(&size, sizeof(int), 1, fp);
		bool flag = false;
		for(k=0; k<sizeof(g_tag_midi) / sizeof(g_tag_midi[0]); k++){
			if(!strcmp(tag,  g_tag_midi[k])){
				flag = true;
switch(k)
{
case 0:
	fread(&bgm_num, sizeof(int), 1, fp);
	if(bgm_num > BGM_MAX){
		bgm_num = BGM_MAX;
	}
	break;
case 1:
	for(i=0; i<bgm_num; i++){
		fread(&len, sizeof(int), 1, fp);
		char bgm_name[MAX_PATH];
		fread(bgm_name, sizeof(char), len, fp);
		sprintf(filename3, "%s\\%s", g_dir.strAudio, bgm_name);
		Load_BGM_RPG(i, filename3, g_set.vol_bgm);
	}
	break;
}
				break;
			}
		}
		if(!flag)
			fseek(fp, size, SEEK_CUR);		// ǂݔ΂
	}
	
	return true;
}// Load_BGM_Bin

// wave_list.dat ̓ǂݍ݁ioCij
bool Load_Sound_Bin(FILE *fp)
{
	UINT	len_tag,size;
	int		i,k,tg,tag_num,len,snd_num = 0;
	char	tag[TAG_LEN];
	char	filename3[MAX_PATH];
	
	fread(&tag_num, sizeof(int), 1, fp);
	for(tg=0; tg<tag_num; tg++){
		int read_size = fread(&len_tag, sizeof(int), 1, fp);
		if(read_size < 1){
			break;
		}
		if(len_tag > sizeof(tag))	len_tag = sizeof(tag);
		fread(tag, sizeof(char), len_tag, fp);
		fread(&size, sizeof(int), 1, fp);
		bool flag = false;
		for(k=0; k<sizeof(g_tag_wave) / sizeof(g_tag_wave[0]); k++){
			if(!strcmp(tag,  g_tag_wave[k])){
				flag = true;
switch(k)
{
case 0:
	fread(&snd_num, sizeof(int), 1, fp);
	if(snd_num > SOUND_MAX){
		snd_num = SOUND_MAX;
	}
	break;
case 1:
	for(i=0; i<snd_num; i++){
		fread(&len, sizeof(int), 1, fp);
		char snd_name[MAX_PATH];
		fread(snd_name, sizeof(char), len, fp);
		sprintf(filename3, "%s\\%s", g_dir.strAudio, snd_name);
		Load_SND_RPG(i, filename3, g_set.vol_sound);
	}
	break;
}
				break;
			}
		}
		if(!flag)
			fseek(fp, size, SEEK_CUR);		// ǂݔ΂
	}
	
	return true;
}// Load_Sound_Bin

// ^Cgݒ̓ǂݍ݁ioCij
bool Load_Title_Bin(FILE *fp)
{
	UINT	len_tag,size;
	int		i,k,tg,tag_num,len;
	char	tag[TAG_LEN];
	
	ZeroMemory(&g_t, sizeof(g_t));
	
	fread(&tag_num, sizeof(int), 1, fp);
	for(tg=0; tg<tag_num; tg++){
		int read_size = fread(&len_tag, sizeof(int), 1, fp);
		if(read_size < 1){
			break;
		}
		if(len_tag > sizeof(tag))	len_tag = sizeof(tag);
		fread(tag, sizeof(char), len_tag, fp);
		fread(&size, sizeof(int), 1, fp);
		bool flag = false;
		for(k=0; k<sizeof(g_tag_title) / sizeof(g_tag_title[0]); k++){
			if(!strcmp(tag,  g_tag_title[k])){
				flag = true;
switch(k)
{
case 0:
	fread(&g_t.idxMidi, sizeof(int), 1, fp);
	break;
case 1:
	fread(&g_t.ptSelect, sizeof(POINT), 1, fp);
	break;
case 2:
	fread(&g_t.hgtSelect, sizeof(int), 1, fp);
	break;
case 3:
	fread(&g_t.sizeFont, sizeof(int), 1, fp);
	break;
case 4:
	{
		COLOR clr[4];
		fread(clr, sizeof(COLOR), 4, fp);
		for(i=0; i<4; i++){
			g_t.colorFont[i] = RGB(clr[i].red, clr[i].green, clr[i].blue);
		}
	}
	break;
case 5:
	fread(&g_t.nSelect, sizeof(int), 1, fp);
	if(g_t.nSelect > TITLE_ITEM_MAX){
		g_t.nSelect = TITLE_ITEM_MAX;
	}
	break;
case 6:
	for(i=0; i<g_t.nSelect; i++){
		fread(&g_t.bFadeOutSelect[i], sizeof(BOOL), 1, fp);
		fread(&g_t.idxSelect[i], sizeof(int), 1, fp);
		fread(&len, sizeof(int), 1, fp);
		fread(g_t.strSelect[i], sizeof(char), len, fp);
	}
	break;
}
				break;
			}
		}
		if(!flag)
			fseek(fp, size, SEEK_CUR);		// ǂݔ΂
	}
	
	return true;
}// Load_Title_Bin

// i[V Xg̓ǂݍ݁ioCij
bool Load_Narration_Bin(FILE *fp)
{
	UINT	len_tag,size;
	int		i,k,tg,tag_num,len;
	char	tag[TAG_LEN];
	char	filename3[MAX_PATH];
	
	if(g_n.inf){
		SAFE_FREE(g_n.inf);
	}
	
	fread(&tag_num, sizeof(int), 1, fp);
	for(tg=0; tg<tag_num; tg++){
		int read_size = fread(&len_tag, sizeof(int), 1, fp);
		if(read_size < 1){
			break;
		}
		if(len_tag > sizeof(tag))	len_tag = sizeof(tag);
		fread(tag, sizeof(char), len_tag, fp);
		fread(&size, sizeof(int), 1, fp);
		bool flag = false;
		for(k=0; k<sizeof(g_tag_nar) / sizeof(g_tag_nar[0]); k++){
			if(!strcmp(tag,  g_tag_nar[k])){
				flag = true;
switch(k)
{
case 0:
	{
		fread(&g_n.num, sizeof(int), 1, fp);
		int size2 = sizeof(NARRATION) * g_n.num;
		g_n.inf = (LPNARRATION) malloc(size2);
		if(g_n.inf){
			ZeroMemory(g_n.inf, size2);
		}
	}
	break;
case 1:
	if(g_n.inf){
		for(i=0; i<g_n.num; i++){
			fread(&g_n.inf[i].idxTalk, sizeof(int), 1, fp);
			fread(&g_n.inf[i].sizeFont, sizeof(int), 1, fp);
			COLOR clr;
			fread(&clr, sizeof(COLOR), 1, fp);
			g_n.inf[i].colorFont = RGB(clr.red, clr.green, clr.blue);
			fread(&g_n.inf[i].rcTalk, sizeof(RECT), 1, fp);
			fread(&g_n.inf[i].nLetterSpeed, sizeof(int), 1, fp);
			fread(&g_n.inf[i].nWaitTime1, sizeof(int), 1, fp);
			fread(&g_n.inf[i].nWaitTime2, sizeof(int), 1, fp);
			fread(&len, sizeof(int), 1, fp);
			fread(filename3, sizeof(char), len, fp);
			sprintf(g_n.inf[i].nameImg, "%s\\%s", g_dir.strImage, filename3);
			fread(&g_n.inf[i].idxMidi, sizeof(int), 1, fp);
		}
	}
	break;
}
				break;
			}
		}
		if(!flag)
			fseek(fp, size, SEEK_CUR);		// ǂݔ΂
	}
	
	return true;
}// Load_Narration_Bin

// talk_list.dat ̓ǂݍ݁ioCij
bool Load_Talk_Bin(FILE *fp)
{
	UINT	len_tag,size;
	int		i,k,tg,tag_num,len;
	char	tag[TAG_LEN];
	
	if(g_talk.str){
		for(i=0;i<g_talk.num;i++){
			SAFE_FREE(g_talk.str[i]);
		}
		SAFE_FREE(g_talk.str);
	}
	g_talk.num = 0;
	
	fread(&tag_num, sizeof(int), 1, fp);
	for(tg=0; tg<tag_num; tg++){
		int read_size = fread(&len_tag, sizeof(int), 1, fp);
		if(read_size < 1){
			break;
		}
		if(len_tag > sizeof(tag))	len_tag = sizeof(tag);
		fread(tag, sizeof(char), len_tag, fp);
		fread(&size, sizeof(int), 1, fp);
		bool flag = false;
		for(k=0; k<sizeof(g_tag_talk) / sizeof(g_tag_talk[0]); k++){
			if(!strcmp(tag,  g_tag_talk[k])){
				flag = true;
switch(k)
{
case 0:
	{
		fread(&g_talk.num, sizeof(int), 1, fp);
		int size2 = sizeof(char*) * g_talk.num;
			g_talk.str = (char**) malloc(size2);
			if(g_talk.str)
				ZeroMemory(g_talk.str, size2);
	}
	break;
case 1:
	if(g_talk.str){
		for(i=0; i<g_talk.num; i++){
			fread(&len, sizeof(int), 1, fp);
			g_talk.str[i] = (char*) malloc(len + 1);
			if(g_talk.str[i]){
				fread(g_talk.str[i], sizeof(char), len, fp);
				g_talk.str[i][len] = '\0';
			}
			else{
				fseek(fp, len, SEEK_CUR);
			}
		}
	}
	break;
}
				break;
			}
		}
		if(!flag)
			fseek(fp, size, SEEK_CUR);		// ǂݔ΂
	}
	
	return true;
}// Load_Talk_Bin

// item_list.dat ̓ǂݍ݁ioCij
bool Load_Item_Bin(FILE *fp)
{
	UINT	len_tag,size;
	int		k,tg,tag_num;
	char	tag[TAG_LEN];
	
	SAFE_FREE(g_item.inf);
	g_item.num = 0;
	
	fread(&tag_num, sizeof(int), 1, fp);
	for(tg=0; tg<tag_num; tg++){
		int read_size = fread(&len_tag, sizeof(int), 1, fp);
		if(read_size < 1){
			break;
		}
		if(len_tag > sizeof(tag))	len_tag = sizeof(tag);
		fread(tag, sizeof(char), len_tag, fp);
		fread(&size, sizeof(int), 1, fp);
		bool flag = false;
		for(k=0; k<sizeof(g_tag_item) / sizeof(g_tag_item[0]); k++){
			if(!strcmp(tag,  g_tag_item[k])){
				flag = true;
switch(k)
{
case 0:
	{
		fread(&g_item.num, sizeof(int), 1, fp);
		int size2 = sizeof(ITEM) * g_item.num;
		g_item.inf = (LPITEM) malloc(size2);
		if(g_item.inf)
			ZeroMemory(g_item.inf, size2);
	}
	break;
case 1:
	if(g_item.inf){
		fread(g_item.inf, sizeof(ITEM), g_item.num, fp);
	}
	break;
}
				break;
			}
		}
		if(!flag)
			fseek(fp, size, SEEK_CUR);		// ǂݔ΂
	}
	
	return true;
}// Load_Item_Bin

// shop_list.dat ̓ǂݍ݁ioCij
bool Load_Shop_Bin(FILE *fp)
{
	UINT	len_tag,size;
	int		i,j,k,tg,tag_num,len;
	char	tag[TAG_LEN];
	char	filename3[MAX_PATH];
	
	if(g_shop.inf){
		for(i=0;i<g_shop.num;i++){
			SAFE_FREE(g_shop.inf[i].item_index);
		}
		SAFE_FREE(g_shop.inf);
	}
	g_shop.num = 0;
	
	fread(&tag_num, sizeof(int), 1, fp);
	for(tg=0; tg<tag_num; tg++){
		int read_size = fread(&len_tag, sizeof(int), 1, fp);
		if(read_size < 1){
			break;
		}
		if(len_tag > sizeof(tag))	len_tag = sizeof(tag);
		fread(tag, sizeof(char), len_tag, fp);
		fread(&size, sizeof(int), 1, fp);
		bool flag = false;
		for(k=0; k<sizeof(g_tag_shop) / sizeof(g_tag_shop[0]); k++){
			if(!strcmp(tag,  g_tag_shop[k])){
				flag = true;
switch(k)
{
case 0:
	{
		fread(&g_shop.num, sizeof(int), 1, fp);
		int size2 = sizeof(SHOP) * g_shop.num;
		g_shop.inf = (LPSHOP) malloc(size2);
		if(g_shop.inf){
			ZeroMemory(g_shop.inf, size2);
		}
	}
	break;
case 1:
	for(i=0; i<g_shop.num; i++){
		fread(&g_shop.inf[i].kind, sizeof(int), 1, fp);
		fread(&len, sizeof(int), 1, fp);
		fread(filename3, sizeof(char), len, fp);
		sprintf(g_shop.inf[i].filenameBgBuy, "%s\\%s", g_dir.strImage, filename3);
		fread(&len, sizeof(int), 1, fp);
		fread(filename3, sizeof(char), len, fp);
		sprintf(g_shop.inf[i].filenameBgSell, "%s\\%s", g_dir.strImage, filename3);
		fread(&g_shop.inf[i].item_num, sizeof(int), 1, fp);
		int size2 = sizeof(int) * g_shop.inf[i].item_num;
		g_shop.inf[i].item_index = (LPINT) malloc(size2);
		if(g_shop.inf[i].item_index){
			ZeroMemory(g_shop.inf[i].item_index, size2);
			for(j=0; j<g_shop.inf[i].item_num; j++){
				fread(&g_shop.inf[i].item_index[j], sizeof(int), 1, fp);
			}
		}
	}
	break;
}
				break;
			}
		}
		if(!flag)
			fseek(fp, size, SEEK_CUR);		// ǂݔ΂
	}
	
	return true;
}// Load_Shop_Bin

// level_list.dat ̓ǂݍ݁ioCij
bool Load_LevelList_Bin(FILE *fp)
{
	UINT	len_tag,size;
	int		k,tg,tag_num;
	char	tag[TAG_LEN];
	
	SAFE_FREE(g_level.exp);
	g_level.exp_num = 0;
	
	fread(&tag_num, sizeof(int), 1, fp);
	for(tg=0; tg<tag_num; tg++){
		int read_size = fread(&len_tag, sizeof(int), 1, fp);
		if(read_size < 1){
			break;
		}
		if(len_tag > sizeof(tag))	len_tag = sizeof(tag);
		fread(tag, sizeof(char), len_tag, fp);
		fread(&size, sizeof(int), 1, fp);
		bool flag = false;
		for(k=0; k<sizeof(g_tag_level_list) / sizeof(g_tag_level_list[0]); k++){
			if(!strcmp(tag,  g_tag_level_list[k])){
				flag = true;
switch(k)
{
case 0:
	{
		fread(&g_level.exp_num, sizeof(int), 1, fp);
		int size2 = sizeof(LEVEL1) * g_level.exp_num;
		g_level.exp = (LPLEVEL1) malloc(size2);
		if(g_level.exp)
			ZeroMemory(g_level.exp, size2);
	}
	break;
case 1:
	if(g_level.exp){
		fread(g_level.exp, sizeof(LEVEL1), g_level.exp_num, fp);
	}
	break;
case 2:
	fread(&g_level.add, sizeof(LEVEL1), 1, fp);
	break;
case 3:
	fread(&g_level.max, sizeof(int), 1, fp);
	break;
}
				break;
			}
		}
		if(!flag)
			fseek(fp, size, SEEK_CUR);		// ǂݔ΂
	}
	
	return true;
}// Load_LevelList_Bin

// level_ability_list.dat ̓ǂݍ݁ioCij
bool Load_LevelAbility_Bin(FILE *fp)
{
	UINT	len_tag,size;
	int		k,tg,tag_num;
	char	tag[TAG_LEN];
	
	SAFE_FREE(g_lvlabl.la);
	g_lvlabl.num = 0;
	
	fread(&tag_num, sizeof(int), 1, fp);
	for(tg=0; tg<tag_num; tg++){
		int read_size = fread(&len_tag, sizeof(int), 1, fp);
		if(read_size < 1){
			break;
		}
		if(len_tag > sizeof(tag))	len_tag = sizeof(tag);
		fread(tag, sizeof(char), len_tag, fp);
		fread(&size, sizeof(int), 1, fp);
		bool flag = false;
		for(k=0; k<sizeof(g_tag_level_ability) / sizeof(g_tag_level_ability[0]); k++){
			if(!strcmp(tag,  g_tag_level_ability[k])){
				flag = true;
switch(k)
{
case 0:
	{
		fread(&g_lvlabl.num, sizeof(int), 1, fp);
		int size2 = sizeof(LEVELABILITY1) * g_lvlabl.num;
		g_lvlabl.la = (LPLEVELABILITY1) malloc(size2);
		if(g_lvlabl.la)
			ZeroMemory(g_lvlabl.la, size2);
	}
	break;
case 1:
	if(g_lvlabl.la){
		fread(g_lvlabl.la, sizeof(LEVELABILITY1), g_lvlabl.num, fp);
	}
	break;
case 2:
	{
		int len;
		fread(&len, sizeof(int), 1, fp);
		fread(g_lvlabl.str, sizeof(char), len, fp);
	}
	break;
}
				break;
			}
		}
		if(!flag)
			fseek(fp, size, SEEK_CUR);		// ǂݔ΂
	}
	
	return true;
}// Load_LevelAbility_Bin

// monster_list.dat ̓ǂݍ݁ioCij
bool Load_Monster_Bin(FILE *fp)
{
	UINT	len_tag,size;
	int		k,tg,tag_num;
	char	tag[TAG_LEN];
	
	SAFE_FREE(g_monster.inf);
	g_monster.num = 0;
	
	fread(&tag_num, sizeof(int), 1, fp);
	for(tg=0; tg<tag_num; tg++){
		int read_size = fread(&len_tag, sizeof(int), 1, fp);
		if(read_size < 1){
			break;
		}
		if(len_tag > sizeof(tag))	len_tag = sizeof(tag);
		fread(tag, sizeof(char), len_tag, fp);
		fread(&size, sizeof(int), 1, fp);
		bool flag = false;
		for(k=0; k<sizeof(g_tag_monster) / sizeof(g_tag_monster[0]); k++){
			if(!strcmp(tag,  g_tag_monster[k])){
				flag = true;
switch(k)
{
case 0:
	{
		fread(&g_monster.num, sizeof(int), 1, fp);
		int size2 = sizeof(MONSTER) * g_monster.num;
		g_monster.inf = (LPMONSTER) malloc(size2);
		if(g_monster.inf)
			ZeroMemory(g_monster.inf, size2);
	}
	break;
case 1:
	if(g_monster.inf){
		fread(g_monster.inf, sizeof(MONSTER), g_monster.num, fp);
		char strBuf[MAX_PATH];
		for(int i=0; i<g_monster.num; i++){
			strcpy(strBuf, g_monster.inf[i].fileName);
			sprintf(g_monster.inf[i].fileName, "%s\\%s", g_dir.strImage, strBuf);
		}
	}
	break;
}
				break;
			}
		}
		if(!flag)
			fseek(fp, size, SEEK_CUR);		// ǂݔ΂
	}
	
	return true;
}// Load_Monster_Bin

// enemy_list.dat ̓ǂݍ݁ioCij
bool Load_Enemy_Bin(FILE *fp)
{
	UINT	len_tag,size;
	int		i,k,tg,tag_num;
	char	tag[TAG_LEN];
	
	if(g_enemy.inf){
		for(i=0;i<g_enemy.num;i++){
			SAFE_FREE(g_enemy.inf[i].inf);
		}
		SAFE_FREE(g_enemy.inf);
	}
	g_enemy.num = 0;
	
	fread(&tag_num, sizeof(int), 1, fp);
	for(tg=0; tg<tag_num; tg++){
		int read_size = fread(&len_tag, sizeof(int), 1, fp);
		if(read_size < 1){
			break;
		}
		if(len_tag > sizeof(tag))	len_tag = sizeof(tag);
		fread(tag, sizeof(char), len_tag, fp);
		fread(&size, sizeof(int), 1, fp);
		bool flag = false;
		for(k=0; k<sizeof(g_tag_enemy) / sizeof(g_tag_enemy[0]); k++){
			if(!strcmp(tag,  g_tag_enemy[k])){
				flag = true;
switch(k)
{
case 0:
	{
		fread(&g_enemy.num, sizeof(int), 1, fp);
		int size2 = sizeof(ENEMIES2) * g_enemy.num;
		g_enemy.inf = (LPENEMIES2) malloc(size2);
		if(g_enemy.inf)
			ZeroMemory(g_enemy.inf, size2);
	}
	break;
case 1:
	if(g_enemy.inf){
		for(i=0; i<g_enemy.num; i++){
			fread(&g_enemy.inf[i].num, sizeof(int), 1, fp);
			int size2 = sizeof(ENEMIES) * g_enemy.inf[i].num;
			g_enemy.inf[i].inf = (LPENEMIES) malloc(size2);
			if(g_enemy.inf[i].inf){
				fread(g_enemy.inf[i].inf, sizeof(ENEMIES), g_enemy.inf[i].num, fp);
			}
		}
	}
	break;
}
				break;
			}
		}
		if(!flag)
			fseek(fp, size, SEEK_CUR);		// ǂݔ΂
	}
	
	return true;
}// Load_Enemy_Bin

// magic_list.dat ̓ǂݍ݁ioCij
bool Load_Magic_Bin(FILE *fp)
{
	UINT	len_tag,size;
	int		k,tg,tag_num;
	char	tag[TAG_LEN];
	
	SAFE_FREE(g_magic.inf);
	g_magic.num = 0;
	
	fread(&tag_num, sizeof(int), 1, fp);
	for(tg=0; tg<tag_num; tg++){
		int read_size = fread(&len_tag, sizeof(int), 1, fp);
		if(read_size < 1){
			break;
		}
		if(len_tag > sizeof(tag))	len_tag = sizeof(tag);
		fread(tag, sizeof(char), len_tag, fp);
		fread(&size, sizeof(int), 1, fp);
		bool flag = false;
		for(k=0; k<sizeof(g_tag_magic) / sizeof(g_tag_magic[0]); k++){
			if(!strcmp(tag,  g_tag_magic[k])){
				flag = true;
switch(k)
{
case 0:
	{
		fread(&g_magic.num, sizeof(int), 1, fp);
		int size2 = sizeof(MAGIC) * g_magic.num;
		g_magic.inf = (LPMAGIC) malloc(size2);
		if(g_magic.inf)
			ZeroMemory(g_magic.inf, size2);
	}
	break;
case 1:
	if(g_magic.inf){
		fread(g_magic.inf, sizeof(MAGIC), g_magic.num, fp);
	}
	break;
}
				break;
			}
		}
		if(!flag)
			fseek(fp, size, SEEK_CUR);		// ǂݔ΂
	}
	
	return true;
}// Load_Magic_Bin

// image_back.dat ̓ǂݍ݁ioCij
bool Load_BackImage_Bin(FILE *fp)
{
	UINT	len_tag,size;
	int		i,k,tg,tag_num;
	char	tag[TAG_LEN];
	char	filename3[MAX_PATH];
	
	g_inb.num = 0;
	SAFE_FREE(g_inb.inf);
	
	fread(&tag_num, sizeof(int), 1, fp);
	for(tg=0; tg<tag_num; tg++){
		int read_size = fread(&len_tag, sizeof(int), 1, fp);
		if(read_size < 1){
			break;
		}
		if(len_tag > sizeof(tag))	len_tag = sizeof(tag);
		fread(tag, sizeof(char), len_tag, fp);
		fread(&size, sizeof(int), 1, fp);
		bool flag = false;
		for(k=0; k<sizeof(g_tag_image_back) / sizeof(g_tag_image_back[0]); k++){
			if(!strcmp(tag,  g_tag_image_back[k])){
				flag = true;
switch(k)
{
case 0:
	{
		fread(&g_inb.num, sizeof(int), 1, fp);
		int size2 = sizeof(IMGINF) * g_inb.num;
		g_inb.inf = (LPIMGINF) malloc(size2);
		if(g_inb.inf)
			ZeroMemory(g_inb.inf, size2);
	}
	break;
case 1:
	if(g_inb.inf){
		fread(g_inb.inf, sizeof(IMGINF), g_inb.num, fp);
		for(i=0; i<g_inb.num; i++){
			strncpy(filename3, g_inb.inf[i].name, sizeof(filename3));
			sprintf(g_inb.inf[i].name, "%s\\%s", g_dir.strImage, filename3);
		}
	}
	break;
}
				break;
			}
		}
		if(!flag)
			fseek(fp, size, SEEK_CUR);		// ǂݔ΂
	}
	
	return true;
}// Load_BackImage_Bin

// image_select.dat ̓ǂݍ݁ioCij
bool Load_SelImage_Bin(FILE *fp)
{
	UINT	len_tag,size;
	int		i,k,tg,tag_num;
	char	tag[TAG_LEN];
	char	filename3[MAX_PATH];
	
	g_ins.num = 0;
	SAFE_FREE(g_ins.inf);
	
	fread(&tag_num, sizeof(int), 1, fp);
	for(tg=0; tg<tag_num; tg++){
		int read_size = fread(&len_tag, sizeof(int), 1, fp);
		if(read_size < 1){
			break;
		}
		if(len_tag > sizeof(tag))	len_tag = sizeof(tag);
		fread(tag, sizeof(char), len_tag, fp);
		fread(&size, sizeof(int), 1, fp);
		bool flag = false;
		for(k=0; k<sizeof(g_tag_image_sel) / sizeof(g_tag_image_sel[0]); k++){
			if(!strcmp(tag,  g_tag_image_sel[k])){
				flag = true;
switch(k)
{
case 0:
	{
		fread(&g_ins.num, sizeof(int), 1, fp);
		int size2 = sizeof(IMGINF) * g_ins.num;
		g_ins.inf = (LPIMGINF) malloc(size2);
		if(g_ins.inf)
			ZeroMemory(g_ins.inf, size2);
	}
	break;
case 1:
	if(g_ins.inf){
		fread(g_ins.inf, sizeof(IMGINF), g_ins.num, fp);
		for(i=0; i<g_ins.num; i++){
			strncpy(filename3, g_ins.inf[i].name, sizeof(filename3));
			sprintf(g_ins.inf[i].name, "%s\\%s", g_dir.strImage, filename3);
		}
	}
	break;
}
				break;
			}
		}
		if(!flag)
			fseek(fp, size, SEEK_CUR);		// ǂݔ΂
	}
	
	return true;
}// Load_SelImage_Bin

// image_face.dat ̓ǂݍ݁ioCij
bool Load_FaceImage_Bin(FILE *fp)
{
	UINT	len_tag,size;
	int		i,k,tg,tag_num;
	char	tag[TAG_LEN];
	char	filename3[MAX_PATH];
	
	g_inf.num = 0;
	SAFE_FREE(g_inf.inf);
	
	fread(&tag_num, sizeof(int), 1, fp);
	for(tg=0; tg<tag_num; tg++){
		int read_size = fread(&len_tag, sizeof(int), 1, fp);
		if(read_size < 1){
			break;
		}
		if(len_tag > sizeof(tag))	len_tag = sizeof(tag);
		fread(tag, sizeof(char), len_tag, fp);
		fread(&size, sizeof(int), 1, fp);
		bool flag = false;
		for(k=0; k<sizeof(g_tag_image_face) / sizeof(g_tag_image_face[0]); k++){
			if(!strcmp(tag,  g_tag_image_face[k])){
				flag = true;
switch(k)
{
case 0:
	{
		fread(&g_inf.num, sizeof(int), 1, fp);
		int size2 = sizeof(IMGINF2) * g_inf.num;
		g_inf.inf = (LPIMGINF2) malloc(size2);
		if(g_inf.inf)
			ZeroMemory(g_inf.inf, size2);
	}
	break;
case 1:
	if(g_inf.inf){
		fread(g_inf.inf, sizeof(IMGINF2), g_inf.num, fp);
		for(i=0; i<g_inf.num; i++){
			strncpy(filename3, g_inf.inf[i].name, sizeof(filename3));
			sprintf(g_inf.inf[i].name, "%s\\%s", g_dir.strImage, filename3);
		}
	}
	break;
}
				break;
			}
		}
		if(!flag)
			fseek(fp, size, SEEK_CUR);		// ǂݔ΂
	}
	
	return true;
}// Load_FaceImage_Bin

// image_effect.dat ̓ǂݍ݁ioCij
bool Load_Effect_Bin(FILE *fp)
{
	UINT	len_tag,size;
	int		i,k,tg,tag_num;
	char	tag[TAG_LEN];
	char	filename3[MAX_PATH];
	
	Init_EffectData();
	
	fread(&tag_num, sizeof(int), 1, fp);
	for(tg=0; tg<tag_num; tg++){
		int read_size = fread(&len_tag, sizeof(int), 1, fp);
		if(read_size < 1){
			break;
		}
		if(len_tag > sizeof(tag))	len_tag = sizeof(tag);
		fread(tag, sizeof(char), len_tag, fp);
		fread(&size, sizeof(int), 1, fp);
		bool flag = false;
		for(k=0; k<sizeof(g_tag_image_effect) / sizeof(g_tag_image_effect[0]); k++){
			if(!strcmp(tag,  g_tag_image_effect[k])){
				flag = true;
switch(k)
{
case 0:
	{
		fread(&g_ine.num, sizeof(int), 1, fp);
		int size2 = sizeof(IMGINF5) * g_ine.num;
		g_ine.inf = (LPIMGINF5) malloc(size2);
		if(g_ine.inf)
			ZeroMemory(g_ine.inf, size2);
	}
	break;
case 1:
	if(g_ine.inf){
		for(i=0; i<g_ine.num; i++){
			fread(&g_ine.inf[i].inf3, sizeof(IMGINF3), 1, fp);
			strncpy(filename3, g_ine.inf[i].inf3.name, sizeof(filename3));
			sprintf(g_ine.inf[i].inf3.name, "%s\\%s", g_dir.strImage, filename3);
			fread(&g_ine.inf[i].inf4.pos_num, sizeof(int), 1, fp);
			int size2 = g_ine.inf[i].inf4.pos_num * sizeof(POSIMG);
			g_ine.inf[i].inf4.pos = (LPPOSIMG) malloc(size2);
			if(g_ine.inf[i].inf4.pos){
				fread(g_ine.inf[i].inf4.pos, sizeof(POSIMG), g_ine.inf[i].inf4.pos_num, fp);
			}
		}
	}
	break;
}
				break;
			}
		}
		if(!flag)
			fseek(fp, size, SEEK_CUR);		// ǂݔ΂
	}
	
	return true;
}// Load_Effect_Bin

// map_anim?.dat ̓ǂݍ݁ioCij
bool Load_MapAnim_Bin(FILE *fp)
{
	UINT	len_tag,size;
	int		k,tg,tag_num;
	char	tag[TAG_LEN];
	char	filename3[MAX_PATH];
	
	Init_MapAnimData();
	
	fread(&tag_num, sizeof(int), 1, fp);
	for(tg=0; tg<tag_num; tg++){
		int read_size = fread(&len_tag, sizeof(int), 1, fp);
		if(read_size < 1){
			break;
		}
		if(len_tag > sizeof(tag))	len_tag = sizeof(tag);
		fread(tag, sizeof(char), len_tag, fp);
		fread(&size, sizeof(int), 1, fp);
		bool flag = false;
		for(k=0; k<sizeof(g_tag_map_anim) / sizeof(g_tag_map_anim[0]); k++){
			if(!strcmp(tag,  g_tag_map_anim[k])){
				flag = true;
switch(k)
{
case 0:
	{
		int len;
		fread(&len, sizeof(int), 1, fp);
		fread(filename3, sizeof(char), len, fp);
		fread(&g_inma.width, sizeof(int), 1, fp);
		fread(&g_inma.height, sizeof(int), 1, fp);
		fread(&g_inma.speed, sizeof(int), 1, fp);
		
		sprintf(g_inma.name, "%s\\%s", g_dir.strImage, filename3);
		g_inma.bm = new CDib(g_inma.name);
	}
	break;
case 1:
	{
		fread(&g_inma.inf_num, sizeof(int), 1, fp);
		int size2 = g_inma.inf_num * sizeof(IMGINF6);
		g_inma.inf = (LPIMGINF6) malloc(size2);
		if(g_inma.inf)
			ZeroMemory(g_inma.inf, size2);
	}
	break;
case 2:
	if(g_inma.inf){
		int i;
		for(i=0; i<g_inma.inf_num; i++){
			fread(&g_inma.inf[i].pos_num, sizeof(int), 1, fp);
			int size2 = g_inma.inf[i].pos_num * sizeof(POINT);
			g_inma.inf[i].pos = (LPPOINT) malloc(size2);
			if(g_inma.inf[i].pos){
				fread(g_inma.inf[i].pos, sizeof(POINT), g_inma.inf[i].pos_num, fp);
			}
		}
	}
	break;
}
				break;
			}
		}
		if(!flag)
			fseek(fp, size, SEEK_CUR);		// ǂݔ΂
	}
	
	return true;
}// Load_MapAnim_Bin

// treasure_list.dat ̓ǂݍ݁ioCij
bool Load_Treasure_Bin(FILE *fp)
{
	UINT	len_tag,size;
	int		i,k,tg,tag_num;
	char	tag[TAG_LEN];
	
	if(g_tre.inf){
		for(i=0;i<g_tre.num;i++){
			SAFE_DELETE(g_tre.inf[i].bm);
			SAFE_DELETE(g_tre.inf[i].bm2);
		}
		SAFE_FREE(g_tre.inf);
		g_tre.num = 0;
	}
	
	fread(&tag_num, sizeof(int), 1, fp);
	for(tg=0; tg<tag_num; tg++){
		int read_size = fread(&len_tag, sizeof(int), 1, fp);
		if(read_size < 1){
			break;
		}
		if(len_tag > sizeof(tag))	len_tag = sizeof(tag);
		fread(tag, sizeof(char), len_tag, fp);
		fread(&size, sizeof(int), 1, fp);
		bool flag = false;
		for(k=0; k<sizeof(g_tag_treasure) / sizeof(g_tag_treasure[0]); k++){
			if(!strcmp(tag,  g_tag_treasure[k])){
				flag = true;
switch(k)
{
case 0:
	{
		fread(&g_tre.num, sizeof(int), 1, fp);
		int size2 = sizeof(TREASURE) * g_tre.num;
		g_tre.inf = (LPTREASURE) malloc(size2);
		if(g_tre.inf)
			ZeroMemory(g_tre.inf, size2);
	}
	break;
case 1:
	if(g_tre.inf){
		for(i=0; i<g_tre.num; i++){
			fread(&g_tre.inf[i].flag_show, sizeof(BOOL), 1, fp);
			fread(&g_tre.inf[i].flag_once, sizeof(BOOL), 1, fp);
			fread(&g_tre.inf[i].flag_opened, sizeof(BOOL), 1, fp);
			fread(&g_tre.inf[i].flag_anim_kind, sizeof(BOOL), 1, fp);
			fread(&g_tre.inf[i].pt, sizeof(POINT), 1, fp);
			fread(&g_tre.inf[i].idxEffect, sizeof(int), 1, fp);
			fread(&g_tre.inf[i].idxWave, sizeof(int), 1, fp);
			fread(&g_tre.inf[i].idxFlag, sizeof(int), 1, fp);
			Load_TreasureList_Sub(i);
		}
	}
	break;
}
				break;
			}
		}
		if(!flag)
			fseek(fp, size, SEEK_CUR);		// ǂݔ΂
	}
	
	return true;
}// Load_Treasure_Bin

// PC ̓ǂݍ݁ioCij
bool Load_PC_Bin(FILE *fp)
{
	UINT	len_tag,size;
	int		i,k,tg,tag_num,len;
	char	tag[TAG_LEN];
	char filename3[MAX_PATH];
	
	Init_PcData();
	
	fread(&tag_num, sizeof(int), 1, fp);
	for(tg=0; tg<tag_num; tg++){
		int read_size = fread(&len_tag, sizeof(int), 1, fp);
		if(read_size < 1){
			break;
		}
		if(len_tag > sizeof(tag))	len_tag = sizeof(tag);
		fread(tag, sizeof(char), len_tag, fp);
		fread(&size, sizeof(int), 1, fp);
		bool flag = false;
		for(k=0; k<sizeof(g_tag_pc) / sizeof(g_tag_pc[0]); k++){
			if(!strcmp(tag,  g_tag_pc[k])){
				flag = true;
switch(k)
{
case 0:
	fread(&len, sizeof(int), 1, fp);
	fread(g_pc.name, sizeof(char), len, fp);
	break;
case 1:
	fread(&g_pc.move_speed, sizeof(int), 1, fp);
	fread(&g_pc.view, sizeof(POINT), 1, fp);
	fread(&g_pc.pos, sizeof(POINT), 1, fp);
	fread(&g_pc.posBm, sizeof(POINT), 1, fp);
	fread(&g_pc.idxDir, sizeof(int), 1, fp);
	fread(&g_pc.level, sizeof(int), 1, fp);
	fread(&g_pc.ability, sizeof(ABILITY), 1, fp);
	fread(&g_pc.damagePoison, sizeof(int), 1, fp);
	g_pc.view.x *= CHIP_SIZE;
	g_pc.view.y *= CHIP_SIZE;
	break;
case 2:
	for(i=0; i<2; i++){
		len = strlen(g_pc.img[i].filenameBm) + 1;
		fread(&len, sizeof(int), 1, fp);
		fread(filename3, sizeof(char), len, fp);
		sprintf(g_pc.img[i].filenameBm, "%s\\%s", g_dir.strImage, filename3);
		fread(&g_pc.img[i].xBm, sizeof(int), 1, fp);
		fread(&g_pc.img[i].yBm, sizeof(int), 1, fp);
		fread(&g_pc.img[i].widthBm, sizeof(int), 1, fp);
		fread(&g_pc.img[i].heightBm, sizeof(int), 1, fp);
		fread(&g_pc.img[i].flag_alpha, sizeof(int), 1, fp);
		fread(&g_pc.img[i].flag_colorkey, sizeof(BOOL), 1, fp);
		fread(&g_pc.img[i].colorkey_red, sizeof(int), 1, fp);
		fread(&g_pc.img[i].colorkey_green, sizeof(int), 1, fp);
		fread(&g_pc.img[i].colorkey_blue, sizeof(int), 1, fp);
	}
	fread(g_pc.img_pos_idx, sizeof(int), 2 * 4, fp);
	g_pc.img_size[0] = g_pc.img[0].widthBm / 3;
	g_pc.img_size[1] = g_pc.img[0].heightBm / 4;
	break;
case 3:
	fread(g_pc.idxEquipment, sizeof(int), EQUIP_NUM, fp);
	break;
case 4:
	fread(&g_pc.numItemKindMax, sizeof(int), 1, fp);
	break;
case 5:
	{
		fread(&g_pc.numItemKind, sizeof(int), 1, fp);
		int size = sizeof(ITEM3) * g_pc.numItemKindMax;
		g_pc.item = (LPITEM3) malloc(size);
		if(g_pc.item)
			ZeroMemory(g_pc.item, size);
	}
	break;
case 6:
	if(g_pc.item){
		fread(g_pc.item, sizeof(ITEM3), size, fp);
	}
	break;
}
				break;
			}
		}
		if(!flag)
			fseek(fp, size, SEEK_CUR);		// ǂݔ΂
	}
	
	return true;
}// Load_PC_Bin

// npc_list.dat ̓ǂݍ݁ioCij
bool Load_NPC_Bin(FILE *fp)
{
	UINT	len_tag,size;
	int		i,k,tg,tag_num;
	char	tag[TAG_LEN];
	char	filename3[MAX_PATH];
	
	if(g_npc.inf){
		for(i=0;i<g_npc.num;i++){
			SAFE_DELETE(g_npc.inf[i].img.bm);
			SAFE_DELETE(g_npc.inf[i].img.bm2);
		}
		SAFE_FREE(g_npc.inf);
	}
	
	fread(&tag_num, sizeof(int), 1, fp);
	for(tg=0; tg<tag_num; tg++){
		int read_size = fread(&len_tag, sizeof(int), 1, fp);
		if(read_size < 1){
			break;
		}
		if(len_tag > sizeof(tag))	len_tag = sizeof(tag);
		fread(tag, sizeof(char), len_tag, fp);
		fread(&size, sizeof(int), 1, fp);
		bool flag = false;
		for(k=0; k<sizeof(g_tag_npc) / sizeof(g_tag_npc[0]); k++){
			if(!strcmp(tag,  g_tag_npc[k])){
				flag = true;
switch(k)
{
case 0:
	{
		fread(&g_npc.num, sizeof(int), 1, fp);
		int size2 = sizeof(NPC) * g_npc.num;
		g_npc.inf = (LPNPC) malloc(size2);
		if(g_npc.inf)
			ZeroMemory(g_npc.inf, size2);
	}
	break;
case 1:
	if(g_npc.inf){
		for(i=0; i<g_npc.num; i++){
			fread(&g_npc.inf[i].typeMove, sizeof(int), 1, fp);
			fread(&g_npc.inf[i].idxDir, sizeof(int), 1, fp);
			fread(&g_npc.inf[i].flag_show, sizeof(BOOL), 1, fp);
			fread(&g_npc.inf[i].move_speed, sizeof(int), 1, fp);
			fread(&g_npc.inf[i].posBm, sizeof(POINT), 1, fp);
			fread(&g_npc.inf[i].posNow, sizeof(POINT), 1, fp);
			fread(&g_npc.inf[i].posCenter, sizeof(POINT), 1, fp);
			fread(&g_npc.inf[i].areaMove, sizeof(POINT), 1, fp);
			fread(&g_npc.inf[i].idxFlag, sizeof(int), 1, fp);
			int len = strlen(g_npc.inf[i].img.filenameBm) + 1;
			fread(&len, sizeof(int), 1, fp);
			fread(filename3, sizeof(char), len, fp);
			fread(&g_npc.inf[i].img.xBm, sizeof(int), 1, fp);
			fread(&g_npc.inf[i].img.yBm, sizeof(int), 1, fp);
			fread(&g_npc.inf[i].img.widthBm, sizeof(int), 1, fp);
			fread(&g_npc.inf[i].img.heightBm, sizeof(int), 1, fp);
			fread(&g_npc.inf[i].img.flag_alpha, sizeof(int), 1, fp);
			fread(&g_npc.inf[i].img.flag_colorkey, sizeof(BOOL), 1, fp);
			fread(&g_npc.inf[i].img.colorkey_red, sizeof(int), 1, fp);
			fread(&g_npc.inf[i].img.colorkey_green, sizeof(int), 1, fp);
			fread(&g_npc.inf[i].img.colorkey_blue, sizeof(int), 1, fp);
			fread(g_npc.inf[i].img_pos_idx, sizeof(int), 2 * 4, fp);
			sprintf(g_npc.inf[i].img.filenameBm, "%s\\%s", g_dir.strImage, filename3);
			Load_NpcList_Sub(i);
		}
	}
	break;
}
				break;
			}
		}
		if(!flag)
			fseek(fp, size, SEEK_CUR);		// ǂݔ΂
	}
	
	return true;
}// Load_NPC_Bin

// scene?.dat ̓ǂݍ݁ioCij
bool Load_Scene_Bin(FILE *fp)
{
	UINT	len_tag,size;
	int		i,j,k,tg,tag_num,len;
	char	tag[TAG_LEN];
	char	filename3[MAX_PATH];
	
	Init_SceneData();
	
	fread(&tag_num, sizeof(int), 1, fp);
	for(tg=0; tg<tag_num; tg++){
		int read_size = fread(&len_tag, sizeof(int), 1, fp);
		if(read_size < 1){
			break;
		}
		if(len_tag > sizeof(tag))	len_tag = sizeof(tag);
		fread(tag, sizeof(char), len_tag, fp);
		fread(&size, sizeof(int), 1, fp);
		bool flag = false;
		for(k=0; k<sizeof(g_tag_scene) / sizeof(g_tag_scene[0]); k++){
			if(!strcmp(tag,  g_tag_scene[k])){
				flag = true;
switch(k)
{
case 0:
	fread(&g_sn.kindScene, sizeof(int), 1, fp);
	break;
case 1:
	fread(&len, sizeof(int), 1, fp);
	fread(g_sn.scene_name, sizeof(char), len, fp);
	break;
case 2:
	fread(&len, sizeof(int), 1, fp);
	fread(g_sn.filenameMapData, sizeof(char), len, fp);
	break;
case 3:
	fread(&len, sizeof(int), 1, fp);
	fread(filename3, sizeof(char), len, fp);
	sprintf(g_sn.filenameBgMapChip, "%s\\%s", g_dir.strImage, filename3);
	break;
case 4:
	fread(&len, sizeof(int), 1, fp);
	fread(filename3, sizeof(char), len, fp);
	fread(&g_sn.imginfLyerMapChip.flag_alpha, sizeof(int), 1, fp);
	fread(&g_sn.imginfLyerMapChip.flag_colorkey, sizeof(BOOL), 1, fp);
	fread(&g_sn.imginfLyerMapChip.colorkey_red, sizeof(int), 1, fp);
	fread(&g_sn.imginfLyerMapChip.colorkey_green, sizeof(int), 1, fp);
	fread(&g_sn.imginfLyerMapChip.colorkey_blue, sizeof(int), 1, fp);
	sprintf(g_sn.imginfLyerMapChip.name, "%s\\%s", g_dir.strImage, filename3);
	break;
case 5:
	fread(&g_sn.idxMidi, sizeof(int), 1, fp);
	break;
case 6:
	{
		fread(&g_sn.scene_change_num, sizeof(int), 1, fp);
		int size2 = sizeof(SCENECHANGE) * g_sn.scene_change_num;
		g_sn.scene_change = (LPSCENECHANGE) malloc(size2);
		if(g_sn.scene_change)
			ZeroMemory(g_sn.scene_change, size2);
	}
	break;
case 7:
	if(g_sn.scene_change){
		fread(g_sn.scene_change, sizeof(SCENECHANGE), g_sn.scene_change_num, fp);
	}
	break;
case 8:
	{
		fread(&g_sn.npc_index_num, sizeof(int), 1, fp);
		int size2 = sizeof(int) * g_sn.npc_index_num;
		g_sn.npc_index = (LPINT) malloc(size2);
		if(g_sn.npc_index)
			ZeroMemory(g_sn.npc_index, size2);
	}
	break;
case 9:
	if(g_sn.npc_index){
		fread(g_sn.npc_index, sizeof(int), g_sn.npc_index_num, fp);
	}
	break;
case 10:
	{
		fread(&g_sn.tre_index_num, sizeof(int), 1, fp);
		int size2 = sizeof(int) * g_sn.tre_index_num;
		g_sn.tre_index = (LPINT) malloc(size2);
		if(g_sn.tre_index)
			ZeroMemory(g_sn.tre_index, size2);
	}
	break;
case 11:
	if(g_sn.tre_index){
		fread(g_sn.tre_index, sizeof(int), g_sn.tre_index_num, fp);
	}
	break;
case 12:
	{
		fread(&g_sn.battle_num, sizeof(int), 1, fp);
		int size2 = sizeof(BATTLE) * g_sn.battle_num;
		g_sn.battle = (LPBATTLE) malloc(size2);
		if(g_sn.battle)
			ZeroMemory(g_sn.battle, size2);
	}
	break;
case 13:
	if(g_sn.battle){
		fread(g_sn.battle, sizeof(BATTLE), g_sn.battle_num, fp);
		for(i=0; i<g_sn.battle_num; i++){
			strncpy(filename3, g_sn.battle[i].filenameBgBattle, sizeof(filename3));
			sprintf(g_sn.battle[i].filenameBgBattle, "%s\\%s", g_dir.strImage, filename3);
		}
	}
	break;
case 14:
	fread(&g_sn.battle_map, sizeof(BATTLEMAP), 1, fp);
	break;
case 15:
	fread(&len, sizeof(int), 1, fp);
	fread(g_sn.filenameMapAnim, sizeof(char), len, fp);
	break;
case 16:
	fread(&g_sn.map_anim, sizeof(MAPANIM), 1, fp);
	break;
case 17:
	{
		fread(&g_sn.event_pos_num, sizeof(int), 1, fp);
		int size2 = sizeof(EVENTPOS) * g_sn.event_pos_num;
		g_sn.event_pos = (LPEVENTPOS) malloc(size2);
		if(g_sn.event_pos)
			ZeroMemory(g_sn.event_pos, size2);
	}
	break;
case 18:
	if(g_sn.event_pos){
		fread(g_sn.event_pos, sizeof(EVENTPOS), g_sn.event_pos_num, fp);
	}
	break;
case 19:
	{
		fread(&g_sn.evt_cmd_num, sizeof(int), 1, fp);
		int size2 = sizeof(EVENTCMDSTR) * g_sn.evt_cmd_num;
		g_sn.evt_cmd = (LPEVENTCMDSTR) malloc(size2);
		if(g_sn.evt_cmd)
			ZeroMemory(g_sn.evt_cmd, size2);
	}
	break;
case 20:
	if(g_sn.evt_cmd){
		for(i=0; i<g_sn.evt_cmd_num; i++){
			fread(&g_sn.evt_cmd[i].num, sizeof(int), 1, fp);
			int size2 = sizeof(char*) * g_sn.evt_cmd[i].num;
			g_sn.evt_cmd[i].str = (char**) malloc(size2);
			if(g_sn.evt_cmd[i].str)
				ZeroMemory(g_sn.evt_cmd[i].str, size2);
		}
	}
	break;
case 21:
	if(g_sn.evt_cmd){
		for(i=0; i<g_sn.evt_cmd_num; i++){
			if(g_sn.evt_cmd[i].str){
				for(j=0; j<g_sn.evt_cmd[i].num; j++){
					fread(&len, sizeof(int), 1, fp);
					g_sn.evt_cmd[i].str[j] = (char*) malloc(len);
					if(g_sn.evt_cmd[i].str[j]){
						fread(g_sn.evt_cmd[i].str[j], sizeof(char), len, fp);
					}
				}
			}
		}
	}
	break;
}
				break;
			}
		}
		if(!flag)
			fseek(fp, size, SEEK_CUR);		// ǂݔ΂
	}
	
	return true;
}// Load_Scene_Bin

// {ݒ̓ǂݍ݁ioCij
bool Load_Setting_Bin(FILE *fp)
{
	UINT	len_tag,size;
	int		i,k,tg,tag_num,len;
	char	tag[TAG_LEN];
	char filename3[MAX_PATH];
	
	ZeroMemory(&g_set, sizeof(g_set));
	lstrcpy(glFont.lfFaceName, "lr ");
	glFont.lfWeight			= 700;
	glFont.lfCharSet		= SHIFTJIS_CHARSET;
	glFont.lfPitchAndFamily	= FIXED_PITCH | FF_MODERN;
	glFont.lfQuality		= PROOF_QUALITY;
	
	fread(&tag_num, sizeof(int), 1, fp);
	for(tg=0; tg<tag_num; tg++){
		int read_size = fread(&len_tag, sizeof(int), 1, fp);
		if(read_size < 1){
			break;
		}
		if(len_tag > sizeof(tag))	len_tag = sizeof(tag);
		fread(tag, sizeof(char), len_tag, fp);
		fread(&size, sizeof(int), 1, fp);
		bool flag = false;
		for(k=0; k<sizeof(g_tag_setting) / sizeof(g_tag_setting[0]); k++){
			if(!strcmp(tag,  g_tag_setting[k])){
				flag = true;
switch(k)
{
case 0:
	fread(&len, sizeof(int), 1, fp);
	fread(g_set.title, sizeof(char), len, fp);
	break;
case 1:
	fread(&len, sizeof(int), 1, fp);
	fread(filename3, sizeof(char), len, fp);
	fread(&g_set.img_focus.flag_alpha, sizeof(int), 1, fp);
	fread(&g_set.img_focus.flag_colorkey, sizeof(BOOL), 1, fp);
	fread(&g_set.img_focus.colorkey_red, sizeof(int), 1, fp);
	fread(&g_set.img_focus.colorkey_green, sizeof(int), 1, fp);
	fread(&g_set.img_focus.colorkey_blue, sizeof(int), 1, fp);
	sprintf(g_set.img_focus.name, "%s\\%s", g_dir.strImage, filename3);
	break;
case 2:
	fread(&g_set.effect_arrow_talk, sizeof(int), 1, fp);
	break;
case 3:
	fread(&g_set.effect_arrow_menu1, sizeof(int), 1, fp);
	break;
case 4:
	fread(&g_set.effect_arrow_menu2, sizeof(int), 1, fp);
	break;
case 5:
	fread(&g_set.effect_bare, sizeof(int), 1, fp);
	break;
case 6:
	fread(&g_set.wave_bare, sizeof(int), 1, fp);
	break;
case 7:
	fread(&g_set.flag_wave_battle, sizeof(int), 1, fp);
	fread(&g_set.wave_get, sizeof(int), 1, fp);
	fread(&g_set.wave_level_up, sizeof(int), 1, fp);
	break;
case 8:
	fread(&g_set.wave_poison, sizeof(int), 1, fp);
	break;
case 9:
	fread(&g_set.wave_equip_set, sizeof(int), 1, fp);
	break;
case 10:
	fread(&g_set.wave_equip_remove, sizeof(int), 1, fp);
	break;
case 11:
	fread(&g_set.midi_level_up, sizeof(int), 1, fp);
	break;
case 12:
	fread(&g_set.midi_gameover, sizeof(int), 1, fp);
	break;
case 13:
	fread(&len, sizeof(int), 1, fp);
	fread(g_set.denomi_name, sizeof(char), len, fp);
	break;
case 14:
	fread(&g_set.line_thick, sizeof(int), 1, fp);
	break;
case 15:
	fread(&g_set.flag_battle_alpha, sizeof(int), 1, fp);
	break;
case 16:
	fread(&g_set.flag_back_bmp, sizeof(int), 1, fp);
	break;
case 17:
	fread(&g_set.alpha_select, sizeof(int), 1, fp);
	break;
case 18:
	{
		int r = 0,g = 0,b = 0;
		fread(&r, sizeof(int), 1, fp);
		fread(&g, sizeof(int), 1, fp);
		fread(&b, sizeof(int), 1, fp);
		g_set.rgb_line = RGB(r, g, b);
	}
	break;
case 19:
	{
		int r = 0,g = 0,b = 0;
		fread(&r, sizeof(int), 1, fp);
		fread(&g, sizeof(int), 1, fp);
		fread(&b, sizeof(int), 1, fp);
		g_set.rgb_back = DIB_RGB_MAKE(r, g, b);
	}
	break;
case 20:
	{
		int r = 0,g = 0,b = 0;
		fread(&r, sizeof(int), 1, fp);
		fread(&g, sizeof(int), 1, fp);
		fread(&b, sizeof(int), 1, fp);
		g_set.rgb_battle_item = DIB_RGB_MAKE(r, g, b);
	}
	break;
case 21:
	fread(&g_set.alpha_battle_item, sizeof(int), 1, fp);
	break;
case 22:
	{
		int r = 0,g = 0,b = 0;
		fread(&r, sizeof(int), 1, fp);
		fread(&g, sizeof(int), 1, fp);
		fread(&b, sizeof(int), 1, fp);
		g_set.rgb_back_talk = DIB_RGB_MAKE(r, g, b);
	}
	break;
case 23:
	fread(&g_set.fade_max_talk, sizeof(int), 1, fp);
	break;
case 24:
	fread(&g_set.flag_talk_face, sizeof(int), 1, fp);
	break;
case 25:
	fread(&g_set.talk_y, sizeof(int), 1, fp);
	break;
case 26:
	fread(&g_set.poison_interval, sizeof(int), 1, fp);
	break;
case 27:
	fread(&g_set.move_interval_pc, sizeof(int), 1, fp);
	break;
case 28:
	fread(&g_set.move_interval_npc, sizeof(int), 1, fp);
	break;
case 29:
	fread(&g_set.no_scroll_area, sizeof(POINT), 1, fp);
	break;
case 30:
	fread(&g_set.straight_max, sizeof(int), 1, fp);
	break;
case 31:
	fread(&g_set.game_speed, sizeof(int), 1, fp);
	break;
case 32:
	fread(&g_set.fade_speed, sizeof(int), 1, fp);
	break;
case 33:
	fread(&g_set.turn_speed, sizeof(int), 1, fp);
	break;
case 34:
	fread(&g_set.e_attack_speed, sizeof(int), 1, fp);
	break;
case 35:
	fread(&g_set.damage_speed, sizeof(int), 1, fp);
	break;
case 36:
	fread(&g_set.e_damage_speed, sizeof(int), 1, fp);
	break;
case 37:
	fread(&g_set.focus_speed, sizeof(int), 1, fp);
	break;
case 38:
	fread(&g_set.letter_speed, sizeof(int), 1, fp);
	break;
case 39:
	fread(&len, sizeof(int), 1, fp);
	fread(glFont.lfFaceName, sizeof(char), len, fp);
	break;
case 40:
	fread(&glFont.lfWeight, sizeof(int), 1, fp);
	if(glFont.lfWeight < 0)	glFont.lfWeight = 0;
	if(glFont.lfWeight > 9)	glFont.lfWeight = 9;
	glFont.lfWeight *= 100;
	break;
case 41:
	for(i=0; i<9; i++){
		int r = 0, g = 0, b = 0;
		fread(&r, sizeof(int), 1, fp);
		fread(&g, sizeof(int), 1, fp);
		fread(&b, sizeof(int), 1, fp);
		g_set.font_color[i] = RGB(r, g, b);
	}
	break;
case 42:
	fread(&g_set.event_font_size, sizeof(int), 1, fp);
	break;
case 43:
	fread(&g_set.talk_font_size, sizeof(int), 1, fp);
	break;
case 44:
	fread(&g_set.ability_max, sizeof(int), 1, fp);
	break;
case 45:
	fread(&g_set.item_own_num, sizeof(int), 1, fp);
	break;
case 46:
	fread(&g_set.item_sell_rate, sizeof(float), 1, fp);
	break;
case 47:
	fread(&g_set.buy_disp_num, sizeof(int), 1, fp);
	break;
case 48:
	fread(&g_set.sell_disp_num, sizeof(int), 1, fp);
	break;
case 49:
	fread(&g_set.menu_disp_num1, sizeof(int), 1, fp);
	break;
case 50:
	fread(&g_set.menu_disp_num2, sizeof(int), 1, fp);
	break;
case 51:
	fread(&g_set.battle_disp_num, sizeof(int), 1, fp);
	break;
case 52:
	fread(&g_set.save_disp_num, sizeof(int), 1, fp);
	break;
case 53:
	fread(&g_set.battle_item_y, sizeof(int), 1, fp);
	break;
case 54:
	fread(&g_set.battle_wait1, sizeof(int), 1, fp);
	break;
case 55:
	fread(&g_set.battle_wait2, sizeof(int), 1, fp);
	break;
case 56:
	{
		fread(&g_save.num, sizeof(int), 1, fp);
		SAFE_FREE(g_save.str);
		int size = sizeof(char) * g_save.num * NAME_LEN1;
		g_save.str = (char(*)[NAME_LEN1]) malloc(size);
		if(g_save.str)
			ZeroMemory(g_save.str, size);
	}
	break;
case 57:
	fread(&g_set.menu_width1, sizeof(int), 1, fp);
	break;
case 58:
	fread(&g_set.menu_width2, sizeof(int), 1, fp);
	break;
case 59:
	fread(&g_set.menu_width3, sizeof(int), 1, fp);
	break;
case 60:
	fread(&g_set.item_height, sizeof(int), 1, fp);
	break;
case 61:
	fread(&g_set.fade_inc_monster, sizeof(int), 1, fp);
	break;
case 62:
	fread(&g_set.fade_inc_talk, sizeof(int), 1, fp);
	break;
case 63:
	fread(&g_set.vol_all, sizeof(int), 1, fp);
	break;
case 64:
	fread(&g_set.vol_bgm, sizeof(int), 1, fp);
	break;
case 65:
	fread(&g_set.vol_sound, sizeof(int), 1, fp);
	break;
case 66:
	fread(&g_set.key_interval, sizeof(int), 1, fp);
	break;
case 67:
	fread(&g_set.talk_margin, sizeof(int), 1, fp);
	break;
case 68:
	fread(&g_set.pos_menu_item, sizeof(POINT), 1, fp);
	break;
case 69:
	fread(&g_set.critical_rate, sizeof(int), 1, fp);
	break;
case 70:
	fread(&g_set.ampl_damage, sizeof(int), 1, fp);
	break;
case 71:
	fread(&g_set.ampl_damage_crt, sizeof(int), 1, fp);
	break;
case 72:
	fread(&g_set.dist_enemy_attack, sizeof(int), 1, fp);
	break;
case 73:
	fread(&g_set.effect_wave_crt, sizeof(int), 1, fp);
	break;
case 74:
	fread(&g_set.vol_sound_crt, sizeof(int), 1, fp);
	break;
}
				break;
			}
		}
		if(!flag)
			fseek(fp, size, SEEK_CUR);		// ǂݔ΂
	}
	
	return true;
}// Load_Setting_Bin

#endif