#include "rpgLoadBmpCode.h"
#include "cmpcode.h"
#include "rpgKey.h"

#define WIDTHBYTES(bits)	((bits + 31) >> 5) << 2	// 4 byte E
#define SAFE_FREE(p)		if (p){free(p);p=NULL;}

WORD BmiSize(LPBITMAPINFOHEADER lpbih);
WORD BitMaskSize(LPBITMAPINFOHEADER lpbih);
WORD PaletteSize(LPBITMAPINFOHEADER lpbih);
WORD DIBNumColors(LPBITMAPINFOHEADER lpbih);
DWORD BytesPerLine(LPBITMAPINFOHEADER lpbih);

// rbg}bvǂݍ
HBITMAP Load_BMP(char *filename)
{
	HBITMAP hBmp = NULL;
	char filename_code[MAX_PATH];
	strncpy(filename_code, filename, sizeof(filename_code));
	char *p = strrchr(filename_code, '.');
	if(p + 1)
		strcpy(p + 1, "b");
	int type = Is_Compress(filename_code) ? 2 : 0;
	int size = Get_FileSize(type, filename_code);
	if(size > 0){
		BYTE *pData = (BYTE*) malloc(size);
		if(pData){
			ZeroMemory(pData, size);
			if(Decode_File(type, CODE_KEY, (BYTE*) pData, size, filename_code)){
				BITMAPINFO			*pBmi = NULL;
				BYTE				*pBits = NULL;
				BITMAPFILEHEADER	bmfh;
				BITMAPINFOHEADER	bmih;
				BYTE				*pData2 = pData;
				
				memcpy(&bmfh, pData2, sizeof(bmfh));
				pData2 += sizeof(bmfh);
				if(bmfh.bfType == 0x4D42){
					memcpy(&bmih, pData2, sizeof(bmih));
					pData2 += sizeof(bmih);
					int size_pBmi = BmiSize(&bmih);
					pBmi = (BITMAPINFO*) malloc(size_pBmi);
					ZeroMemory(pBmi, size_pBmi);
					pBmi->bmiHeader = bmih;
					if(pBmi->bmiHeader.biBitCount <= 8){			// pbg̏ꍇ
						memcpy(&pBmi->bmiColors, pData2, PaletteSize(&bmih));
						pData2 += PaletteSize(&bmih);
					}
					else if(bmih.biCompression == BI_BITFIELDS){	// }XN̏ꍇ
						memcpy(&pBmi->bmiColors, pData2, BitMaskSize(&bmih));
						pData2 += BitMaskSize(&bmih);
					}
					hBmp = CreateDIBSection(NULL, pBmi, DIB_RGB_COLORS, (void**)&pBits, NULL, 0);
					BYTE	*pData3 = pData;	// 擪|C^擾
					pData3 += bmfh.bfOffBits;	// |C^ʒuItZbgl܂ňړ
					pBmi->bmiHeader.biSizeImage = BytesPerLine(&pBmi->bmiHeader) * pBmi->bmiHeader.biHeight;
					memcpy(pBits, pData3, pBmi->bmiHeader.biSizeImage);
					SAFE_FREE(pBmi);
				}
				free(pData);
				pData = NULL;
			}
		}
	}
	
	if(!hBmp){
		hBmp = (HBITMAP)LoadImage(NULL, filename, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE|LR_CREATEDIBSECTION);
	}
	return hBmp;
}// Load_BMP

// DIB  BITMAPINFO \̃TCYԂ
WORD BmiSize(LPBITMAPINFOHEADER lpbih)
{
	return (sizeof(BITMAPINFOHEADER) + BitMaskSize(lpbih) + PaletteSize(lpbih));
}// BmiMaskSize

// DIB ̃sNZtH[}bg TCYԂ
WORD BitMaskSize(LPBITMAPINFOHEADER lpbih)
{
	WORD mask_size = 0;
	if(lpbih->biCompression == BI_BITFIELDS)
		mask_size = sizeof(DWORD) * 3;
	return mask_size;
}// BitMaskSize

// DIB ̃pbg TCYԂ
WORD PaletteSize( LPBITMAPINFOHEADER lpbih )
{
	return ( DIBNumColors( lpbih ) * sizeof( RGBQUAD ) );
}// PaletteSize

// DIB ̐FԂ
WORD DIBNumColors( LPBITMAPINFOHEADER lpbih )
{
	int num;
	if(lpbih->biBitCount > 8)
		num = 0;
	else if(lpbih->biClrUsed == 0)
		num = 1 << lpbih->biBitCount;
	else
		num = lpbih->biClrUsed;
	return num;
}// DIBNumColors

// DIB  4byte EԂ
DWORD BytesPerLine( LPBITMAPINFOHEADER lpbih )
{
	return WIDTHBYTES(lpbih->biWidth * lpbih->biPlanes * lpbih->biBitCount);
}// BytesPerLine
