#ifndef __RPGLOADMUSICCODE_H__
#define __RPGLOADMUSICCODE_H__

BYTE *g_pBGM[BGM_MAX];
BYTE *g_pSND[SOUND_MAX];

bool Load_BGM_RPG(int Seg_num, char *filename, long nVol);
bool Load_BGM_Coded(int Seg_num, char *filename, long nVol);
bool Load_SND_RPG(int Seg_num, char *filename, long nVol);
bool Load_SND_Coded(int Seg_num, char *filename, long nVol);
void Free_Music();

// t@C̓ǂݍ݁iBGM j
bool Load_BGM_RPG(int Seg_num, char *filename, long nVol)
{
	char filename_code[MAX_PATH];
	strncpy(filename_code, filename, sizeof(filename_code));
	char *p = strrchr(filename_code, '.');
	if(p + 2){
		strcpy(p + 2, "");
	}
	if(!Load_BGM_Coded(Seg_num, filename_code, nVol)){
		if(!LoadBGM_F(Seg_num, filename, nVol)){
			return false;
		}
	}
	return true;
}// Load_BGM_RPG

// Ít@C̓ǂݍ݁iBGM j
bool Load_BGM_Coded(int Seg_num, char *filename, long nVol)
{
	bool ret = false;
	if(Seg_num >= 0 && Seg_num < BGM_MAX){
		char *p = strrchr(filename, '.');
		if((p + 1) && strlen(p + 1) == 1){	// gqP̏ꍇ
			int type = Is_Compress(filename) ? 2 : 0;
			int size = Get_FileSize(type, filename);
			if(size == 0){
				return false;
			}
			SAFE_FREE(g_pBGM[Seg_num]);
			g_pBGM[Seg_num] = (BYTE*) malloc(size);
			if(g_pBGM[Seg_num]){
				ZeroMemory(g_pBGM[Seg_num], size);
				ret = Decode_File(type, CODE_KEY, g_pBGM[Seg_num], size, filename);
				if(ret){
					ret = LoadBGM_M(Seg_num, g_pBGM[Seg_num], size, nVol);
				}
			}
		}
	}
	return ret;
}// Load_BGM_Coded

// t@C̓ǂݍ݁iʉ j
bool Load_SND_RPG(int Seg_num, char *filename, long nVol)
{
	char filename_code[MAX_PATH];
	strncpy(filename_code, filename, sizeof(filename_code));
	char *p = strrchr(filename_code, '.');
	if(p + 2){
		strcpy(p + 2, "");
	}
	if(!Load_SND_Coded(Seg_num, filename_code, nVol)){
		if(!LoadSND_EF_F(Seg_num, filename, nVol)){
			return false;
		}
	}
	return true;
}// Load_SND_RPG

// Ít@C̓ǂݍ݁iʉ j
bool Load_SND_Coded(int Seg_num, char *filename, long nVol)
{
	bool ret = false;
	if(Seg_num >= 0 && Seg_num < SOUND_MAX){
		char *p = strrchr(filename, '.');
		if((p + 1) && strlen(p + 1) == 1){	// gqP̏ꍇ
			int type = Is_Compress(filename) ? 2 : 0;
			int size = Get_FileSize(type, filename);
			if(size == 0){
				return false;
			}
			SAFE_FREE(g_pSND[Seg_num]);
			g_pSND[Seg_num] = (BYTE*) malloc(size);
			if(g_pSND[Seg_num]){
				ZeroMemory(g_pSND[Seg_num], size);
				ret = Decode_File(type, CODE_KEY, g_pSND[Seg_num], size, filename);
				if(ret){
					ret = LoadSND_EF_M(Seg_num, g_pSND[Seg_num], size, nVol);
				}
			}
		}
	}
	return ret;
}// Load_SND_Coded

void Free_Music()
{
	int i;
	for(i=0; i<BGM_MAX; i++){
		SAFE_FREE(g_pBGM[i]);
	}
	for(i=0; i<SOUND_MAX; i++){
		SAFE_FREE(g_pSND[i]);
	}
}// Free_Music

#endif
