#ifndef __RPGUTIL_H__
#define __RPGUTIL_H__

#include "dib_alpha2.h"

#define SAFE_DELETE(p)		if (p){delete p;p=NULL;}
#define SAFE_FREE(p)		if (p){free(p);p=NULL;}

bool	GetTiming(UINT anim_speed, long *TickCount);
void	Set_Bm(CDib **bm, CDib2 **bm2, int idxAlpha, BOOL bColorKey,
				char *filename, WORD colorkey);
void	Set_Bm(CDib **bm, CDib2 **bm2, int idxAlpha, BOOL bColorKey, char *filename,
				int x, int y, int width, int height, WORD colorkey);
void	Draw_Dib(CDib *buf, CDib *bm, CDib2 *bm2, int idxAlpha, int dst_x, int dst_y,
				int src_x, int src_y, int width, int height, int alpha);
void	Draw_Dib(CDib *buf, CDib *bm, CDib2 *bm2, int idxAlpha,
				int x, int y, int width, int height, int alpha = 32);
void	Good_Health(CDib *buf, CDib2 *buf2, char *file_name, int x, int y, int width, int height);
void	Bad_Health(CDib *buf, CDib2 *buf2, int condition);

// Aj̏Ԃ
// anim_speed	: [IN]		Aj̑x
// TickCount	: [IN][OUT]	ȑO̎
// ߂l		: true  , false  ܂
bool GetTiming(UINT anim_speed, long *TickCount)
{
	if(!TickCount){
		return false;
	}
	
	bool flag_go;
	
	if(GetTickCount() - *TickCount >= anim_speed){
		flag_go = true;
		*TickCount = GetTickCount();
	}
	else{
		flag_go = false;
	}
	
	return flag_go;
}// GetTiming

// DIB IuWFNgɉ摜ݒ
// idxAlpha		: [IN]	`tOi0:s, 1:Z, 2:x񂠂j
// bColorKey	: [IN]	J[L[tOifalse:ȂAtrue:j
// filename		: [IN]	摜t@C
// colorkey		: [IN]	J[L[mDIB_RGB_MAKE(r, g, b)n
void Set_Bm(CDib **bm, CDib2 **bm2, int idxAlpha, BOOL bColorKey, char *filename, WORD colorkey)
{
	SAFE_DELETE(*bm);
	SAFE_DELETE(*bm2);
	if(idxAlpha < 2){
		if(!bColorKey){
			*bm  = new CDib(filename);
		}
		else{
			*bm  = new CDib(filename, colorkey);
		}
	}
	else{
		*bm2  = new CDib2(filename);
	}
}// Set_Bm

// DIB IuWFNgɉ摜ݒi͈͎w̃I[o[[hj
// idxAlpha		: [IN]	`tOi0:s, 1:Z, 2:x񂠂j
// bColorKey	: [IN]	J[L[tOifalse:ȂAtrue:j
// filename		: [IN]	摜t@C
// x, y			: [IN]	`W
// width		: [IN]	摜̕
// height		: [IN]	摜̍
// colorkey		: [IN]	J[L[mDIB_RGB_MAKE(r, g, b)n
void Set_Bm(CDib **bm, CDib2 **bm2, int idxAlpha, BOOL bColorKey, char *filename,
			int x, int y, int width, int height, WORD colorkey)
{
	SAFE_DELETE(*bm);
	SAFE_DELETE(*bm2);
	if(idxAlpha < 2){
		if(!bColorKey){
			*bm = DIB_LoadFile2(width, height, filename, x, y);
		}
		else{
			*bm  = DIB_LoadFile2(width, height, filename, x, y, colorkey);
		}
	}
	else{
		*bm2  = new CDib2(filename, x, y, width, height);
	}
}// Set_Bm

// 摜̕`
// idxAlpha		: [IN]	`tOi0:s, 1:Z, 2:x񂠂j
// dst_x, dst_y	: [IN]	`W
// src_x, src_y	: [IN]	`挳W
// width		: [IN]	摜̕
// height		: [IN]	摜̍
// alpha		: [IN]	xi0 ` 32j
void Draw_Dib(CDib *buf, CDib *bm, CDib2 *bm2, int idxAlpha, int dst_x, int dst_y,
				int src_x, int src_y, int width, int height, int alpha)
{
	switch (idxAlpha)
	{
	case 0:	// s
		if(bm){
			if(alpha < 32)
				DIB_DrawRateAlpha(buf, dst_x, dst_y, bm, src_x, src_y,
									src_x + width, src_y + height, alpha);
			else
				DIB_DrawRect(buf, dst_x, dst_y, bm, src_x, src_y,
									src_x + width, src_y + height);
		}
		break;
	case 1:	// Z
		if(bm){
			DIB_DrawAddAlpha(buf, dst_x, dst_y, bm, src_x, src_y, src_x + width, src_y + height, alpha);
		}
		break;
	case 2:	// x񂠂
		DIB2_DrawAlpha(buf, dst_x, dst_y, bm2, src_x, src_y, width, height, alpha * 8);
		break;
	}
}// Draw_Dib

// 摜̕`i`挳W [0, 0] ̃I[o[[hj
// idxAlpha	: [IN]	`tOi0:s, 1:Z, 2:x񂠂j
// x, y		: [IN]	`W
// width	: [IN]	摜̕
// height	: [IN]	摜̍
// alpha	: [IN]	xi0 ` 32j
void Draw_Dib(CDib *buf, CDib *bm, CDib2 *bm2, int idxAlpha,
				int x, int y, int width, int height, int alpha)
{
	Draw_Dib(buf, bm, bm2, idxAlpha, x, y, 0, 0, width, height, alpha);
}// Draw_Dib

// 摜N̏Ԃɂ
// x, y			: [IN]	Rs[W
// width, height: [IN]	Rs[`̕ƍ
void Good_Health(CDib *buf, CDib2 *buf2, char *file_name, int x, int y, int width, int height)
{
	if(buf){
		DIB_ReLoadFile(buf, 0, 0, file_name, x, y, x + width, y + height);
	}
	if(buf2){
		DIB2_ReLoadFile(buf2, 0, 0, file_name, x, y, width, height);
	}
}// Good_Health

// 摜Xe[^Xُɂ
// condition	: [IN]	Nԁi16i 0:A1:ŁA2:A4:ΉA8:Cj
void Bad_Health(CDib *buf, CDib2 *buf2, int condition)
{
	if(buf){
		if(condition & 0x04){		// Ή
			DIB_AlterMonotone(buf, 0, 0, 0, 0);
		}
		else if(condition & 0x08){	// C
			DIB_AlterHue(buf, 0, 0, 0, 0, 96);
		}
		else if(condition & 0x01){	// 
			DIB_AlterHue(buf, 0, 0, 0, 0, 144);
		}
	}
	if(buf2){
		if(condition & 0x04){		// Ή
			DIB2_AlterMonotone(buf2, 0, 0, 0, 0);
		}
		else if(condition & 0x08){	// C
			DIB2_AlterHue(buf2, 0, 0, 0, 0, 96);
		}
		else if(condition & 0x01){	// 
			DIB2_AlterHue(buf2, 0, 0, 0, 0, 144);
		}
	}
}// Bad_Health

#endif
