///////////////////////////////////////////////////////////////////////////
//	SCREEN MODE CHANGE FUNCTION 		
//								    Programmed by m.minami				
///////////////////////////////////////////////////////////////////////////
#include "win_main.h"
#include "scr_change.h"

////////////////////////////////////////////////////////////////////////////
//							  	  }N
////////////////////////////////////////////////////////////////////////////
#define MAX_DISPLAYMODE		1000
#define MAX_NAMELENGTH		500
#define MAX_WINDOWNUM		100

////////////////////////////////////////////////////////////////////////////
//							  O[oϐ
////////////////////////////////////////////////////////////////////////////
// EChEԂێ\
typedef struct{
	HWND			hwnd;
	WINDOWPLACEMENT place;
} WINDOW_STAT;

static WINDOW_STAT	WindowStat[MAX_WINDOWNUM];	// EChEԕۑz
static int			WindowMax;					// ʏ̃EChE

////////////////////////////////////////////////////////////////////////////
//						@	 ֐vg^Cv							  
////////////////////////////////////////////////////////////////////////////
static bool WinPosSave(void);
static bool WinPosRestore(void);
static BOOL CALLBACK EnumWinPosSave(HWND hWnd, LPARAM lParam);
static BOOL CALLBACK EnumWinPosRestore(HWND hwnd, LPARAM lParam);

////////////////////////////////////////////////////////////////////////////
//	֐	F	ScrModeChange	
//	TvF	XN[[hؑւs
//		F	hwnd	EChEnh
//			F	mode	FULLSCREEN_MODE		tXN[֐؂ւ
//			F			WINDOW_MODE			EChE[h֐؂ւ		
//	o	F	true	؂ւ
//			F	false	؂ւs
////////////////////////////////////////////////////////////////////////////
bool ScrModeChange(HWND hwnd, int mode)
{
	DEVMODE DeviceMode = {0};
	
	DeviceMode.dmSize	= sizeof(DeviceMode);
	DeviceMode.dmFields	= DM_PELSWIDTH | DM_PELSHEIGHT;

	switch (mode) {
		//=================================================================
		//                     tXN[֕ύX	
		//=================================================================
		case FULLSCREEN_MODE:
		{	// EChEʒuۑ
			WinPosSave();
			
			// ݂̐F擾
			HDC hDC = GetDC( hwnd );
			int ScreenColors = GetDeviceCaps( hDC, BITSPIXEL );
			ReleaseDC( hwnd, hDC );

			// tXN[[hT
			for( int i = 0; i < MAX_DISPLAYMODE; i++ ){
				EnumDisplaySettings( NULL, i, &DeviceMode );
				if( DeviceMode.dmPelsWidth	== SCREEN_WIDTH &&
					DeviceMode.dmPelsHeight	== SCREEN_HEIGHT &&
					DeviceMode.dmBitsPerPel	== (DWORD)ScreenColors ) break;
			}

			// tXN[ɕύX
			if( ChangeDisplaySettings( &DeviceMode, 0 ) != DISP_CHANGE_SUCCESSFUL ) return FALSE;

			// J[\nee
			ShowCursor(FALSE);
			
			//  EBhEX^CĐݒ
			DWORD dwStyle = GetWindowStyle(hwnd);
			dwStyle &= ~(WS_OVERLAPPED | WS_CAPTION);
			SetWindowLong(hwnd, GWL_STYLE, dwStyle);						
			SetWindowPos(hwnd, 0, 0, 0, 0, 0, SWP_DRAWFRAME|SWP_FRAMECHANGED|SWP_NOSIZE);
			break;
		}
		//=================================================================
		//                    EChE[h֕A
		//=================================================================
		case WINDOW_MODE:
		{	
			// J[\nm
			ShowCursor(TRUE);
			
			// EChEʒuA
			WinPosRestore();
			
			//  EBhEX^CĐݒ
			DWORD dwStyle = GetWindowStyle(hwnd);
			dwStyle |= WS_OVERLAPPED | WS_CAPTION;
			SetWindowLong(hwnd, GWL_STYLE, dwStyle);
			SetWindowPos(hwnd, 0, 0, 0, 0, 0, SWP_DRAWFRAME|SWP_FRAMECHANGED|SWP_NOSIZE);
			
			// XN[[hύX
			ChangeDisplaySettings( NULL, 0 );
			
			// EChEʒuA
			WinPosRestore();
			break;
		}
	}

	return true;
}

////////////////////////////////////////////////////////////////////////////
//	֐	F	GameInit	
//	TvF	EChEʒuۑ
//		F	WinPosSave
//	o	F	
////////////////////////////////////////////////////////////////////////////
bool WinPosSave(void)
{
	WindowMax = 0;
	if (EnumWindows( EnumWinPosSave, NULL ) == 0)	return false;

	return true;
}

////////////////////////////////////////////////////////////////////////////
//	֐	F	WinPosRestore	
//	TvF	EChEʒuA
//		F	
//	o	F	
////////////////////////////////////////////////////////////////////////////
bool WinPosRestore(void)
{
	if (EnumWindows( EnumWinPosRestore, NULL ) == 0)	return false;

	return true;
}

////////////////////////////////////////////////////////////////////////////
//	֐	F	EnumWinPosSave
//	TvF	EChEʒuۑ̃R[obN֐
//		F	
//	o	F	
////////////////////////////////////////////////////////////////////////////
BOOL CALLBACK EnumWinPosSave( HWND hwnd, LPARAM lParam )
{
	char szWindowName[MAX_NAMELENGTH];
	char szClassName[MAX_NAMELENGTH];

	// EChEƃNX̎擾
	GetWindowText( hwnd, szWindowName, MAX_NAMELENGTH );
	GetClassName(  hwnd, szClassName,  MAX_NAMELENGTH );

	// ĂEChEZNg
	if( IsWindowVisible( hwnd ) &&
		GetWindow( hwnd, GW_OWNER ) == NULL &&
		lstrlen( szWindowName ) > 0 &&
		lstrcmp( szClassName, "Progman" ) != 0 ){

		// EChEʒuۑ
		if( WindowMax < MAX_WINDOWNUM ){
			WindowStat[WindowMax].place.length = sizeof( WINDOWPLACEMENT );
			GetWindowPlacement( hwnd, &WindowStat[WindowMax].place );
			WindowStat[WindowMax].hwnd = hwnd;

			WindowMax++;
		}
	}


	return TRUE;
}

////////////////////////////////////////////////////////////////////////////
//	֐	F	EnumWinPosRestore	
//	TvF	EChEʒuÃR[obN֐
//		F	
//	o	F	
////////////////////////////////////////////////////////////////////////////
BOOL CALLBACK EnumWinPosRestore( HWND hwnd, LPARAM lParam )
{
	char szWindowName[MAX_NAMELENGTH];

	// EChE̎擾
	GetWindowText( hwnd, szWindowName, MAX_NAMELENGTH );

	// ۑĂEChE
	int i;
	for( i = 0; i < WindowMax; i++ ){
		if( WindowStat[i].hwnd == hwnd ) break;
	}

	// 猳̏ꏊɖ߂
	if( i != WindowMax ){
		SetWindowPlacement( hwnd, &WindowStat[i].place );
	}

	return TRUE;
}
